/*
 * (C) Copyright 2007, 2011 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * Version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

.align 5
.global flush_dcache_range
.global invalidate_dcache_range

flush_dcache_range:
	bic	r0, r0, #32 - 1
1:
	mcr	p15, 0, r0, c7, c10, 1		/* clean D$ */
	add	r0, r0, #32
	cmp	r0, r1
	blo	1b
	mov	r0, #0
	mcr	p15, 0, r0, c7, c10, 4		/* Data Synchronization Barrier */
	mov	pc, lr

invalidate_dcache_range:
	tst 	r0, #32 - 1
	bic	r0, r0, #32 - 1
	mcrne	p15, 0, r0, c7, c10, 1		/* clean D$ */
	tst	r1, #32 - 1
	bic	r1, r1, #32 - 1
	mcrne	p15, 0, r1, c7, c14, 1		/* clean and invalidate D$ */
1:
	mcr	p15, 0, r0, c7, c6, 1		/* invalidate D$ */
	add	r0, r0, #32
	cmp	r0, r1
	blo	1b
	mov	r0, #0
	mcr	p15, 0, r0, c7, c10, 4		/* Data Synchronization Barrier */
	mov	pc, lr


