/*
 * (C) Copyright 2007, 2011 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * Version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef DTMR_SP804_H
#define DTMR_SP804_H

/* register */
#define SP804_TIMER1_LOAD_REG			0x000
#define SP804_TIMER1_VAL_REG			0x004
#define SP804_TIMER1_CTRL_REG			0x008
#define SP804_TIMER1_INT_CLR_REG		0x00C
#define SP804_TIMER1_RIS_REG			0x010
#define SP804_TIMER1_MIS_REG			0x014
#define SP804_TIMER1_BGLOAD_REG			0x018

#define SP804_TIMER2_LOAD_REG			0x020
#define SP804_TIMER2_VAL_REG			0x024
#define SP804_TIMER2_CTRL_REG			0x028
#define SP804_TIMER2_INT_CLR_REG		0x02C
#define SP804_TIMER2_RIS_REG			0x030
#define SP804_TIMER2_MIS_REG			0x034
#define SP804_TIMER2_BGLOAD_REG			0x038

#define SP804_TIMER_ITCR_REG			0xF00
#define SP804_TIMER_ITOP_REG			0xF04
#define SP804_TIMER_PERI_ID0_REG		0xFE0
#define SP804_TIMER_PERI_ID1_REG		0xFE4
#define SP804_TIMER_PERI_ID2_REG		0xFE8
#define SP804_TIMER_PERI_ID3_REG		0xFEC
#define SP804_TIMER_PCEL_ID0_REG		0xFF0
#define SP804_TIMER_PCEL_ID1_REG		0xFF4
#define SP804_TIMER_PCEL_ID2_REG		0xFF8
#define SP804_TIMER_PCEL_ID3_REG		0xFFC


/* TimerXControl */
#define SP804_CTRL_TIMER_ENABLE			0x00000080
#define SP804_CTRL_TIMER_MODE_PERIODIC		0x00000040
#define SP804_CTRL_TIMER_MODE_FREERUN		0x00000000
#define SP804_CTRL_INT_ENABLE			0x00000020
#define SP804_CTRL_INT_DISABLE			0x00000000
#define SP804_CTRL_TIMER_PRE_MASK		0x0000000C
#define SP804_CTRL_TIMER_PRE_DIV_32		0x00000008
#define SP804_CTRL_TIMER_PRE_DIV_16		0x00000004
#define SP804_CTRL_TIMER_PRE_DIV_1		0x00000000
#define SP804_CTRL_TIMER_SIZE_32BIT		0x00000002
#define SP804_CTRL_TIMER_SIZE_16BIT		0x00000000
#define SP804_CTRL_ONE_SHOT			0x00000001
#define SP804_CTRL_WRAPPING			0x00000000

/* MAX VALUE */
#define SP804_VAL_32BIT_MAX			0xFFFFFFFF
#define SP804_VAL_16BIT_MAX			0xFFFF

#endif /* DTMR_SP804_H */
