/*
 *  armboot - Startup Code for ARM1176 CPU-core
 *
 *  Copyright (c) 2007, 2011 Sony Corporation.
 *
 *  ----- Adapted for versatile from ARM926EJS CPU-core code ------
 *
 *  Copyright (c) 2003  Texas Instruments
 *
 *  ----- Adapted for OMAP1610 OMAP730 from ARM925t code ------
 *
 *  Copyright (c) 2001	Marius Grger <mag@sysgo.de>
 *  Copyright (c) 2002	Alex ZEke <azu@sysgo.de>
 *  Copyright (c) 2002	Gary Jennejohn <gj@denx.de>
 *  Copyright (c) 2003	Richard Woodruff <r-woodruff2@ti.com>
 *  Copyright (c) 2003	Kshitij <kshitij@ti.com>
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

/* used watchdog timer - prime cell sp805 */
#include "wdt_sp805.h"

	.align	5
.globl reset_cpu
reset_cpu:
	/* unlock */
	ldr	r0, =SP805_WDOG_LOCK_REG
	ldr	r1, =SP805_WDOG_UNLOCK_VAL
	str	r1, [r0]

	/* wdt stop */
	ldr	r0, =SP805_WDOG_CONT_REG
	ldr	r1, =SP805_WDOG_CONT_INIT
	str	r1, [r0]

	/* counter val set */
	ldr	r0, =SP805_WDOG_LOAD_REG
	ldr	r1, =SP805_WDOG_LOAD_COUNT
	str	r1, [r0]

	/* wdt start */
	ldr	r0, =SP805_WDOG_CONT_REG
	ldr	r2, =SP805_WDOG_CONT_INTEN
	ldr	r3, =SP805_WDOG_CONT_RESEN
	orr	r1, r2, r3
	str	r1, [r0]

_loop_forever:
	b	_loop_forever

