/*
 * (C) Copyright 2007, 2011 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * Version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <asm/io.h>
#include <asm/arch/xarina_wdt.h>
#include "wdt_sp805.h"

int wdt_start(unsigned long sec)
{
    unsigned long val = (sec ? (SP805_WDOG_LOAD_COUNT * 10 * sec) : SP805_WDOG_LOAD_COUNT);

    writel(SP805_WDOG_UNLOCK_VAL, SP805_WDOG_LOCK_REG);

    writel(SP805_WDOG_CONT_INIT, SP805_WDOG_CONT_REG);

    writel(val, SP805_WDOG_LOAD_REG);

    writel((SP805_WDOG_CONT_INTEN | SP805_WDOG_CONT_RESEN), SP805_WDOG_CONT_REG);

    return 0;
}
