/*
 * (C) Copyright 2007, 2011, 2013 Sony Corporation.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef HW_REG_H
#define HW_REG_H
#include <config.h>

#define EEPROM_DDR0_ADDR    0x00a0
#define EEPROM_DDR1_ADDR    0x00a2

/************************************/
/* DDRTOP                           */
/************************************/
/*==========*/
/* address  */
/*==========*/
#define DDRTOP0_BASE	0x30014000
#define DDRTOP1_BASE	0x30015000

/*-------------------------*/
/* DDRTOP  setting data    */
/*-------------------------*/
#define DDRTOP_PIR_0_DATA	0x80000000
#define DDRTOP_PGCR0_DATA	0xA8003E00
#define DDRTOP_PGCR1_0_DATA	0x0300C403
#define DDRTOP_PGCR1_1_DATA	0x0700C403
#define DDRTOP_PLLCR_DATA	0x0005C000
#define DDRTOP_PTR0_DATA	0x0641F410
#define DDRTOP_PTR1_DATA	0x13880096
#define DDRTOP_PTR2_DATA	0x00083DEF
#define DDRTOP_PTR3_DATA	0x04430D40
#define DDRTOP_PTR4_DATA	0x08013880
#define DDRTOP_DXCCR_DATA	0x00001224
#define DDRTOP_DSGCR_DATA	0xF0040002
#define DDRTOP_DCR_DATA		0x0000040B
#define DDRTOP_DTP0_DATA	0x550F6644
#define DDRTOP_DTP1_DATA	0x1A820282
#define DDRTOP_DTP2_DATA	0x70022A00
#define DDRTOP_MR0_DATA		0x00000420
#define DDRTOP_MR2_DATA		0x00000000
#define DDRTOP_MR3_DATA		0x00000000
#define DDRTOP_DTCR_DATA	0x01001A47
#define DDRTOP_PIR_1_DATA	0x00010FF3
#define DDRTOP_PIR_2_DATA	0x0001FFF3
#define DDRTOP_PIR_3_DATA	0x0001F981
#define DDRTOP_ZQ0CR1_DATA	0x0000001B
#define DDRTOP_ZQ0CR1_DATA_MOD_1	0x00000019
#define DDRTOP_ZQ0CR1_DATA_MOD_2	0x0000001B
#define DDRTOP_DX0BDLR0_DATA	0x08208208
#define DDRTOP_DX0BDLR1_DATA	0x08208208
#define DDRTOP_DX0BDLR2_DATA	0x00000208
#define DDRTOP_DX0BDLR3_DATA	0x00000000
#define DDRTOP_DX0BDLR4_DATA	0x00000000
#define DDRTOP_DX1BDLR0_DATA	0x08208208
#define DDRTOP_DX1BDLR1_DATA	0x08208208
#define DDRTOP_DX1BDLR2_DATA	0x00000208
#define DDRTOP_DX1BDLR3_DATA	0x00000000
#define DDRTOP_DX1BDLR4_DATA	0x00000000


#if defined(CONFIG_XARINA_DDR_ODT_OFF)
#define DDRTOP_MR1_DATA		0x00000000
#define DDRTOP_DX0GCR_DATA	0x7C000881
#define DDRTOP_DX1GCR_DATA	0x7C000881

#else 
#define DDRTOP_MR1_DATA		0x00000040
#define DDRTOP_DX0GCR_DATA	0x7C000E81
#define DDRTOP_DX1GCR_DATA	0x7C000E81
#endif

/************************************/
/* Memory Controller databahn       */
/************************************/

/*==========*/
/* address  */
/*==========*/
#define DDR0_DB_BASE	0x38011000
#define DDR1_DB_BASE	0x51044000

/*-------------------------*/
/* DDRCON0 registers       */
/*-------------------------*/
#define DDR0_DB_CTL00_REG		0x000
#define DDR0_DB_CTL01_REG		0x004
#define DDR0_DB_CTL02_REG		0x008
#define DDR0_DB_CTL03_REG		0x00c
#define DDR0_DB_CTL04_REG		0x010
#define DDR0_DB_CTL05_REG		0x014
#define DDR0_DB_CTL06_REG		0x018
#define DDR0_DB_CTL07_REG		0x01c
#define DDR0_DB_CTL08_REG		0x020
#define DDR0_DB_CTL09_REG		0x024
#define DDR0_DB_CTL10_REG		0x028
#define DDR0_DB_CTL11_REG		0x02c
#define DDR0_DB_CTL12_REG		0x030
#define DDR0_DB_CTL13_REG		0x034
#define DDR0_DB_CTL14_REG		0x038
#define DDR0_DB_CTL15_REG		0x03c
#define DDR0_DB_CTL16_REG		0x040
#define DDR0_DB_CTL17_REG		0x044
#define DDR0_DB_CTL18_REG		0x048
#define DDR0_DB_CTL19_REG		0x04c
#define DDR0_DB_CTL20_REG		0x050
#define DDR0_DB_CTL21_REG		0x054
#define DDR0_DB_CTL22_REG		0x058
#define DDR0_DB_CTL23_REG		0x05c
#define DDR0_DB_CTL24_REG		0x060
#define DDR0_DB_CTL25_REG		0x064
#define DDR0_DB_CTL26_REG		0x068
#define DDR0_DB_CTL27_REG		0x06c
#define DDR0_DB_CTL28_REG		0x070
#define DDR0_DB_CTL29_REG		0x074
#define DDR0_DB_CTL30_REG		0x078
#define DDR0_DB_CTL31_REG		0x07c
#define DDR0_DB_CTL32_REG		0x080
#define DDR0_DB_CTL33_REG		0x084
#define DDR0_DB_CTL34_REG		0x088
#define DDR0_DB_CTL35_REG		0x08c
#define DDR0_DB_CTL36_REG		0x090
#define DDR0_DB_CTL37_REG		0x094
#define DDR0_DB_CTL38_REG		0x098
#define DDR0_DB_CTL39_REG		0x09c
#define DDR0_DB_CTL40_REG		0x0a0


/* for xarina */
#define DDR_CTL_00_REG	0x000
#define DDR_CTL_01_REG	0x004
#define DDR_CTL_02_REG	0x008
#define DDR_CTL_03_REG	0x00C
#define DDR_CTL_04_REG	0x010
#define DDR_CTL_05_REG	0x014
#define DDR_CTL_06_REG	0x018
#define DDR_CTL_07_REG	0x01C
#define DDR_CTL_08_REG	0x020
#define DDR_CTL_09_REG	0x024
#define DDR_CTL_10_REG	0x028
#define DDR_CTL_11_REG	0x02C
#define DDR_CTL_12_REG	0x030
#define DDR_CTL_13_REG	0x034
#define DDR_CTL_14_REG	0x038
#define DDR_CTL_15_REG	0x03C
#define DDR_CTL_16_REG	0x040
#define DDR_CTL_17_REG	0x044
#define DDR_CTL_18_REG	0x048
#define DDR_CTL_19_REG	0x04C
#define DDR_CTL_20_REG	0x050
#define DDR_CTL_21_REG	0x054
#define DDR_CTL_22_REG	0x058
#define DDR_CTL_23_REG	0x05C
#define DDR_CTL_24_REG	0x060
#define DDR_CTL_25_REG	0x064
#define DDR_CTL_26_REG	0x068
#define DDR_CTL_27_REG	0x06C
#define DDR_CTL_28_REG	0x070
#define DDR_CTL_29_REG	0x074
#define DDR_CTL_30_REG	0x078
#define DDR_CTL_31_REG	0x07C
#define DDR_CTL_32_REG	0x080
#define DDR_CTL_33_REG	0x084
#define DDR_CTL_34_REG	0x088
#define DDR_CTL_35_REG	0x08C
#define DDR_CTL_36_REG	0x090
#define DDR_CTL_37_REG	0x094
#define DDR_CTL_38_REG	0x098
#define DDR_CTL_39_REG	0x09C
#define DDR_CTL_40_REG	0x0A0
#define DDR_CTL_41_REG	0x0A4
#define DDR_CTL_42_REG	0x0A8
#define DDR_CTL_43_REG	0x0AC
#define DDR_CTL_44_REG	0x0B0
#define DDR_CTL_45_REG	0x0B4
#define DDR_CTL_46_REG	0x0B8
#define DDR_CTL_47_REG	0x0BC
#define DDR_CTL_48_REG	0x0C0
#define DDR_CTL_49_REG	0x0C4
#define DDR_CTL_50_REG	0x0C8
#define DDR_CTL_51_REG	0x0CC
#define DDR_CTL_52_REG	0x0D0
#define DDR_CTL_53_REG	0x0D4
#define DDR_CTL_54_REG	0x0D8
#define DDR_CTL_55_REG	0x0DC
#define DDR_CTL_56_REG	0x0E0
#define DDR_CTL_57_REG	0x0E4
#define DDR_CTL_58_REG	0x0E8
#define DDR_CTL_59_REG	0x0EC
#define DDR_CTL_60_REG	0x0F0
#define DDR_CTL_61_REG	0x0F4
#define DDR_CTL_62_REG	0x0F8
#define DDR_CTL_63_REG	0x0FC
#define DDR_CTL_64_REG	0x100
#define DDR_CTL_65_REG	0x104
#define DDR_CTL_66_REG	0x108
#define DDR_CTL_67_REG	0x10C
#define DDR_CTL_68_REG	0x110
#define DDR_CTL_69_REG	0x114
#define DDR_CTL_70_REG	0x118
#define DDR_CTL_71_REG	0x11C
#define DDR_CTL_72_REG	0x120
#define DDR_CTL_73_REG	0x124
#define DDR_CTL_74_REG	0x128
#define DDR_CTL_75_REG	0x12C
#define DDR_CTL_76_REG	0x130
#define DDR_CTL_77_REG	0x134
#define DDR_CTL_78_REG	0x138
#define DDR_CTL_79_REG	0x13C
#define DDR_CTL_80_REG	0x140



/*-------------------------*/
/* DDRCON1 registers       */
/*-------------------------*/
#define DDR1_DB_CTL00_REG		0x000
#define DDR1_DB_CTL01_REG		0x004
#define DDR1_DB_CTL02_REG		0x008
#define DDR1_DB_CTL03_REG		0x00c
#define DDR1_DB_CTL04_REG		0x010
#define DDR1_DB_CTL05_REG		0x014
#define DDR1_DB_CTL06_REG		0x018
#define DDR1_DB_CTL07_REG		0x01c
#define DDR1_DB_CTL08_REG		0x020
#define DDR1_DB_CTL09_REG		0x024
#define DDR1_DB_CTL10_REG		0x028
#define DDR1_DB_CTL11_REG		0x02c
#define DDR1_DB_CTL12_REG		0x030
#define DDR1_DB_CTL13_REG		0x034
#define DDR1_DB_CTL14_REG		0x038
#define DDR1_DB_CTL15_REG		0x03c
#define DDR1_DB_CTL16_REG		0x040
#define DDR1_DB_CTL17_REG		0x044
#define DDR1_DB_CTL18_REG		0x048
#define DDR1_DB_CTL19_REG		0x04c
#define DDR1_DB_CTL20_REG		0x050
#define DDR1_DB_CTL21_REG		0x054
#define DDR1_DB_CTL22_REG		0x058
#define DDR1_DB_CTL23_REG		0x05c
#define DDR1_DB_CTL24_REG		0x060
#define DDR1_DB_CTL25_REG		0x064
#define DDR1_DB_CTL26_REG		0x068
#define DDR1_DB_CTL27_REG		0x06c
#define DDR1_DB_CTL28_REG		0x070
#define DDR1_DB_CTL29_REG		0x074
#define DDR1_DB_CTL30_REG		0x078
#define DDR1_DB_CTL31_REG		0x07c
#define DDR1_DB_CTL32_REG		0x080
#define DDR1_DB_CTL33_REG		0x084
#define DDR1_DB_CTL34_REG		0x088
#define DDR1_DB_CTL35_REG		0x08c
#define DDR1_DB_CTL36_REG		0x090
#define DDR1_DB_CTL37_REG		0x094
#define DDR1_DB_CTL38_REG		0x098
#define DDR1_DB_CTL39_REG		0x09c
#define DDR1_DB_CTL40_REG		0x0a0
#define DDR1_DB_CTL41_REG		0x0a4
#define DDR1_DB_CTL42_REG		0x0a8
#define DDR1_DB_CTL43_REG		0x0ac
#define DDR1_DB_CTL44_REG		0x0b0
#define DDR1_DB_CTL45_REG		0x0b4
#define DDR1_DB_CTL46_REG		0x0b8


/*==========*/
/* value    */
/*==========*/
#define DDR_START		0x00000001

#define DDR_INTERRUPT_MASK	0x00ff0000
#define DDR_INTERRUPT_CLEAR	0x000000ff
#define DDR_INT_STATUS		0x10000000

/*-------------------------*/
/* DDRCON0 initial setting */
/*-------------------------*/
#if 1
/* colosseo */
#define DDR0_CTL00_DATA 0x00000101  /* 00000000 arefresh 00000000 ap 00000001 addr_cmp_en 00000001 active_aging */
#define DDR0_CTL01_DATA 0x01010100  /* 00000001 bank_split_en 00000001 axi0_w_priority 00000001 axi0_r_priority 00000000 auto_refresh_mode */
#define DDR0_CTL02_DATA 0x01010001  /* 00000001 drive_dq_dqs 00000001 dll_bypass_mode 00000000 dlllockreg 00000001 concurrentap */
#define DDR0_CTL03_DATA 0x00000101  /* 00000000 intrptapburst 00000000 fast_write 00000001 en_lowpower_mode 00000001 enable_quick_srefresh */
#define DDR0_CTL04_DATA 0x01000000  /* 00000001 placement_en 00000000 no_cmd_init 00000000 intrptwritea 00000000 intrptreada */
#define DDR0_CTL05_DATA 0x01000100  /* 00000001 rd2rd_turn 00000000 pwrup_srefresh_exit 00000001 priority_en 00000000 power_down */
#define DDR0_CTL06_DATA 0x00010000  /* 00000000 srefresh 00000001 rw_same_en 00000000 reg_dimm_enable 00000000 reduc */
#define DDR0_CTL07_DATA 0x01010100  /* 00000001 tref_enable 00000001 tras_lockout 00000001 swap_en 00000000 start */
#define DDR0_CTL08_DATA 0x03030001  /* 00000011 command_age_count 00000011 age_count 00000000 write_modereg 00000001 writeinterp */
#define DDR0_CTL09_DATA 0x00000003  /* 00000000 q_fullness 00000000 max_cs_reg 00000000 lowpower_refresh_enable 00000011 cs_map */
#define DDR0_CTL10_DATA 0x03020102  /* 00000011 caslat 00000010 bstlen 00000001 addr_pins 00000010 temrs */

/* #define DDR0_CTL11_DATA  0x00000400 */   /* 00000000 port_data_error_type 00000000 out_of_range_type 00000100 column_size 00000000 cke_delay */
#define DDR0_CTL11_DATA 0x00000300  /* 00000000 port_data_error_type 00000000 out_of_range_type 00000011 column_size 00000000 cke_delay */

#define DDR0_CTL12_DATA 0x02020202  /* 00000010 twtr 00000010 twr_int 00000010 trrd 00000010 tcke */
#define DDR0_CTL13_DATA 0x0206060a  /* 00000010 initaref 00000110 caslat_lin_gate 00000110 caslat_lin 00001010 aprebit */
#define DDR0_CTL14_DATA 0x00000000  /* 00000000 port_cmd_error_id 00000000 out_of_range_source_id 00000000 max_row_reg 00000000 max_col_reg */
#define DDR0_CTL15_DATA 0x03050000  /* 00000011 trp 00000101 tdal 00000000 port_data_error_id 00000000 port_cmd_error_type */
#define DDR0_CTL16_DATA 0x0a020000  /* 00001010 trc 00000010 tmrd 00000000 lowpower_control 00000000 lowpower_auto_enable */
#define DDR0_CTL17_DATA 0x1f1f1f00  /* 00011111 dll_dqs_delay2 00011111 dll_dqs_delay1 00011111 dll_dqs_delay0 00000000 int_ack */
#define DDR0_CTL18_DATA 0x0000001f  /* 00000000000000000000000000011111 dll_dqs_delay3 */
#define DDR0_CTL19_DATA 0x00000000  /* 00000000000000000000000000000000 */
#define DDR0_CTL20_DATA 0x00000000  /* 00000000000000000000000000000000 */
#define DDR0_CTL21_DATA 0x00000000  /* 00000000000000000000000000000000 */
#define DDR0_CTL22_DATA 0x0000007f  /* 00000000 int_status 00000000 int_mask 0000000001111111 dqs_out_shift */
#define DDR0_CTL23_DATA 0x0600001f  /* 00000110 tras_min 00000000 out_of_range_length 0000000000011111 wr_dqs_shift */
#define DDR0_CTL24_DATA 0x03fe0a03  /* 0000001111111110 tref 00001010 trfc 00000011 trcd_int */
#define DDR0_CTL25_DATA 0x00000000  /* 0000000000 emrs2_data0 0000000000 emrs1_data */
#define DDR0_CTL26_DATA 0x001c0000  /* 0000000000011100 axi0_en_size_lt_width_instr 0000000000 emrs2_data1 */
#define DDR0_CTL27_DATA 0x00000000  /* 0000000000000000 lowpower_internal_cnt 0000000000000000 lowpower_external_cnt */
#define DDR0_CTL28_DATA 0x00000000  /* 0000000000000000 lowpower_refresh_hold 0000000000000000 lowpower_power_down_cnt */
#define DDR0_CTL29_DATA 0x00000000  /* 0000000000000000 tdll 0000000000000000 lowpower_self_refresh_cnt */
#define DDR0_CTL30_DATA 0x24090004  /* 0010010000001001 tras_max 0000000000000100 tpdex */
#define DDR0_CTL31_DATA 0x00100010  /* 0000000000010000 txsr 0000000000010000 txsnr */
#define DDR0_CTL32_DATA 0x00000000  /* 00000000000000000000000000000000 version */
#define DDR0_CTL33_DATA 0x0000001b  /* 00000000000000000000000000011011 tinit */
#define DDR0_CTL34_DATA 0x00000000  /* 00000000000000000000000000000000 out_of_range_addr */
#define DDR0_CTL35_DATA 0x00000000  /* 00000000000000000000000000000000 port_cmd_error_addr */
#define DDR0_CTL36_DATA 0x00002a01  /* 000000000000000000101010 dll_dqs_delay_bypass0 00000001 wrlat */
#define DDR0_CTL37_DATA 0x002a002a  /* 0000000000101010 dll_dqs_delay_bypass2 0000000000101010 dll_dqs_delay_bypass1 */
#define DDR0_CTL38_DATA 0x0022002a  /* 0000000000100010 dll_increment 0000000000101010 dll_dqs_delay_bypass3 */
#define DDR0_CTL39_DATA 0x00810000  /* 0000000010000001 dll_start_point 0000000000 dll_lock */
#define DDR0_CTL40_DATA 0x002a00aa  /* 0000000000101010 wr_dqs_shift_bypass 0000000010101010 dqs_out_shift_bypass */
#else
/* EVB hynix */
#define DDR0_CTL00_DATA 0x00000101 //0000000_0 arefresh 0000000_0 ap 0000000_1 addr_cmp_en 0000000_1 active_aging 
#define DDR0_CTL01_DATA 0x01010100 //0000000_1 bank_split_en 0000000_1 axi0_w_priority 0000000_1 axi0_r_priority 0000000_0 auto_refresh_mode 
#define DDR0_CTL02_DATA 0x01000000 //0000000_1 drive_dq_dqs 0000000_0 dll_bypass_mode 0000000_0 dlllockreg 0000000_0 concurrentap 
#define DDR0_CTL03_DATA 0x01000101 //0000000_1 intrptapburst 0000000_0 fast_write 0000000_1 en_lowpower_mode 0000000_1 enable_quick_srefresh 
#define DDR0_CTL04_DATA 0x01000000 //0000000_1 placement_en 0000000_0 no_cmd_init 0000000_0 intrptwritea 0000000_0 intrptreada 
#define DDR0_CTL05_DATA 0x00000100 //0000000_0 rd2rd_turn 0000000_0 pwrup_srefresh_exit 0000000_1 priority_en 0000000_0 power_down 
#define DDR0_CTL06_DATA 0x00010000 //0000000_0 srefresh 0000000_1 rw_same_en 0000000_0 reg_dimm_enable 0000000_0 reduc 
#define DDR0_CTL07_DATA 0x01000100 //0000000_1 tref_enable 0000000_0 tras_lockout 0000000_1 swap_en 0000000_0 start 
#define DDR0_CTL08_DATA 0x03030001 //000000_11 command_age_count 000000_11 age_count 0000000_0 write_modereg 0000000_1 writeinterp 
#define DDR0_CTL09_DATA 0x00000001 //00000_000 q_fullness 000000_00 max_cs_reg 000000_00 lowpower_refresh_enable 000000_01 cs_map 
#define DDR0_CTL10_DATA 0x03020102 //00000_011 caslat 00000_010 bstlen 00000_001 addr_pins 000000_10 temrs 
#define DDR0_CTL11_DATA 0x00000300 //00000_000 port_data_error_type 000_00000 out_of_range_type 00000_011 column_size 00000_000 cke_delay 
#define DDR0_CTL12_DATA 0x02020201 //00000_010 twtr 0000_0010 twr_int 00000_010 trrd 00000_001 tcke 
#define DDR0_CTL13_DATA 0x0206060a //0000_0010 initaref 0000_0110 caslat_lin_gate 0000_0110 caslat_lin 0000_1010 aprebit 
#define DDR0_CTL14_DATA 0x00000000 //0000_0000 port_cmd_error_id 0000_0000 out_of_range_source_id 0000_0000 max_row_reg 0000_0000 max_col_reg 
#define DDR0_CTL15_DATA 0x03050000 //0000_0011 trp 0000_0101 tdal 0000_0000 port_data_error_id 0000_0000 port_cmd_error_type 
#define DDR0_CTL16_DATA 0x08020000 //000_01000 trc 000_00010 tmrd 000_00000 lowpower_control 000_00000 lowpower_auto_enable 
#define DDR0_CTL17_DATA 0x1f1f1f00 //0_0011111 dll_dqs_delay_2 0_0011111 dll_dqs_delay_1 0_0011111 dll_dqs_delay_0 00_000000 int_ack 
#define DDR0_CTL18_DATA 0x0000001f //0000000000000000000000000_0011111 dll_dqs_delay_3 
#define DDR0_CTL19_DATA 0x00000000 //00000000000000000000000000000000
#define DDR0_CTL20_DATA 0x00000000 //00000000000000000000000000000000
#define DDR0_CTL21_DATA 0x00000000 //00000000000000000000000000000000
#define DDR0_CTL22_DATA 0x0000007f //0_0000000 int_status 0_0000000 int_mask 000000000_1111111 dqs_out_shift 
#define DDR0_CTL23_DATA 0x0600001f //00000110 tras_min 0_0000000 out_of_range_length 000000000_0011111 wr_dqs_shift 
#define DDR0_CTL24_DATA 0x03fe0f03 //0000_001111111110 tref 00001111 trfc 00000011 trcd_int 
#define DDR0_CTL25_DATA 0x00000000 //00_00000000000000 emrs2_data_0 00_00000000000000 emrs1_data 
#define DDR0_CTL26_DATA 0x001c0000 //0000000000011100 axi0_en_size_lt_width_instr 00_00000000000000 emrs2_data_1 
#define DDR0_CTL27_DATA 0x00000000 //0000000000000000 lowpower_internal_cnt 0000000000000000 lowpower_external_cnt 
#define DDR0_CTL28_DATA 0x00000000 //0000000000000000 lowpower_refresh_hold 0000000000000000 lowpower_power_down_cnt 
#define DDR0_CTL29_DATA 0x00000000 //0000000000000000 tdll 0000000000000000 lowpower_self_refresh_cnt 
#define DDR0_CTL30_DATA 0x24090001 //0010010000001001 tras_max 0000000000000001 tpdex 
#define DDR0_CTL31_DATA 0x00150013 //0000000000010101 txsr 0000000000010011 txsnr 
#define DDR0_CTL32_DATA 0x00000000 //00000000000000000000000000000000 version 
#define DDR0_CTL33_DATA 0x00006712 //00000000000000000110011100010010 tinit 
#define DDR0_CTL34_DATA 0x00000000 //00000000000000000000000000000000 out_of_range_addr 
#define DDR0_CTL35_DATA 0x00000000 //00000000000000000000000000000000 port_cmd_error_addr 
#define DDR0_CTL36_DATA 0x00002a01 //000000000000000_000101010 dll_dqs_delay_bypass_0 0000000_1 wrlat 
#define DDR0_CTL37_DATA 0x002a002a //0000000_000101010 dll_dqs_delay_bypass_2 0000000_000101010 dll_dqs_delay_bypass_1 
#define DDR0_CTL38_DATA 0x000f002a //0000000_000001111 dll_increment 0000000_000101010 dll_dqs_delay_bypass_3 
#define DDR0_CTL39_DATA 0x002a0000 //0000000_000101010 dll_start_point 0000000_000000000 dll_lock 
#define DDR0_CTL40_DATA 0x002a00aa //0000000_000101010 wr_dqs_shift_bypass 0000000_010101010 dqs_out_shift_bypass 
#endif

/*-------------------------*/
/* DDRCON1 initial setting */
/*-------------------------*/
#if 1
/* colosseo */
#define DDR1_CTL00_DATA 0x00000101  /* 00000000 arefresh 00000000 ap 00000001 addr_cmp_en 00000001 active_aging */
#define DDR1_CTL01_DATA 0x01010100  /* 00000001 bank_split_en 00000001 axi0_w_priority 00000001 axi0_r_priority 00000000 auto_refresh_mode */
#define DDR1_CTL02_DATA 0x01010001  /* 00000001 drive_dq_dqs 00000001 dll_bypass_mode 00000000 dlllockreg 00000001 concurrentap */
#define DDR1_CTL03_DATA 0x00000101  /* 00000000 intrptapburst 00000000 fast_write 00000001 en_lowpower_mode 00000001 enable_quick_srefresh */
#define DDR1_CTL04_DATA 0x01000000  /* 00000001 placement_en 00000000 no_cmd_init 00000000 intrptwritea 00000000 intrptreada */
#define DDR1_CTL05_DATA 0x01000100  /* 00000001 rd2rd_turn 00000000 pwrup_srefresh_exit 00000001 priority_en 00000000 power_down */
#define DDR1_CTL06_DATA 0x00010000  /* 00000000 srefresh 00000001 rw_same_en 00000000 reg_dimm_enable 00000000 reduc */
#define DDR1_CTL07_DATA 0x01010100  /* 00000001 tref_enable 00000001 tras_lockout 00000001 swap_en 00000000 start */
#define DDR1_CTL08_DATA 0x03030001  /* 00000011 command_age_count 00000011 age_count 00000000 write_modereg 00000001 writeinterp */
#define DDR1_CTL09_DATA 0x00000003  /* 00000000 q_fullness 00000000 max_cs_reg 00000000 lowpower_refresh_enable 00000011 cs_map */
#define DDR1_CTL10_DATA 0x03020102  /* 00000011 caslat 00000010 bstlen 00000001 addr_pins 00000010 temrs */

/* #define DDR1_CTL11_DATA  0x00000400 */   /* 00000000 port_data_error_type 00000000 out_of_range_type 00000100 column_size 00000000 cke_delay */
#define DDR1_CTL11_DATA 0x00000300  /* 00000000 port_data_error_type 00000000 out_of_range_type 00000011 column_size 00000000 cke_delay */

#define DDR1_CTL12_DATA 0x02020202  /* 00000010 twtr 00000010 twr_int 00000010 trrd 00000010 tcke */
#define DDR1_CTL13_DATA 0x0206060a  /* 00000010 initaref 00000110 caslat_lin_gate 00000110 caslat_lin 00001010 aprebit */
#define DDR1_CTL14_DATA 0x00000000  /* 00000000 port_cmd_error_id 00000000 out_of_range_source_id 00000000 max_row_reg 00000000 max_col_reg */
#define DDR1_CTL15_DATA 0x03050000  /* 00000011 trp 00000101 tdal 00000000 port_data_error_id 00000000 port_cmd_error_type */
#define DDR1_CTL16_DATA 0x0a020000  /* 00001010 trc 00000010 tmrd 00000000 lowpower_control 00000000 lowpower_auto_enable */
#define DDR1_CTL17_DATA 0x1f1f1f00  /* 00011111 dll_dqs_delay2 00011111 dll_dqs_delay1 00011111 dll_dqs_delay0 00000000 int_ack */
#define DDR1_CTL18_DATA 0x1f1f1f1f  /* 00011111 dll_dqs_delay6 00011111 dll_dqs_delay5 00011111 dll_dqs_delay4 00011111 dll_dqs_delay3 */
#define DDR1_CTL19_DATA 0x0000001f  /* 00000000000000000000000000011111 dll_dqs_delay7 */
#define DDR1_CTL20_DATA 0x00000000  /* 00000000000000000000000000000000 */
#define DDR1_CTL21_DATA 0x00000000  /* 00000000000000000000000000000000 */
#define DDR1_CTL22_DATA 0x0000007f  /* 00000000 int_status 00000000 int_mask 0000000001111111 dqs_out_shift */
#define DDR1_CTL23_DATA 0x0600001f  /* 00000110 tras_min 00000000 out_of_range_length 0000000000011111 wr_dqs_shift */
#define DDR1_CTL24_DATA 0x03fe0a03  /* 0000001111111110 tref 00001010 trfc 00000011 trcd_int */
#define DDR1_CTL25_DATA 0x00000000  /* 0000000000 emrs2_data0 0000000000 emrs1_data */
#define DDR1_CTL26_DATA 0x001c0000  /* 0000000000011100 axi0_en_size_lt_width_instr 0000000000 emrs2_data1 */
#define DDR1_CTL27_DATA 0x00000000  /* 0000000000000000 lowpower_internal_cnt 0000000000000000 lowpower_external_cnt */
#define DDR1_CTL28_DATA 0x00000000  /* 0000000000000000 lowpower_refresh_hold 0000000000000000 lowpower_power_down_cnt */
#define DDR1_CTL29_DATA 0x00000000  /* 0000000000000000 tdll 0000000000000000 lowpower_self_refresh_cnt */
#define DDR1_CTL30_DATA 0x24090004  /* 0010010000001001 tras_max 0000000000000100 tpdex */
#define DDR1_CTL31_DATA 0x00100010  /* 0000000000010000 txsr 0000000000010000 txsnr */
#define DDR1_CTL32_DATA 0x00000000  /* 00000000000000000000000000000000 version */
#define DDR1_CTL33_DATA 0x0000001b  /* 00000000000000000000000000011011 tinit */
#define DDR1_CTL34_DATA 0x00000000  /* 00000000000000000000000000000000 */
#define DDR1_CTL35_DATA 0x00000000  /* 00000000000000000000000000000000 */
#define DDR1_CTL36_DATA 0x00002a01  /* 000000000000000000101010 dll_dqs_delay_bypass0 00000001 wrlat */
#define DDR1_CTL37_DATA 0x002a002a  /* 0000000000101010 dll_dqs_delay_bypass2 0000000000101010 dll_dqs_delay_bypass1 */
#define DDR1_CTL38_DATA 0x002a002a  /* 0000000000101010 dll_dqs_delay_bypass4 0000000000101010 dll_dqs_delay_bypass3 */
#define DDR1_CTL39_DATA 0x002a002a  /* 0000000000101010 dll_dqs_delay_bypass6 0000000000101010 dll_dqs_delay_bypass5 */
#define DDR1_CTL40_DATA 0x0022002a  /* 0000000000100010 dll_increment 0000000000101010 dll_dqs_delay_bypass7 */
#define DDR1_CTL41_DATA 0x00810000  /* 0000000010000001 dll_start_point 0000000000 dll_lock */
#define DDR1_CTL42_DATA 0x002a00aa  /* 0000000000101010 wr_dqs_shift_bypass 0000000010101010 dqs_out_shift_bypass */
#define DDR1_CTL43_DATA 0x00000000  /* 00000000000000000000000000000000 out_of_range_addr */
#define DDR1_CTL44_DATA 0x00000000  /* 00000000000000000000000000000000 */
#define DDR1_CTL45_DATA 0x00000000  /* 00000000000000000000000000000000 port_cmd_error_addr */
#define DDR1_CTL46_DATA 0x00000000  /* 00000000000000000000000000000000 */
#else
/* EVB hynix */
#define DDR1_CTL00_DATA 0x00000101 //0000000_0 arefresh 0000000_0 ap 0000000_1 addr_cmp_en 0000000_1 active_aging 
#define DDR1_CTL01_DATA 0x01010100 //0000000_1 bank_split_en 0000000_1 axi0_w_priority 0000000_1 axi0_r_priority 0000000_0 auto_refresh_mode 
#define DDR1_CTL02_DATA 0x01000000 //0000000_1 drive_dq_dqs 0000000_0 dll_bypass_mode 0000000_0 dlllockreg 0000000_0 concurrentap 
#define DDR1_CTL03_DATA 0x01000101 //0000000_1 intrptapburst 0000000_0 fast_write 0000000_1 en_lowpower_mode 0000000_1 enable_quick_srefresh 
#define DDR1_CTL04_DATA 0x01000000 //0000000_1 placement_en 0000000_0 no_cmd_init 0000000_0 intrptwritea 0000000_0 intrptreada 
#define DDR1_CTL05_DATA 0x00000100 //0000000_0 rd2rd_turn 0000000_0 pwrup_srefresh_exit 0000000_1 priority_en 0000000_0 power_down 
#define DDR1_CTL06_DATA 0x00010000 //0000000_0 srefresh 0000000_1 rw_same_en 0000000_0 reg_dimm_enable 0000000_0 reduc 
#define DDR1_CTL07_DATA 0x01000100 //0000000_1 tref_enable 0000000_0 tras_lockout 0000000_1 swap_en 0000000_0 start 
#define DDR1_CTL08_DATA 0x03030001 //000000_11 command_age_count 000000_11 age_count 0000000_0 write_modereg 0000000_1 writeinterp 
#define DDR1_CTL09_DATA 0x00000001 //00000_000 q_fullness 000000_00 max_cs_reg 000000_00 lowpower_refresh_enable 000000_01 cs_map 
#define DDR1_CTL10_DATA 0x03020102 //00000_011 caslat 00000_010 bstlen 00000_001 addr_pins 000000_10 temrs 
#define DDR1_CTL11_DATA 0x00000300 //00000_000 port_data_error_type 000_00000 out_of_range_type 00000_011 column_size 00000_000 cke_delay 
#define DDR1_CTL12_DATA 0x02020201 //00000_010 twtr 0000_0010 twr_int 00000_010 trrd 00000_001 tcke 
#define DDR1_CTL13_DATA 0x0206060a //0000_0010 initaref 0000_0110 caslat_lin_gate 0000_0110 caslat_lin 0000_1010 aprebit 
#define DDR1_CTL14_DATA 0x00000000 //0000_0000 port_cmd_error_id 0000_0000 out_of_range_source_id 0000_0000 max_row_reg 0000_0000 max_col_reg 
#define DDR1_CTL15_DATA 0x03050000 //0000_0011 trp 0000_0101 tdal 0000_0000 port_data_error_id 0000_0000 port_cmd_error_type 
#define DDR1_CTL16_DATA 0x08020000 //000_01000 trc 000_00010 tmrd 000_00000 lowpower_control 000_00000 lowpower_auto_enable 
#define DDR1_CTL17_DATA 0x1f1f1f00 //0_0011111 dll_dqs_delay_2 0_0011111 dll_dqs_delay_1 0_0011111 dll_dqs_delay_0 00_000000 int_ack 
#define DDR1_CTL18_DATA 0x1f1f1f1f //0_0011111 dll_dqs_delay_6 0_0011111 dll_dqs_delay_5 0_0011111 dll_dqs_delay_4 0_0011111 dll_dqs_delay_3 
#define DDR1_CTL19_DATA 0x0000001f //0000000000000000000000000_0011111 dll_dqs_delay_7 
#define DDR1_CTL20_DATA 0x00000000 //00000000000000000000000000000000
#define DDR1_CTL21_DATA 0x00000000 //00000000000000000000000000000000
#define DDR1_CTL22_DATA 0x0000007f //0_0000000 int_status 0_0000000 int_mask 000000000_1111111 dqs_out_shift 
#define DDR1_CTL23_DATA 0x0600001f //00000110 tras_min 00000000 out_of_range_length 000000000_0011111 wr_dqs_shift 
#define DDR1_CTL24_DATA 0x03fe0f03 //0000_001111111110 tref 00001111 trfc 00000011 trcd_int 
#define DDR1_CTL25_DATA 0x00000000 //00_00000000000000 emrs2_data_0 00_00000000000000 emrs1_data 
#define DDR1_CTL26_DATA 0x001c0000 //0000000000011100 axi0_en_size_lt_width_instr 00_00000000000000 emrs2_data_1 
#define DDR1_CTL27_DATA 0x00000000 //0000000000000000 lowpower_internal_cnt 0000000000000000 lowpower_external_cnt 
#define DDR1_CTL28_DATA 0x00000000 //0000000000000000 lowpower_refresh_hold 0000000000000000 lowpower_power_down_cnt 
#define DDR1_CTL29_DATA 0x00000000 //0000000000000000 tdll 0000000000000000 lowpower_self_refresh_cnt 
#define DDR1_CTL30_DATA 0x24090001 //0010010000001001 tras_max 0000000000000001 tpdex 
#define DDR1_CTL31_DATA 0x00150013 //0000000000010101 txsr 0000000000010011 txsnr 
#define DDR1_CTL32_DATA 0x00000000 //00000000000000000000000000000000 version 
#define DDR1_CTL33_DATA 0x00006712 //00000000000000000110011100010010 tinit 
#define DDR1_CTL34_DATA 0x00000000 //00000000000000000000000000000000
#define DDR1_CTL35_DATA 0x00000000 //00000000000000000000000000000000
#define DDR1_CTL36_DATA 0x00002a01 //000000000000000_000101010 dll_dqs_delay_bypass_0 0000000_1 wrlat 
#define DDR1_CTL37_DATA 0x002a002a //0000000_000101010 dll_dqs_delay_bypass_2 0000000_000101010 dll_dqs_delay_bypass_1 
#define DDR1_CTL38_DATA 0x002a002a //0000000_000101010 dll_dqs_delay_bypass_4 0000000_000101010 dll_dqs_delay_bypass_3 
#define DDR1_CTL39_DATA 0x002a002a //0000000_000101010 dll_dqs_delay_bypass_6 0000000_000101010 dll_dqs_delay_bypass_5 
#define DDR1_CTL40_DATA 0x000f002a //0000000_000001111 dll_increment 0000000_000101010 dll_dqs_delay_bypass_7 
#define DDR1_CTL41_DATA 0x002a0000 //0000000_000101010 dll_start_point 0000000_000000000 dll_lock 
#define DDR1_CTL42_DATA 0x002a00aa //0000000_000101010 wr_dqs_shift_bypass 0000000_010101010 dqs_out_shift_bypass 
#define DDR1_CTL43_DATA 0x00000000 //00000000000000000000000000000000 out_of_range_addr 
#define DDR1_CTL44_DATA 0x00000000 //0000000000000000000000000000000_0
#define DDR1_CTL45_DATA 0x00000000 //00000000000000000000000000000000 port_cmd_error_addr 
#define DDR1_CTL46_DATA 0x00000000 //0000000000000000000000000000000_0
#endif


/* for xarina */
#define DDR_CTL_00_DATA	 0x00000600
#define DDR_CTL_01_DATA	 0x00000000
#define DDR_CTL_02_DATA	 0x00000004
#define DDR_CTL_03_DATA	 0x00013880
#define DDR_CTL_04_DATA	 0x00030D40
#define DDR_CTL_05_DATA	 0x04050C00
#define DDR_CTL_06_DATA	 0x0F150404
#define DDR_CTL_07_DATA	 0x06040604
#define DDR_CTL_08_DATA	 0x006DB00C
#define DDR_CTL_09_DATA	 0x00000403
#define DDR_CTL_10_DATA	 0x06060101
#define DDR_CTL_11_DATA	 0x0002000C
#define DDR_CTL_12_DATA	 0x00001403
#define DDR_CTL_13_DATA	 0x00000007
#define DDR_CTL_14_DATA	 0x00004001
#define DDR_CTL_15_DATA	 0x00000C2D
#define DDR_CTL_16_DATA	 0x000A0003
#define DDR_CTL_17_DATA	 0x00440200
#define DDR_CTL_18_DATA	 0x01000000
#define DDR_CTL_19_DATA	 0x00000000
#define DDR_CTL_20_DATA	 0x00000000
#define DDR_CTL_21_DATA	 0x00042000
#define DDR_CTL_23_DATA	 0x00000000
#define DDR_CTL_24_DATA	 0x01000200
#define DDR_CTL_25_DATA	 0x02000040
#define DDR_CTL_26_DATA	 0x02010040
#define DDR_CTL_27_DATA0 0x0F000A00
#define DDR_CTL_27_DATA1 0x7F000A00
#define DDR_CTL_28_DATA	 0x01010101
#define DDR_CTL_29_DATA	 0x00010101
#define DDR_CTL_30_DATA	 0x0000000C
#define DDR_CTL_31_DATA	 0x00000100
#define DDR_CTL_32_DATA	 0x00000000
#define DDR_CTL_33_DATA	 0x00000000
#define DDR_CTL_34_DATA	 0x00000000
#define DDR_CTL_35_DATA	 0x00000000
#define DDR_CTL_36_DATA	 0x00000000
#define DDR_CTL_37_DATA	 0x00000000
#define DDR_CTL_38_DATA	 0x00000000
#define DDR_CTL_39_DATA	 0x00040000
#define DDR_CTL_40_DATA	 0x00000000
#define DDR_CTL_41_DATA	 0x00000000
#define DDR_CTL_42_DATA	 0x00000000
#define DDR_CTL_43_DATA	 0x00281900
#define DDR_CTL_44_DATA	 0x00000000
#define DDR_CTL_45_DATA	 0x00000000
#define DDR_CTL_46_DATA	 0x00000000
#define DDR_CTL_47_DATA	 0x00000000
#define DDR_CTL_48_DATA	 0x00000000
#define DDR_CTL_49_DATA	 0x00000000
#define DDR_CTL_50_DATA	 0x00232300
#define DDR_CTL_51_DATA	 0x00000000
#define DDR_CTL_52_DATA	 0x00000000
#define DDR_CTL_53_DATA	 0x00000000
#define DDR_CTL_54_DATA	 0x00002323
#define DDR_CTL_55_DATA	 0x00005555
#define DDR_CTL_56_DATA	 0x00000000
#define DDR_CTL_57_DATA	 0x00000000
#define DDR_CTL_58_DATA	 0x00002000
#define DDR_CTL_59_DATA	 0x000C2D00
#define DDR_CTL_60_DATA	 0x02000020
#define DDR_CTL_61_DATA	 0x02000200
#define DDR_CTL_62_DATA	 0x00000C2D
#define DDR_CTL_63_DATA	 0x00003CE1
#define DDR_CTL_64_DATA	 0x80000203
#define DDR_CTL_65_DATA	 0x04070303
#define DDR_CTL_66_DATA	 0x0000000A
#define DDR_CTL_67_DATA	 0x00000000
#define DDR_CTL_68_DATA	 0x00000000
#define DDR_CTL_69_DATA	 0x0010FFFF
#define DDR_CTL_70_DATA	 0x12070303
#define DDR_CTL_71_DATA	 0x0000000F
#define DDR_CTL_72_DATA	 0x00000000
#define DDR_CTL_73_DATA	 0x00000000
#define DDR_CTL_74_DATA	 0x00000000
#define DDR_CTL_75_DATA	 0x00000000
#define DDR_CTL_76_DATA	 0x00000204
#define DDR_CTL_77_DATA	 0x00000000
#define DDR_CTL_78_DATA	 0xFF000200
#define DDR_CTL_79_DATA	 0x00640000
#define DDR_CTL_80_DATA	 0x00006400

#if defined(CONFIG_XARINA_DDR_ODT_OFF)
#define DDR_CTL_22_DATA	 0x00000000
#else 
#define DDR_CTL_22_DATA	 0x00000040
#endif

/***************************************/
/* SYSREG 1 (ARM11 Block)              */
/***************************************/
/* SYSREG Base Address */
#define SYSREG1_REG_BASE		0x30000000
/* SYSREG Register Address */

/* for XARINA */
#define SYSREG1_PLL1				0x000
#define SYSREG1_PLL2				0x004
#define SYSREG1_PLL3				0x008
#define SYSREG1_PLL4				0x00C
#define SYSREG1_PLL5				0x010
#define SYSREG1_PLL6				0x014
#define SYSREG1_PLL7				0x018
#define SYSREG1_PLL_POWER_1234			0x01C
#define SYSREG1_PLL_POWER_567			0x020
#define SYSREG1_PLL_READY			0x024
#define SYSREG1_RST_CTL				0x030
#define SYSREG1_CLK_CTL				0x034
#define SYSREG1_CLK_EN				0x038
#define SYSREG1_MODE_SEL			0x040
#define SYSREG1_REMAP_CTR			0x044
#define SYSREG1_FUNC_SEL1			0x048
#define SYSREG1_PORT_MON			0x04C
#define SYSREG1_DEVICE_ID_1108			0x108
#define SYSREG1_DEVICE_ID_CTRL			0x120
#define SYSREG1_GPIO_ABCD_PC		0x308
#define SYSREG1_GPIO_EFGH_PC		0x30C
#define SYSREG1_GPIO_I_PC			0x310
#define SYSREG1_DEVICE_ID			0x700
#define SYSREG1_PLL1_POWER_ON			0x00000001
#define SYSREG1_PLL2_POWER_ON			0x00000100
#define SYSREG1_PLL2_OUT_EN			0x00000200
#define SYSREG1_PLL3_POWER_ON			0x00010000
#define SYSREG1_PLL3_OUT_EN			0x00020000
#define SYSREG1_PLL4_POWER_ON			0x01000000
#define SYSREG1_PLL4_OUT_EN			0x02000000
#define SYSREG1_PLL5_POWER_ON			0x00000001
#define SYSREG1_PLL5_OUT_EN			0x00000002
#define SYSREG1_PLL6_POWER_ON			0x00000100
#define SYSREG1_PLL6_OUT_EN			0x00000200
#define SYSREG1_PLL7_POWER_ON			0x00010000
#define SYSREG1_PLL7_OUT_EN			0x00020000
#define SYSREG1_PLL1_READY			0x00000001
#define SYSREG1_PLL2_READY			0x00000002
#define SYSREG1_PLL3_READY			0x00000004
#define SYSREG1_PLL4_READY			0x00000008
#define SYSREG1_PLL5_READY			0x00000010
#define SYSREG1_PLL6_READY			0x00000020
#define SYSREG1_PLL7_READY			0x00000040
#define SYSREG1_PLL5_SMAC_FREQ			0x00032702
#define SYSREG1_SYS_CKSEL_PLL1			0x00000001
#define SYSREG1_GBEMODE_MII			0x00000000
#define SYSREG1_GBEMODE_RGMII			0x00000001
#define SYSREG1_AVCC_RST_CTL_N			0x00000001
#define SYSREG1_AVCC_ARM9_RST_CTL_N		0x00000100
#define SYSREG1_RST_CTL_GBE_RST_CTL_N		0x00000002
#define SYSREG1_RST_CTL_DDR1_RST_CTL_N		0x00000010
#define SYSREG1_GBE_CKSEL_MASK			0x00003000
#define SYSREG1_GBE_CKSEL_SHIFT			(12)
#define SYSREG1_GBE_CKSEL_RGMII1000M		0x00000000
#define SYSREG1_GBE_CKSEL_RGMII100M		0x00000001
#define SYSREG1_GBE_CKSEL_RGMII10M		0x00000002
#define SYSREG1_GBE_CKSEL_MII10M_100M		0x00000003
#define SYSREG1_NFIF_CKSEL_MASK			0x00070000
#define SYSREG1_NFIF_CKSEL_SHIFT		(16)
#define SYSREG1_AVCAMCTL_CKON			0x00000001
#define SYSREG1_DDR0_CKON			0x00000400
#define SYSREG1_DDR1_CKON			0x00000002
#define SYSREG1_GBE_CKON			0x00000010
#define SYSREG1_SDIF_CKON			0x00000040
#define SYSREG1_AVA9_CKON			0x00000100
#define SYSREG1_GBEEXT_EN			0x00000200
#define SYSREG1_ARM11_REMAP			0x00000001
#define SYSREG1_PLL3_BYPASS			0x00000001
#define SYSREG1_DDRIMP_REG			0x00E0	/* W */
#define SYSREG1_VIDEOCLK_SEL_MASK		0x00000003
#define SYSREG1_VIDEO_HCLK			0x00000001
#define SYSREG1_SVICLK				0x00000003
#define SYSREG1_A9JTAGSEL			0x0000000E
#define SYSREG1_A9JTAGSEL_NOUSE			0x00000000
#define SYSREG1_A9JTAGSEL_CPU1			0x00000002
#define SYSREG1_A9JTAGSEL_CPU2			0x00000004
#define SYSREG1_A9JTAGSEL_CPU3			0x00000008
#define SYSREG1_A9JTAGSEL_DAISYCHAIN		0x0000000E
#define SYSREG1_BOOTSEL_MASK			0x00000060
#define SYSREG1_BOOTSEL_NAND			0x00000000
#define SYSREG1_BOOTSEL_UART			0x00000020
#define SYSREG1_NAND_CONTROLLER1		0x00000000
#define SYSREG1_NAND_CONTROLLER2		0x00000040
#define SYSREG1_AUDIO_CKSEL_MASK		0x00000010
#define SYSREG1_AUDIO_CKSEL_MASTER		0x00000000
#define SYSREG1_AUDIO_CKSEL_SLAVE		0x00000010
#define SYSREG1_VCLK_CKSEL_MASK			0x000000E0
#define SYSREG1_VCLK_CKSEL_27MHZ_27MHZ		0x00000000
#define SYSREG1_VCLK_CKSEL_13_5MHZ_27MHZ	0x00000020
#define SYSREG1_VCLK_CKSEL_13_5MHZ_13_5MHZ	0x00000040
#define SYSREG1_VCLK_CKSEL_74_175MHZ_74_175MHZ	0x00000060
#define SYSREG1_VCLK_CKSEL_74_25MHZ_74_25MHZ_PLL4	0x00000080
#define SYSREG1_VCLK_CKSEL_74_25MHZ_74_25MHZ_PLL7	0x000000A0
#define SYSREG1_DDR1_CKSEL			0x00008000
#define SYSREG1_DDR0_CKSEL			0x00004000
#define SYSREG1_EVRINIT_MASK			0x00000010
#define SYSREG1_EVRINIT_SCI			0x00000000
#define SYSREG1_EVRINIT_SPI			0x00000010
#define SYSREG1_AUDIO_MCLK_OE_N			0x00000008
#define SYSREG1_CKSEL_GCLK_125MHZ		0x00000000
#define SYSREG1_CKSEL_GCLK_25MHZ		0x00000001


#define SYSREG1_NFIF_CKSEL_33MHZ		(0)
#define SYSREG1_NFIF_CKSEL_40MHZ		(1)
#define SYSREG1_NFIF_CKSEL_50MHZ		(2)
#define SYSREG1_NFIF_CKSEL_66MHZ		(3)
#define SYSREG1_NFIF_CKSEL_80MHZ		(4)
#define SYSREG1_NFIF_CKSEL_100MHZ		(5)

#define SYSREG1_DEVICE_ID_PKG			(0x00000000)
#define SYSREG1_DEVICE_ID_MODULE_S		(0x00000100)
#define SYSREG1_DEVICE_ID_MODULE_H		(0x00000200)
#define SYSREG1_DEVICE_ID_MODULE_S2		(0x00000300)
#define SYSREG1_DEVICE_ID_MODULE_H2		(0x00000400)

#define SYSREG1_BOARD_TYPE		(0x0000F000)
#define SYSREG1_BOARD_TYPE_EVB_1_0	(0x00002000)
#define SYSREG1_BOARD_TYPE_EVB_1_1	(0x00000000)
#define SYSREG1_BOARD_TYPE_EVB_1_0_AF	(0x00005000)
#define SYSREG1_BOARD_TYPE_EVB_1_1_AF	(0x00009000)
#define SYSREG1_BOARD_TYPE_RD_IMX122	(0x00008000)
#define SYSREG1_BOARD_TYPE_RD_ICX692	(0x00004000)
#define SYSREG1_BOARD_TYPE_RD_IMX122AF	(0x0000C000)
#define SYSREG1_BOARD_TYPE_RD_IMX139	(0x0000A000)
#define SYSREG1_BOARD_TYPE_RD_IMX140	(0x00006000)
#define SYSREG1_BOARD_TYPE_RD_IMX139AF	(0x0000E000)
#define SYSREG1_BOARD_TYPE_RD_IMX140AF	(0x00001000)
#define SYSREG1_BOARD_TYPE_RD_IMX140LA	(0x00003000)
#define SYSREG1_BOARD_TYPE_RD_ICX693	(0x0000D000)

#define SYSREG1_BOARD_CONFIG				(0x0000FF00)
#define SYSREG1_BOARD_CONFIG_FACTORY_RESET	(0x00000100)
#define SYSREG1_BOARD_CONFIG_NTSC_PAL		(0x00000800)

/* for xarina */

#define SYSREG1_CAM_GPIOA_SEL		(0x200)
#define SYSREG1_PINSEL_PA_GPIO		(0x00000000)
#define SYSREG1_PINSEL_PA_AFVD		(0x00000001)
#define SYSREG1_PINSEL_PA_MASK		(0x00000001)
#define SYSREG1_PINSEL_PA_SHIFT		(0)

#define SYSREG1_VIDEO_GPIO_SVI_SEL	(0x208)
#define SYSREG1_PINSEL_PC_GPIO		(0x00000000)
#define SYSREG1_PINSEL_PC_VIDEO		(0x00005555)
#define SYSREG1_PINSEL_PC_SVI		(0x0000ffff)
#define SYSREG1_PINSEL_PC_MASK		(0x00FFFF00)
#define SYSREG1_PINSEL_PC_SHIFT		(8)

#define SYSREG1_GPIO_BE_SEL		(0x20C)
#define SYSREG1_PINSEL_PB_GPIO		(0x00000000)
#define SYSREG1_PINSEL_PB_AUDIOIF	(0x0000001F)
#define SYSREG1_PINSEL_PB_MASK		(0x0000F800)
#define SYSREG1_PINSEL_PB_SHIFT		(11)

#define SYSREG1_PINSEL_PE_GPIO		(0x00000000)
#define SYSREG1_PINSEL_PE_UART0		(0x00005500)
#define SYSREG1_PINSEL_PE_UART0_NOFC		(0x00000500)
#define SYSREG1_PINSEL_PE_SPI1		(0x0000AA00)
#define SYSREG1_PINSEL_PE_SPI0		(0x0000000F)
#define SYSREG1_PINSEL_PE_MASK		(0xFFFF0000)
#define SYSREG1_PINSEL_PE_SHIFT		(16)


#define SYSREG1_GPIOFG_SEL		(0x210)
#define SYSREG1_PINSEL_PG_GPIO		(0x00000000)
#define SYSREG1_PINSEL_PG_UART3		(0x00000300)
#define SYSREG1_PINSEL_PG_UART1		(0x00000055)
#define SYSREG1_PINSEL_PG_UART1_NOFC	(0x00000005)
#define SYSREG1_PINSEL_PG_SPI2		(0x000000AA)
#define SYSREG1_PINSEL_PG_UART2		(0x00001400)
#define SYSREG1_PINSEL_PG_VIDEO		(0x00002800)
#define SYSREG1_PINSEL_PG_SVI		(0x00003C00)

#define SYSREG1_PINSEL_PG_MASK		(0x003FFF00)
#define SYSREG1_PINSEL_PG_SHIFT		(8)

#define SYSREG1_GPIOHI_SEL		(0x214)
#define SYSREG1_PINSEL_PH_GPIO		(0x00000000)
#define SYSREG1_PINSEL_PH_SDIF		(0x00005555)
#define SYSREG1_PINSEL_PH_VIDEO		(0x0000AAAA)
#define SYSREG1_PINSEL_PH_SVI		(0x0000FFFF)

#define SYSREG1_PINSEL_PH_MASK		(0x0000FFFF)
#define SYSREG1_PINSEL_PH_SHIFT		(0)
#define SYSREG1_PINSEL_PI_GPIO		(0x00000000)
#define SYSREG1_PINSEL_PI_SPI3		(0x00000055)
#define SYSREG1_PINSEL_PI_PWM		(0x00000500)
#define SYSREG1_PINSEL_PI_VIDEO		(0x00000A00)
#define SYSREG1_PINSEL_PI_NCE1		(0x00000001)
#define SYSREG1_PINSEL_PI_MASK		(0x0FFF0000)
#define SYSREG1_PINSEL_PI_SHIFT		(16)

#define SYSREG1_NAND_GPIOI_SEL		(0x204)
#define SYSREG1_NAND_PI_MASK		(0x00000001)
#define SYSREG1_NAND_PI_GPIO		(0x00000000)
#define SYSREG1_NAND_PI_NCE1		(0x00000001)

#define SYSREG1_GPIO_PA_PC_MASK		(0x000000FF)
#define SYSREG1_GPIO_PB_PC_MASK		(0x0000F800)
#define SYSREG1_GPIO_PC_PC_MASK		(0x00FF0000)

#define SYSREG1_GPIO_PE_PC_MASK		(0x000000FF)
#define SYSREG1_GPIO_PF_PC_MASK		(0x0000FF00)
#define SYSREG1_GPIO_PG_PC_MASK		(0x00FF0000)
#define SYSREG1_GPIO_PH_PC_MASK		(0xFF000000)

#define SYSREG1_GPIO_PI_PC_MASK		(0x0000003F)

/* BOTR Register bit */
#define SYSREG1_BOTR_BOOTREMAP_BIT	0x00000001	/* BootRAM Remap on 0x00000000 */

#define SYSREG1_DEVICE_ID_ES1		(0x41350100)
#define SYSREG1_DEVICE_ID_ES2		(0x4135a100)
#define SYSREG1_DEVICE_ID_ES3		(0x41350300)


/***************************************/
/* SYSREG 0 (ARM9 Block)               */
/***************************************/
/* SYSREG Base Address */
#define SYSREG0_REG_BASE		0x51000000
/* for XARINA */
#define SYSREG0_RST_CTL		0x000
#define SYSREG0_CLK_EN		0x008
#define SYSREG0_CDSP_RST_CTL_N	0x00000004
#define SYSREG0_SLICEVIDEO_CKON	0x00000010


/***************************************/
/* BUS Config 0                        */
/***************************************/
#define BUS_CONFIG0_BASE		0x41000000
#define BUS_CONFIG0_00_REG		0x020
#define BUS_CONFIG0_01_REG		0x024
#define BUS_CONFIG0_02_REG		0x030
#define BUS_CONFIG0_03_REG		0x034
#define BUS_CONFIG0_04_REG		0x040
#define BUS_CONFIG0_05_REG		0x044
#define BUS_CONFIG0_06_REG		0x050
#define BUS_CONFIG0_07_REG		0x054
#define BUS_CONFIG0_08_REG		0x060
#define BUS_CONFIG0_09_REG		0x064
#define BUS_CONFIG0_10_REG		0x070
#define BUS_CONFIG0_11_REG		0x074
#define BUS_CONFIG0_2DDR_00_DATA	0x00000000
#define BUS_CONFIG0_2DDR_01_DATA	0x0400000C
#define BUS_CONFIG0_2DDR_02_DATA	0x00000001
#define BUS_CONFIG0_2DDR_03_DATA	0x04000002
#define BUS_CONFIG0_2DDR_04_DATA	0x00000000
#define BUS_CONFIG0_2DDR_05_DATA	0x04000004
#define BUS_CONFIG0_2DDR_06_DATA	0x00000000
#define BUS_CONFIG0_2DDR_07_DATA	0x04000002
#define BUS_CONFIG0_2DDR_08_DATA	0x00000002
#define BUS_CONFIG0_2DDR_09_DATA	0x04000002
#define BUS_CONFIG0_2DDR_10_DATA	0x00000000
#define BUS_CONFIG0_2DDR_11_DATA	0x04000002
#define BUS_CONFIG0_1DDR_00_DATA	0x00000000
#define BUS_CONFIG0_1DDR_01_DATA	0x0400000C
#define BUS_CONFIG0_1DDR_02_DATA	0x00000001
#define BUS_CONFIG0_1DDR_03_DATA	0x04000002
#define BUS_CONFIG0_1DDR_04_DATA	0x00000000
#define BUS_CONFIG0_1DDR_05_DATA	0x04000004
#define BUS_CONFIG0_1DDR_06_DATA	0x00000000
#define BUS_CONFIG0_1DDR_07_DATA	0x04000002
#define BUS_CONFIG0_1DDR_08_DATA	0x00000002
#define BUS_CONFIG0_1DDR_09_DATA	0x04000002
#define BUS_CONFIG0_1DDR_10_DATA	0x00000000
#define BUS_CONFIG0_1DDR_11_DATA	0x04000002
/***************************************/
/* BUS Config 1                        */
/***************************************/
#define BUS_CONFIG1_BASE		0x41060000
#define BUS_CONFIG1_00_REG		0x020
#define BUS_CONFIG1_01_REG		0x024
#define BUS_CONFIG1_02_REG		0x030
#define BUS_CONFIG1_03_REG		0x034
#define BUS_CONFIG1_04_REG		0x040
#define BUS_CONFIG1_05_REG		0x044
#define BUS_CONFIG1_06_REG		0x050
#define BUS_CONFIG1_07_REG		0x054
#define BUS_CONFIG1_08_REG		0x060
#define BUS_CONFIG1_09_REG		0x064
#define BUS_CONFIG1_10_REG		0x070
#define BUS_CONFIG1_11_REG		0x074
#define BUS_CONFIG1_12_REG		0x080
#define BUS_CONFIG1_13_REG		0x084
#define BUS_CONFIG1_14_REG		0x120
#define BUS_CONFIG1_15_REG		0x124
#define BUS_CONFIG1_2DDR_00_DATA	0x00000001
#define BUS_CONFIG1_2DDR_01_DATA	0x04000002
#define BUS_CONFIG1_2DDR_02_DATA	0x00000000
#define BUS_CONFIG1_2DDR_03_DATA	0x04000002
#define BUS_CONFIG1_2DDR_04_DATA	0x00000002
#define BUS_CONFIG1_2DDR_05_DATA	0x04000002
#define BUS_CONFIG1_2DDR_06_DATA	0x00000002
#define BUS_CONFIG1_2DDR_07_DATA	0x04000002
#define BUS_CONFIG1_2DDR_08_DATA	0x00000002
#define BUS_CONFIG1_2DDR_09_DATA	0x04000002
#define BUS_CONFIG1_2DDR_10_DATA	0x00000002
#define BUS_CONFIG1_2DDR_11_DATA	0x04000002
#define BUS_CONFIG1_2DDR_12_DATA	0x00000000
#define BUS_CONFIG1_2DDR_13_DATA	0x04000002
#define BUS_CONFIG1_1DDR_00_DATA	0x00000001
#define BUS_CONFIG1_1DDR_01_DATA	0x04000002
#define BUS_CONFIG1_1DDR_02_DATA	0x00000000
#define BUS_CONFIG1_1DDR_03_DATA	0x04000002
#define BUS_CONFIG1_1DDR_04_DATA	0x00000002
#define BUS_CONFIG1_1DDR_05_DATA	0x04000002
#define BUS_CONFIG1_1DDR_06_DATA	0x00000002
#define BUS_CONFIG1_1DDR_07_DATA	0x04000002
#define BUS_CONFIG1_1DDR_08_DATA	0x00000002
#define BUS_CONFIG1_1DDR_09_DATA	0x04000002
#define BUS_CONFIG1_1DDR_10_DATA	0x00000002
#define BUS_CONFIG1_1DDR_11_DATA	0x04000002
#define BUS_CONFIG1_1DDR_12_DATA	0x00000000
#define BUS_CONFIG1_1DDR_13_DATA	0x04000002
#define BUS_CONFIG1_TILING_OFF_14_DATA		0x00000000
#define BUS_CONFIG1_TILING_OFF_15_DATA		0x00000000
#define BUS_CONFIG1_TILING_TYPE1_14_DATA	0x0c2c35cb
#define BUS_CONFIG1_TILING_TYPE1_15_DATA	0x0000005a
#define BUS_CONFIG1_TILING_TYPE2_14_DATA	0x0d2c360b
#define BUS_CONFIG1_TILING_TYPE2_15_DATA	0x00000000

/***************************************/
/* EMC_SM2 register                    */
/***************************************/
/* EMC_SM2 Base Address */
#define EMC_SM2_REG_BASE		0x38002000

/* EMC_SM2 Register Address */
#define EMC_SM2_STATUS			0x000
#define EMC_SM2_TRANS_CTRL		0x004
#define EMC_SM2_CS_PHY_BIND		0x008
#define EMC_SM2_IO_CNTRL		0x00C
#define EMC_SM2_INT_CTRL		0x010
#define EMC_SM2_INT_CLR			0x014
#define EMC_SM2_INT_STAT		0x018
#define EMC_SM2_INT_RAWSTAT		0x01C
#define EMC_SM2_INT_ASYNC		0x020

#define EMC_SM2_PHY_AM0_CFG		0x050
#define EMC_SM2_PHY_AM0_PRM1		0x054
#define EMC_SM2_PHY_AM0_PRM2		0x058
#define EMC_SM2_PHY_AM0_PRM3		0x05C
#define EMC_SM2_PHY_AM0_PRM4		0x060
#define EMC_SM2_PHY_AM0_PRM5		0x064
#define EMC_SM2_PHY_AM1_CFG		0x070
#define EMC_SM2_PHY_AM1_PRM1		0x074
#define EMC_SM2_PHY_AM1_PRM2		0x078
#define EMC_SM2_PHY_AM1_PRM3		0x07C
#define EMC_SM2_PHY_AM1_PRM4		0x080
#define EMC_SM2_PHY_AM1_PRM5		0x084
#define EMC_SM2_PHY_AM2_CFG		0x090
#define EMC_SM2_PHY_AM2_PRM1		0x094
#define EMC_SM2_PHY_AM2_PRM2		0x098
#define EMC_SM2_PHY_AM2_PRM3		0x09C
#define EMC_SM2_PHY_AM2_PRM4		0x0A0
#define EMC_SM2_PHY_AM2_PRM5		0x0A4
#define EMC_SM2_PHY_AM3_CFG		0x0B0
#define EMC_SM2_PHY_AM3_PRM1		0x0B4
#define EMC_SM2_PHY_AM3_PRM2		0x0B8
#define EMC_SM2_PHY_AM3_PRM3		0x0BC
#define EMC_SM2_PHY_AM3_PRM4		0x0C0
#define EMC_SM2_PHY_AM3_PRM5		0x0C4

/* EMC_SM2_PHY_AMx_CFG	bit */
/* DW (bit1-0)*/
#define EMC_SM2_PHY_AM_DW_8BIT		0x00000000	/* bus width 8bit */
#define EMC_SM2_PHY_AM_DW_16BIT		0x00000001	/* bus width 16bit */
#define EMC_SM2_PHY_AM_DW_32BIT		0x00000002	/* bus width 32bit */
#define EMC_SM2_PHY_AM_DW_RESERVED	0x00000003	/* reserved        */

/* NOR (S29GL512N10TFI020) */
#define EMC_SM2_PHY_CFG_NOR		0x00000001
#define EMC_SM2_PHY_PRM1_NOR		0x01060102
#define EMC_SM2_PHY_PRM2_NOR		0x04040003

/* 100M Ethernet (SMSC9118) */
#define EMC_SM2_PHY_CFG_ETHER		0x00000001
#define EMC_SM2_PHY_PRM1_ETHER		0x00030001
#define EMC_SM2_PHY_PRM2_NETHER		0x00030001

/* SRAM (CY7C1041DV33-10BVXI) */
#define EMC_SM2_PHY_CFG_SRAM		0x00000001
#define EMC_SM2_PHY_PRM1_SRAM		0x00010001
#define EMC_SM2_PHY_PRM2_SRAM		0x00010001


#endif /* HW_REG_H */
