/*
 * (C) Copyright 2007, 2011 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * Version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef _XARINA_DMAC_H
#define _XARINA_DMAC_H
#include <config.h>
#include <asm/io.h>

#define XARINA_DMAC_BASE	(0x38004000)

/* DMAC access */
#define DMAC_RIN(n)		readl(XARINA_DMAC_BASE+(n))
#define DMAC_ROUT(n, v)		writel((v), XARINA_DMAC_BASE+(n))

#define DMA_FROM_DEVICE		(0)
#define DMA_TO_DEVICE		(1)

/* DMAC address */
#define DMAC_INTTCCLR		(0x008)
#define DMAC_CONFIG		(0x030)
#define DMAC_SRCADDR_0		(0x100)
#define DMAC_SRCADDR_1		(0x120)
#define DMAC_DSTADDR_0		(0x104)
#define DMAC_DSTADDR_1		(0x124)
#define DMAC_LLI_0		(0x108)
#define DMAC_LLI_1		(0x128)
#define DMAC_DEF_CONTROL_0	(0x10C)
#define DMAC_DEF_CONTROL_1	(0x12C)
#define DMAC_DEF_CONFIG_0	(0x110)
#define DMAC_DEF_CONFIG_1	(0x130)
#define DMAC_DEF_LLI_0		(0x114)
#define DMAC_DEF_LLI_1		(0x134)

/* INTTCCLEAR */
#define INTTCCLEAR_0		(0x01)
#define INTTCCLEAR_1		(0x02)

/* DMACConfiguration */
#define DMAC_CONFIG_E		(0x00000001)

/* DMACLLI */
#define DMAC_LLI_VAL		(0x00000000)

/* DMACDefControl*/
#define DMAC_DEF_CONTROL_VAL_R	(0xC9489080)	/* for Read */
#define DMAC_DEF_CONTROL_VAL_W	(0xB5489080)	/* for Write */

/* DMACConfiguration_0 */
#define DMAC_DEF_CONFIG_0_VAL_R	(0x00008009)	/* for Read */
#define DMAC_DEF_CONFIG_0_VAL_W	(0x02008101)	/* for Write */

/* DMACDefLLI_0 */
#define DMAC_DEF_LLI_0_VAL	(0x00000000)


#endif	/* _XARINA_DMAC_H */

