/*
 * (C) Copyright 2007, 2011 Sony Corporation.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef CMD_ARM9_H
#define CMD_ARM9_H

#include <config.h>
#include "corefw_boot_param.h"


#define COREFW_BOOT_RES_OK	(SC_SYS_BOOT_RES_PF_INIT_DONE | SC_SYS_BOOT_RES_RM_INIT_DONE)
#define COREFW_BOOT_RES_OK_COMP	(SC_SYS_BOOT_RES_PF_INIT_DONE | SC_SYS_BOOT_RES_RM_INIT_DONE | SC_SYS_BOOT_RES_VOUT_BOOT_DONE)

/* error bit mask */
#define COREFW_BOOT_RES_ERROR_MASK  (SC_SYS_BOOT_RES_E_PARAM | SC_SYS_BOOT_RES_E_SPF_INIT | SC_SYS_BOOT_RES_E_DRV_INIT | SC_SYS_BOOT_RES_E_RM_INIT | SC_SYS_BOOT_RES_E_VIDEO_INIT | SC_SYS_BOOT_RES_E_AUDIO_INIT | SC_SYS_BOOT_RES_E_CAM_INIT | SC_SYS_BOOT_RES_E_VIDEO_OPEN | SC_SYS_BOOT_RES_E_AUDIO_OPEN)

/* warning bit mask */
#define COREFW_BOOT_RES_WARNING_MASK  (SC_SYS_BOOT_RES_W_MASK | SC_SYS_BOOT_RES_W_OSD | SC_SYS_BOOT_RES_W_VIDEO_OTHER)

/* boot_check() return code */
#define E_CMD_BOOT_NOT_YET		(0)
#define E_CMD_BOOT_SUCCESS		(1)
#define E_CMD_BOOT_ERROR		(-1)
#define E_CMD_BOOT_WARNING		(2)

/* boot_corefw() return code */
#define E_CMD_BOOT_COREFW_TMOUT		(-1)
#define E_CMD_BOOT_COREFW_FAILURE	(-2)

#if defined(CONFIG_XARINA_VSS)

#define AUDIO_CODEC_I2C_SLAVE_ADDR	(0x12)
#define AUDIO_CODEC_I2C_DEV		(1)

#else /* defined(CONFIG_XARINA_VSS) */

#define AUDIO_CODEC_I2C_SLAVE_ADDR	(0x18)
#define AUDIO_CODEC_I2C_DEV		(1)

#endif /* defined(CONFIG_XARINA_VSS) */

extern void sensfw_info_out_all(void);
#endif /* CMD_ARM9_H */

