/*
 * (C) Copyright 2007, 2011 Sony Corporation.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <common.h>
#include <command.h>
#include <exports.h>
#include <asm/arch/xarina_wdt.h>

static int do_wdt(cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[])
{
    unsigned long sec = (60 * 2);

    if (argc == 2) {
        sec = simple_strtoul(argv[1], NULL, 10);
    }

    printf("set wdt: %d sec\n", sec);

    return wdt_start(sec/2);
}

U_BOOT_CMD(
    wdt, 2, 0, do_wdt,
    "enable watchdog timer",
    "[sec]\n"
);
