/*
 * (C) Copyright 2007, 2011 Sony Corporation.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef COREFW_COMM_PARAM_H
#define COREFW_COMM_PARAM_H

/************************************/
/* save area identifier             */
/************************************/
#define COREFW_PARAM_FILE_IDENTIFIER		"COPA"

/************************************/
/* prototype                        */
/************************************/
extern unsigned char corefw_param_vout_fmt_get(unsigned char id, unsigned char sync);
extern unsigned char corefw_param_vout_res_type_get(unsigned char fmt);
extern unsigned char corefw_param_vout_id_get(unsigned char fmt);
extern unsigned char corefw_param_vout_sync_type_get(unsigned char fmt);
extern unsigned char corefw_param_vout_ip_type_get(unsigned char fmt);

extern unsigned char corefw_param_uart0_spi1_select_get(void);
extern void corefw_param_tvout_type_set(unsigned long data);
extern void corefw_param_reverse_type_set(unsigned long data);
extern unsigned char corefw_param_tvout_type_get(void);
extern void  corefw_param_osd_mask_output_status_set(unsigned long data);
extern unsigned long corefw_param_osd_mask_output_status_get(void);
extern unsigned long corefw_param_osd_color_plt_addr_get(void);
extern unsigned long corefw_param_osd_data_addr_get(void);
extern unsigned long corefw_param_mask_data_addr_get(void);
extern unsigned char corefw_param_audio_use_get(void);
extern void corefw_param_audio_use_set(unsigned char flag);
extern void corefw_param_audio_i2s_mode_set(unsigned char mode);
extern void corefw_param_audio_i2s_bck_set(unsigned char bit_clock);
extern unsigned char corefw_param_audio_i2s_mode_get(void);
extern unsigned char corefw_param_audio_i2s_format_get(void);
extern void corefw_comm_param_default_area_flash_protect(int flag);
extern void corefw_comm_param_save_area_flash_protect(int flag);
extern void corefw_comm_default_param_load(void);
extern void corefw_comm_param_load(void);
extern void corefw_comm_param_save(void);
extern void corefw_comm_param_dummydata_load(void);
extern int is_corefw_param_save_area(void);
extern int is_corefw_comm_param(int type);
extern int corefw_comm_param_ver_str_get(int type, unsigned long *p_addr, char *p_str);
extern void corefw_comm_param_ver_out(int type);
extern int corefw_comm_param_restore(void);
extern int is_corefw_comm_param_uart0_spi1_select(void);
extern int corefw_param_vout_hd_limit_check(void);
extern int corefw_param_vout_capability_check(unsigned long id);
extern int corefw_param_capability_check_total(void);

#endif /* COREFW_COMM_PARAM_H */
