/*
 * (C) Copyright 2007, 2011 Sony Corporation.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef __DDRCOMMON_H
#define __DDRCOMMON_H

#ifdef CONFIG_XARINA_VSS
typedef enum AGGREGATED_DDR_ID_tag {
    DDR_ID_MODULE_VRAM,
    DDR_ID_MODULE_SYSRAM,
    DDR_ID_0_VRAM,
    DDR_ID_0_SYSRAM,
    DDR_ID_1_VRAM,
    DDR_ID_1_SYSRAM,
    DDR_ID_2_VRAM,
    DDR_ID_2_SYSRAM,
    DDR_ID_3_VRAM
} AggregatedDdrId;

extern void init_ddrtop_with_ddr_id(unsigned long *result, AggregatedDdrId ddr_id);
#else
extern void init_ddrtop(unsigned long *result);
#endif // CONFIG_XARINA_VSS

/* retuen code of do_init_ddrtop */
#define STATUS_INIT_SUCCEEDED 0
#define STATUS_INIT_FAILED    1

#define CONTROLLER_NUM 2
#define NUM_STAGES     4

typedef struct {
  unsigned int sl[2];
  unsigned int lcdl[2];
} S_DQS_GATE_RESULT;

#endif
