/*
 * (C) Copyright 2007, 2011 Sony Corporation.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef HW_REG_CTRL_H
#define HW_REG_CTRL_H

#include <asm/io.h>
#include <asm/arch/hw_reg.h>

/* register access */
#define SYSREG1_RIN(n)		readl(SYSREG1_REG_BASE+(n))
#define SYSREG1_ROUT(n, v)	writel((v), SYSREG1_REG_BASE+(n))
#define SYSREG0_RIN(n)		readl(SYSREG0_REG_BASE+(n))
#define BUS_CONFIG0_ROUT(n, v)	writel((v), BUS_CONFIG0_BASE+(n))
#define BUS_CONFIG1_ROUT(n, v)	writel((v), BUS_CONFIG1_BASE+(n))
#define SYSREG0_ROUT(n, v)	writel((v), SYSREG0_REG_BASE+(n))
#define EMCSM2_RIN(n)		readl(EMC_SM2_REG_BASE+(n))
#define EMCSM2_ROUT(n, v)	writel((v), EMC_SM2_REG_BASE+(n))

extern int xarina_hw_boot_type_get(void);
extern void xarina_hw_pinmux_set(unsigned long *p_reg);
extern void xarina_hw_bootram_remap(void);
extern void xarina_hw_nfif_clock_set(unsigned long clock);
extern void xarina_hw_cpu1_reset(void);
extern void xarina_hw_cpu1_unreset(void);
extern int xarina_hw_gbe_mode_get(void);
extern int xarina_hw_nand_cont_type_get(void);
extern void xarina_hw_gbe_init(void);
extern void xarina_hw_pcie_init(void);
extern int xarina_hw_devid_get(void);
extern void xarina_hw_sdout_clock_enable(void);
extern unsigned long xarina_hw_type_get(void);
extern unsigned long xarina_hw_date_get(void);
extern int xarina_hw_jtag_connection_check(void);
extern void xarina_hw_video_clock_select(unsigned long clock);
extern void xarina_hw_pll2_pll7_unselect(void);
extern void xarina_hw_pll2_pll7_select(int clock_type);
extern void xarina_hw_pll5_select(void);
extern void xarina_hw_pll6_select(void);
extern unsigned char xarina_hw_evr_type_get(void);
extern int xarina_hw_system_type_get(void);
extern void xarina_hw_sdif_clock_en(void);
extern void xarina_hw_audio_clock_input_sel(void);
extern void xarina_hw_bus_config_set(int ddr_num);
extern void xarina_hw_address_tiling_set(unsigned char sel);

#endif /* HW_REG_CTRL_H */
