/*
 * (C) Copyright 2007, 2011, 2013 Sony Corporation.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef HW_REG_INIT_TABLES_H
#define HW_REG_INIT_TABLES_H

#include <config.h>
#include <asm/arch/hw_reg.h>
#include <asm/types.h>


#ifdef CONFIG_XARINA_EVBRD_PRE
const u32 ddr0_ctl_data[41] = {
	DDR0_CTL00_DATA,
	DDR0_CTL01_DATA,
	DDR0_CTL02_DATA,
	DDR0_CTL03_DATA,
	DDR0_CTL04_DATA,
	DDR0_CTL05_DATA,
	DDR0_CTL06_DATA,
	DDR0_CTL07_DATA,
	DDR0_CTL08_DATA,
	DDR0_CTL09_DATA,
	DDR0_CTL10_DATA,
	DDR0_CTL11_DATA,
	DDR0_CTL12_DATA,
	DDR0_CTL13_DATA,
	DDR0_CTL14_DATA,
	DDR0_CTL15_DATA,
	DDR0_CTL16_DATA,
	DDR0_CTL17_DATA,
	DDR0_CTL18_DATA,
	DDR0_CTL19_DATA,
	DDR0_CTL20_DATA,
	DDR0_CTL21_DATA,
	DDR0_CTL22_DATA,
	DDR0_CTL23_DATA,
	DDR0_CTL24_DATA,
	DDR0_CTL25_DATA,
	DDR0_CTL26_DATA,
	DDR0_CTL27_DATA,
	DDR0_CTL28_DATA,
	DDR0_CTL29_DATA,
	DDR0_CTL30_DATA,
	DDR0_CTL31_DATA,
	DDR0_CTL32_DATA,
	DDR0_CTL33_DATA,
	DDR0_CTL34_DATA,
	DDR0_CTL35_DATA,
	DDR0_CTL36_DATA,
	DDR0_CTL37_DATA,
	DDR0_CTL38_DATA,
	DDR0_CTL39_DATA,
	DDR0_CTL40_DATA,
};

const u32 ddr1_ctl_data[47] = {
	DDR1_CTL00_DATA,
	DDR1_CTL01_DATA,
	DDR1_CTL02_DATA,
	DDR1_CTL03_DATA,
	DDR1_CTL04_DATA,
	DDR1_CTL05_DATA,
	DDR1_CTL06_DATA,
	DDR1_CTL07_DATA,
	DDR1_CTL08_DATA,
	DDR1_CTL09_DATA,
	DDR1_CTL10_DATA,
	DDR1_CTL11_DATA,
	DDR1_CTL12_DATA,
	DDR1_CTL13_DATA,
	DDR1_CTL14_DATA,
	DDR1_CTL15_DATA,
	DDR1_CTL16_DATA,
	DDR1_CTL17_DATA,
	DDR1_CTL18_DATA,
	DDR1_CTL19_DATA,
	DDR1_CTL20_DATA,
	DDR1_CTL21_DATA,
	DDR1_CTL22_DATA,
	DDR1_CTL23_DATA,
	DDR1_CTL24_DATA,
	DDR1_CTL25_DATA,
	DDR1_CTL26_DATA,
	DDR1_CTL27_DATA,
	DDR1_CTL28_DATA,
	DDR1_CTL29_DATA,
	DDR1_CTL30_DATA,
	DDR1_CTL31_DATA,
	DDR1_CTL32_DATA,
	DDR1_CTL33_DATA,
	DDR1_CTL34_DATA,
	DDR1_CTL35_DATA,
	DDR1_CTL36_DATA,
	DDR1_CTL37_DATA,
	DDR1_CTL38_DATA,
	DDR1_CTL39_DATA,
	DDR1_CTL40_DATA,
	DDR1_CTL41_DATA,
	DDR1_CTL42_DATA,
	DDR1_CTL43_DATA,
	DDR1_CTL44_DATA,
	DDR1_CTL45_DATA,
	DDR1_CTL46_DATA,
};

#else // CONFIG_XARINA_EVBRD_PRE

const u32 ddr0_ctl_data_ver00[81] = {
	DDR_CTL_00_DATA,
	DDR_CTL_01_DATA,
	DDR_CTL_02_DATA,
	DDR_CTL_03_DATA,
	DDR_CTL_04_DATA,
	DDR_CTL_05_DATA,
	DDR_CTL_06_DATA,
	DDR_CTL_07_DATA,
	DDR_CTL_08_DATA,
	DDR_CTL_09_DATA,
	DDR_CTL_10_DATA,
	DDR_CTL_11_DATA,
	DDR_CTL_12_DATA,
	DDR_CTL_13_DATA,
	DDR_CTL_14_DATA,
	DDR_CTL_15_DATA,
	DDR_CTL_16_DATA,
	DDR_CTL_17_DATA,
	DDR_CTL_18_DATA,
	DDR_CTL_19_DATA,
	DDR_CTL_20_DATA,
	DDR_CTL_21_DATA,
	DDR_CTL_22_DATA,
	DDR_CTL_23_DATA,
	DDR_CTL_24_DATA,
	DDR_CTL_25_DATA,
	DDR_CTL_26_DATA,
	DDR_CTL_27_DATA0,
	DDR_CTL_28_DATA,
	DDR_CTL_29_DATA,
	DDR_CTL_30_DATA,
	DDR_CTL_31_DATA,
	DDR_CTL_32_DATA,
	DDR_CTL_33_DATA,
	DDR_CTL_34_DATA,
	DDR_CTL_35_DATA,
	DDR_CTL_36_DATA,
	DDR_CTL_37_DATA,
	DDR_CTL_38_DATA,
	DDR_CTL_39_DATA,
	DDR_CTL_40_DATA,
	DDR_CTL_41_DATA,
	DDR_CTL_42_DATA,
	DDR_CTL_43_DATA,
	DDR_CTL_44_DATA,
	DDR_CTL_45_DATA,
	DDR_CTL_46_DATA,
	DDR_CTL_47_DATA,
	DDR_CTL_48_DATA,
	DDR_CTL_49_DATA,
	DDR_CTL_50_DATA,
	DDR_CTL_51_DATA,
	DDR_CTL_52_DATA,
	DDR_CTL_53_DATA,
	DDR_CTL_54_DATA,
	DDR_CTL_55_DATA,
	DDR_CTL_56_DATA,
	DDR_CTL_57_DATA,
	DDR_CTL_58_DATA,
	DDR_CTL_59_DATA,
	DDR_CTL_60_DATA,
	DDR_CTL_61_DATA,
	DDR_CTL_62_DATA,
	DDR_CTL_63_DATA,
	DDR_CTL_64_DATA,
	DDR_CTL_65_DATA,
	DDR_CTL_66_DATA,
	DDR_CTL_67_DATA,
	DDR_CTL_68_DATA,
	DDR_CTL_69_DATA,
	DDR_CTL_70_DATA,
	DDR_CTL_71_DATA,
	DDR_CTL_72_DATA,
	DDR_CTL_73_DATA,
	DDR_CTL_74_DATA,
	DDR_CTL_75_DATA,
	DDR_CTL_76_DATA,
	DDR_CTL_77_DATA,
	DDR_CTL_78_DATA,
	DDR_CTL_79_DATA,
	DDR_CTL_80_DATA,
};

const u32 ddr1_ctl_data_ver00[81] = {
	DDR_CTL_00_DATA,
	DDR_CTL_01_DATA,
	DDR_CTL_02_DATA,
	DDR_CTL_03_DATA,
	DDR_CTL_04_DATA,
	DDR_CTL_05_DATA,
	DDR_CTL_06_DATA,
	DDR_CTL_07_DATA,
	DDR_CTL_08_DATA,
	DDR_CTL_09_DATA,
	DDR_CTL_10_DATA,
	DDR_CTL_11_DATA,
	DDR_CTL_12_DATA,
	DDR_CTL_13_DATA,
	DDR_CTL_14_DATA,
	DDR_CTL_15_DATA,
	DDR_CTL_16_DATA,
	DDR_CTL_17_DATA,
	DDR_CTL_18_DATA,
	DDR_CTL_19_DATA,
	DDR_CTL_20_DATA,
	DDR_CTL_21_DATA,
	DDR_CTL_22_DATA,
	DDR_CTL_23_DATA,
	DDR_CTL_24_DATA,
	DDR_CTL_25_DATA,
	DDR_CTL_26_DATA,
	DDR_CTL_27_DATA1,
	DDR_CTL_28_DATA,
	DDR_CTL_29_DATA,
	DDR_CTL_30_DATA,
	DDR_CTL_31_DATA,
	DDR_CTL_32_DATA,
	DDR_CTL_33_DATA,
	DDR_CTL_34_DATA,
	DDR_CTL_35_DATA,
	DDR_CTL_36_DATA,
	DDR_CTL_37_DATA,
	DDR_CTL_38_DATA,
	DDR_CTL_39_DATA,
	DDR_CTL_40_DATA,
	DDR_CTL_41_DATA,
	DDR_CTL_42_DATA,
	DDR_CTL_43_DATA,
	DDR_CTL_44_DATA,
	DDR_CTL_45_DATA,
	DDR_CTL_46_DATA,
	DDR_CTL_47_DATA,
	DDR_CTL_48_DATA,
	DDR_CTL_49_DATA,
	DDR_CTL_50_DATA,
	DDR_CTL_51_DATA,
	DDR_CTL_52_DATA,
	DDR_CTL_53_DATA,
	DDR_CTL_54_DATA,
	DDR_CTL_55_DATA,
	DDR_CTL_56_DATA,
	DDR_CTL_57_DATA,
	DDR_CTL_58_DATA,
	DDR_CTL_59_DATA,
	DDR_CTL_60_DATA,
	DDR_CTL_61_DATA,
	DDR_CTL_62_DATA,
	DDR_CTL_63_DATA,
	DDR_CTL_64_DATA,
	DDR_CTL_65_DATA,
	DDR_CTL_66_DATA,
	DDR_CTL_67_DATA,
	DDR_CTL_68_DATA,
	DDR_CTL_69_DATA,
	DDR_CTL_70_DATA,
	DDR_CTL_71_DATA,
	DDR_CTL_72_DATA,
	DDR_CTL_73_DATA,
	DDR_CTL_74_DATA,
	DDR_CTL_75_DATA,
	DDR_CTL_76_DATA,
	DDR_CTL_77_DATA,
	DDR_CTL_78_DATA,
	DDR_CTL_79_DATA,
	DDR_CTL_80_DATA,
};
#endif /* !CONFIG_XARINA_EVBRD_PRE */


#endif /* HW_REG_INIT_TABLES_H */
