/*
 * (C) Copyright 2003, ARM Ltd.
 * Philippe Robin, <philippe.robin@arm.com>
 *
 * (C) Copyright 2007, 2011 Sony Corporation.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <config.h>
#include <version.h>
#include <asm/arch/hw_reg.h>

/* Set up the platform, once the cpu has been initialized */
.globl lowlevel_init
lowlevel_init:
	stmdb	sp!,{lr}
#ifndef CONFIG_XARINA_DDR_TEST

#if defined(CONFIG_XARINA_SPL)
	bl	xa_hw_sysram_init
#endif /* defined(CONFIG_XARINA_SPL) */

#if !defined(CONFIG_XARINA_SPL)
	bl	xa_hw_vram_init
#endif /* !defined(CONFIG_XARINA_SPL) */
#endif /* CONFIG_XARINA_DDR_TEST */
	ldmia	sp!,{pc}


#if !defined(CONFIG_XARINA_SPL)
	/* form a first-level section entry */
.macro FL_SECTION_ENTRY base,ap,d,c,b
	.word (\base << 20) | (\ap << 10) | \
	      (\d << 5) | (1<<4) | (\c << 3) | (\b << 2) | (1<<1)
.endm

.section .mmudata, "a"
	.align 14
	/* the following alignment creates the mmu table at address 0x4000. */
	.globl mmu_table
mmu_table:
	.set __base, 0
	/* 1:1 mapping */
	.rept 0x600
	FL_SECTION_ENTRY __base, 3, 0, 0, 0
	.set __base, __base + 1
	.endr

#if !defined(CONFIG_POSTEDWRITE_WORKAROUND)
	.set __base, 0x600
	.rept 0x680 - 0x600
	FL_SECTION_ENTRY __base, 3, 0, 1, 1
	.set __base, __base + 1
	.endr

	.set __base, 0x680
	.rept 0x1000 - 0x680
	FL_SECTION_ENTRY __base, 3, 0, 0, 0
	.set __base, __base + 1
	.endr
#else /* !defined(CONFIG_POSTEDWRITE_WORKAROUND) */
	/* make 1MB non-cache area */
	.set __base, 0x600
	.rept 0x67F - 0x600
	FL_SECTION_ENTRY __base, 3, 0, 1, 1
	.set __base, __base + 1
	.endr

	.set __base, 0x67F
	.rept 0x1000 - 0x67F
	FL_SECTION_ENTRY __base, 3, 0, 0, 0
	.set __base, __base + 1
	.endr
#endif /* !defined(CONFIG_POSTEDWRITE_WORKAROUND) */

#endif

