/*
 * (C) Copyright 2007, 2011 Sony Corporation.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <config.h>
#include <version.h>
#include <common.h>
#include <command.h>
#include "cmd_menu.h"
#include "menu_top.h"
#include "menu_preset.h"
#include "xarina_bool.h"

extern char cmd_buff[];
/*------------------------------------*/
/* pre-set                            */
/*------------------------------------*/
static int menu_preset(struct menu_info *p_info, struct menu_item *p_item, struct menu_proc *p_proc)
{
	char env[64];
	int ret;

	sprintf(env, "menu_preset_%02d_cmd", p_proc->select_num);

	ret = getenv_f(env, cmd_buff, 256);
	if (ret == -1) {
		printf("env %s is not defined.\n", env);
		return 0;
	}

	run_command(cmd_buff, 0);

	return 0;
}

static int menu_preset_pre(struct menu_info *p_info, struct menu_proc *p_proc)
{
	char env[30];
	int i;
	
	for (i = 0; i < MENU_ITEM_NUM_MAX; i++) {
		sprintf(env, "menu_preset_%02d_str", i + 1);
		p_info->p_item[i]->p_str = getenv(env);
		p_info->p_item[i]->p_func = menu_preset;
		p_info->p_item[i]->next = &info_top;
		if (p_info->p_item[i]->p_str != NULL) {
			p_proc->b_disable[i] = FALSE;
		} else {
			p_proc->b_disable[i] = TRUE;
		}
	}

	return 0;
}


/**************************************/
/* menu table                         */
/**************************************/
/*------------------------------------*/
/* preset                              */
/*------------------------------------*/
struct menu_item item_preset[MENU_ITEM_NUM_MAX];

struct menu_item item_preset_quit = {
	"quit", NULL, &info_top, 0, 0,
};

struct menu_info info_preset= {
	"pre-set", menu_preset_pre, NULL,
	NULL,
	MENU_ITEM_NUM_MAX,
	{
		&item_preset[0],
		&item_preset[1],
		&item_preset[2],
		&item_preset[3],
		&item_preset[4],
		&item_preset[5],
		&item_preset[6],
		&item_preset[7],
		&item_preset[8],
		&item_preset[9],
		&item_preset[10],
		&item_preset[11],
		&item_preset[12],
		&item_preset[13],
		&item_preset[14],
		&item_preset[15]
	},
	&item_preset_quit, NULL,
	0,
};


