/*
 * (C) Copyright 2007, 2011 Sony Corporation.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */
#ifndef __REG_DDR_H
#define __REG_DDR_H

/* Register Structure */
/* DDR PHY */
typedef union {
  unsigned int w;
} S_DDRPHY_000_RIDR;

typedef union {
  unsigned int w;
  struct {
    unsigned int INIT           : 1;
    unsigned int ZCAL           : 1;
    unsigned int Reserved_3_2   : 2;
    unsigned int PLLINIT        : 1;
    unsigned int DCAL           : 1;
    unsigned int PHYRST         : 1;
    unsigned int DRAMRST        : 1;
    unsigned int DRAMINIT       : 1;
    unsigned int WL             : 1;
    unsigned int QSGATE         : 1;
    unsigned int WLADJ          : 1;
    unsigned int RDDSKW         : 1;
    unsigned int WRDSKW         : 1;
    unsigned int RDEYE          : 1;
    unsigned int WREYE          : 1;
    unsigned int ICPC           : 1;
    unsigned int PLLBYP         : 1;
    unsigned int CTLDINIT       : 1;
    unsigned int Reserved_26_19 : 8;
    unsigned int CLRSR          : 1;
    unsigned int LOCKBYP        : 1;
    unsigned int DCALBYP        : 1;
    unsigned int ZCALBYP        : 1;
    unsigned int INITBYP        : 1;
  } b;
} S_DDRPHY_004_PIR;

typedef union {
  unsigned int w;
} S_DDRPHY_008_PGCR0;

typedef union {
  unsigned int w;
  struct {
    unsigned int PDDISDX  : 1;
    unsigned int WLFULL   : 1;
    unsigned int WLSTEP   : 1;
    unsigned int WLUNCRT  : 1;
    unsigned int WLRANK   : 2;
    unsigned int WLSELT   : 1;
    unsigned int IODDRM   : 2;
    unsigned int MDLEN    : 1;
    unsigned int LPFEN    : 1;
    unsigned int LPFDEPTH : 2;
    unsigned int FDEPTH   : 2;
    unsigned int DLDLMT   : 8;
    unsigned int ZCKSEL   : 2;
    unsigned int PHYHRST  : 1;
    unsigned int INHVT    : 1;
    unsigned int IOLB     : 1;
    unsigned int LBDQSS   : 1;
    unsigned int LBGDQS   : 2;
    unsigned int LBMODE   : 1;
  } b;
} S_DDRPHY_00C_PGCR1;

typedef union {
  unsigned int w;
} S_DDRPHY_010_PGSR0;

typedef union {
  unsigned int w;
} S_DDRPHY_014_PGSR1;

typedef union {
  unsigned int w;
} S_DDRPHY_018_PLLCR;

typedef union {
  unsigned int w;
} S_DDRPHY_01C_PTR0;

typedef union {
  unsigned int w;
} S_DDRPHY_020_PTR1;

typedef union {
  unsigned int w;
} S_DDRPHY_024_PTR2;

typedef union {
  unsigned int w;
} S_DDRPHY_028_PTR3;

typedef union {
  unsigned int w;
} S_DDRPHY_02C_PTR4;

typedef union {
  unsigned int w;
} S_DDRPHY_030_ACMDLR;

typedef union {
  unsigned int w;
} S_DDRPHY_034_ACBDLR;

typedef union {
  unsigned int w;
} S_DDRPHY_038_ACIOCR;

typedef union {
  unsigned int w;
} S_DDRPHY_03C_DXCCR;

typedef union {
  unsigned int w;
} S_DDRPHY_040_DSGCR;

typedef union {
  unsigned int w;
} S_DDRPHY_044_DCR;

typedef union {
  unsigned int w;
} S_DDRPHY_048_DTPR0;

typedef union {
  unsigned int w;
} S_DDRPHY_04C_DTPR1;

typedef union {
  unsigned int w;
} S_DDRPHY_050_DTPR2;

typedef union {
  unsigned int w;
} S_DDRPHY_054_MR0;

typedef union {
  unsigned int w;
} S_DDRPHY_058_MR1;

typedef union {
  unsigned int w;
} S_DDRPHY_05C_MR2;

typedef union {
  unsigned int w;
} S_DDRPHY_060_MR3;

typedef union {
  unsigned int w;
} S_DDRPHY_064_ODTCR;

typedef union {
  unsigned int w;
} S_DDRPHY_068_DTCR;

typedef union {
  unsigned int w;
} S_DDRPHY_06C_DTAR0;

typedef union {
  unsigned int w;
} S_DDRPHY_070_DTAR1;

typedef union {
  unsigned int w;
} S_DDRPHY_074_DTAR2;

typedef union {
  unsigned int w;
} S_DDRPHY_078_DTAR3;

typedef union {
  unsigned int w;
} S_DDRPHY_07C_DTDR0;

typedef union {
  unsigned int w;
} S_DDRPHY_080_DTDR1;

typedef union {
  unsigned int w;
} S_DDRPHY_084_DTEDR0;

typedef union {
  unsigned int w;
} S_DDRPHY_088_DTEDR1;

typedef union {
  unsigned int w;
  struct {
    unsigned int CWADDR         :  4;
    unsigned int CSADDR         :  4;
    unsigned int CSEL           :  2;
    unsigned int INCA           :  1;
    unsigned int ATYPE          :  1;
    unsigned int Reserved_31_12 : 20;
  } b;
} S_DDRPHY_0C0_DCUAR;

typedef union {
  unsigned int w;
  struct {
    unsigned int CDATA : 32;
  } b;
} S_DDRPHY_0C4_DCUDR;

typedef union {
  unsigned int w;
  struct {
    unsigned int DINST          : 4;
    unsigned int SADDR          : 4;
    unsigned int EADDR          : 4;
    unsigned int NFAIL          : 8;
    unsigned int SONF           : 1;
    unsigned int SCOF           : 1;
    unsigned int RCEN           : 1;
    unsigned int XCEN           : 1;
    unsigned int Reserved_31_24 : 8;
  } b;
} S_DDRPHY_0C8_DCURR;

typedef union {
  unsigned int w;
  struct {
    unsigned int LSADDR         :  4;
    unsigned int LEADDR         :  4;
    unsigned int LCNT           :  8;
    unsigned int LINF           :  1;
    unsigned int IDA            :  1;
    unsigned int Reserved_27_18 : 10;
    unsigned int XLEADDR        :  4;
  } b;
} S_DDRPHY_0CC_DCULR;

typedef union {
  unsigned int w;
  struct {
    unsigned int RCSW           : 16;
    unsigned int Reserved_31_16 : 16;
  } b;
} S_DDRPHY_0D0_DCUGCR;

typedef union {
  unsigned int w;
  struct {
    unsigned int tDCUT0 : 8;
    unsigned int tDCUT1 : 8;
    unsigned int tDCUT2 : 8;
    unsigned int tDCUT3 : 8;
  } b;
} S_DDRPHY_0D4_DCUTPR;

typedef union {
  unsigned int w;
  struct {
    unsigned int RDONE         :  1;
    unsigned int CFAIL         :  1;
    unsigned int CFULL         :  1;
    unsigned int Reserved_31_3 : 29;
  } b;
} S_DDRPHY_0D8_DCUSR0;

typedef union {
  unsigned int w;
  struct {
    unsigned int RDCNT : 16;
    unsigned int FLCNT :  8;
    unsigned int LPCNT :  8;
  } b;
} S_DDRPHY_0DC_DCUSR1;

typedef union {
  unsigned int w;
  struct {
    unsigned int BINST          : 3;
    unsigned int BMODE          : 1;
    unsigned int BINF           : 1;
    unsigned int NFAIL          : 8;
    unsigned int BSONF          : 1;
    unsigned int BDXEN          : 1;
    unsigned int BACEN          : 1;
    unsigned int BDMEN          : 1;
    unsigned int BDPAT          : 2;
    unsigned int BDXSEL         : 4;
    unsigned int BCKSEL         : 2;
    unsigned int BCCSEL         : 2;
    unsigned int Reserved_31_27 : 5;
  } b;
} S_DDRPHY_100_BISTRR;

typedef union {
  unsigned int w;
  struct {
    unsigned int BWCNT          : 16;
    unsigned int Reserved_31_16 : 16;
  } b;
} S_DDRPHY_104_BISTWCR;

typedef union {
  unsigned int w;
} S_DDRPHY_108_BISTMSKR0;

typedef union {
  unsigned int w;
} S_DDRPHY_10C_BISTMSKR1;

typedef union {
  unsigned int w;
} S_DDRPHY_110_BISTMSKR2;

typedef union {
  unsigned int w;
} S_DDRPHY_114_BISTLSR;

typedef union {
  unsigned int w;
  struct {
    unsigned int BCOL        : 12;
    unsigned int BROW        : 16;
    unsigned int BBANK       :  3;
    unsigned int Reserved_31 :  1;
  } b;
} S_DDRPHY_118_BISTAR0;

typedef union {
  unsigned int w;
  struct {
    unsigned int BRANK          : 2;
    unsigned int BMRANK         : 2;
    unsigned int BAINC          : 12;
    unsigned int Reserved_31_16 : 16;
  } b;
} S_DDRPHY_11C_BISTAR1;

typedef union {
  unsigned int w;
  struct {
    unsigned int BMCOL       : 12;
    unsigned int BMROW       : 16;
    unsigned int BMBANK      :  3;
    unsigned int Reserved_31 :  1;
  } b;
} S_DDRPHY_120_BISTAR2;

typedef union {
  unsigned int w;
} S_DDRPHY_124_BISTUDPR;

typedef union {
  unsigned int w;
  struct {
    unsigned int BDONE         : 1;
    unsigned int BACERR        : 1;
    unsigned int BDXERR        : 1;
    unsigned int Reserved_19_3 : 17;
    unsigned int DMBER         : 8;
    unsigned int RASBER        : 2;
    unsigned int CASBER        : 2;
  } b;
} S_DDRPHY_128_BISTGSR;

typedef union {
  unsigned int w;
} S_DDRPHY_12C_BISTWER;

typedef union {
  unsigned int w;
} S_DDRPHY_130_BISTBER0;

typedef union {
  unsigned int w;
} S_DDRPHY_134_BISTBER1;

typedef union {
  unsigned int w;
} S_DDRPHY_138_BISTBER2;

typedef union {
  unsigned int w;
} S_DDRPHY_13C_BISTBER3;

typedef union {
  unsigned int w;
} S_DDRPHY_140_BISTWCSR;

typedef union {
  unsigned int w;
} S_DDRPHY_144_BISTFWR0;

typedef union {
  unsigned int w;
} S_DDRPHY_148_BISTFWR1;

typedef union {
  unsigned int w;
} S_DDRPHY_14C_BISTFWR2;

typedef union {
  unsigned int w;
} S_DDRPHY_178_GPR0;

typedef union {
  unsigned int w;
} S_DDRPHY_17C_GPR1;

typedef union {
  unsigned int w;
} S_DDRPHY_180_ZQ0CR0;

typedef union {
  unsigned int w;
} S_DDRPHY_184_ZQ0CR1;

typedef union {
  unsigned int w;
} S_DDRPHY_188_ZQ0SR0;

typedef union {
  unsigned int w;
} S_DDRPHY_18C_ZQ0SR1;

typedef union {
  unsigned int w;
} S_DDRPHY_190_ZQ1CR0;

typedef union {
  unsigned int w;
} S_DDRPHY_194_ZQ1CR1;

typedef union {
  unsigned int w;
} S_DDRPHY_198_ZQ1SR0;

typedef union {
  unsigned int w;
} S_DDRPHY_19C_ZQ1SR1;

typedef union {
  unsigned int w;
} S_DDRPHY_1A0_ZQ2CR0;

typedef union {
  unsigned int w;
} S_DDRPHY_1A4_ZQ2CR1;

typedef union {
  unsigned int w;
} S_DDRPHY_1A8_ZQ3SR0;

typedef union {
  unsigned int w;
} S_DDRPHY_1AC_ZQ3SR1;

typedef union {
  unsigned int w;
} S_DDRPHY_1B0_ZQ3CR0;

typedef union {
  unsigned int w;
} S_DDRPHY_1B4_ZQ3CR1;

typedef union {
  unsigned int w;
} S_DDRPHY_1B8_ZQ3SR0;

typedef union {
  unsigned int w;
} S_DDRPHY_1BC_ZQ3SR1;

typedef union {
  unsigned int w;
} S_DDRPHY_1C0_DX0GCR;

typedef union {
  unsigned int w;
  struct {
    unsigned int WDQCAL   : 1;
    unsigned int RDQSCAL  : 1;
    unsigned int RDQSNCAL : 1;
    unsigned int GDQSCAL  : 1;
    unsigned int WLCAL    : 1;
    unsigned int WLDONE   : 1;
    unsigned int WLERR    : 1;
    unsigned int WLPRD    : 8;
    unsigned int DPLOCK   : 1;
    unsigned int GDQSPRD  : 8;
    unsigned int QSGERR   : 4;
    unsigned int WEYEWN   : 1;
    unsigned int WBDWN    : 1;
    unsigned int DTERR    : 1;
    unsigned int ___1     : 1;
  } b;
} S_DDRPHY_1C4_DX0GSR0;

typedef union {
  unsigned int w;
} S_DDRPHY_1C8_DX0GSR1;

typedef union {
  unsigned int w;
} S_DDRPHY_1CC_DX0BDLR0;

typedef union {
  unsigned int w;
} S_DDRPHY_1D0_DX0BDLR1;

typedef union {
  unsigned int w;
} S_DDRPHY_1D4_DX0BDLR2;

typedef union {
  unsigned int w;
} S_DDRPHY_1D8_DX0BDLR3;

typedef union {
  unsigned int w;
} S_DDRPHY_1DC_DX0BDLR4;

typedef union {
  unsigned int w;
} S_DDRPHY_1E0_DX0LCDLR0;

typedef union {
  unsigned int w;
} S_DDRPHY_1E4_DX0LCDLR1;

typedef union {
  unsigned int w;
} S_DDRPHY_1E8_DX0LCDLR2;

typedef union {
  unsigned int w;
} S_DDRPHY_1EC_DX0MDLR;

typedef union {
  struct {
    unsigned int R0DGSL         : 3;
    unsigned int R1DGSL         : 3;
    unsigned int R2DGSL         : 3;
    unsigned int R3DGSL         : 3;
    unsigned int R0WLSL         : 2;
    unsigned int R1WLSL         : 2;
    unsigned int R2WLSL         : 2;
    unsigned int R3WLSL         : 2;
    unsigned int Reserved_31_20 : 12;
  } b;
  unsigned int w;
} S_DDRPHY_1F0_DX0GTR;

typedef union {
  unsigned int w;
} S_DDRPHY_200_DX1GCR;

typedef union {
  unsigned int w;
  struct {
    unsigned int WDQCAL   : 1;
    unsigned int RDQSCAL  : 1;
    unsigned int RDQSNCAL : 1;
    unsigned int GDQSCAL  : 1;
    unsigned int WLCAL    : 1;
    unsigned int WLDONE   : 1;
    unsigned int WLERR    : 1;
    unsigned int WLPRD    : 8;
    unsigned int DPLOCK   : 1;
    unsigned int GDQSPRD  : 8;
    unsigned int QSGERR   : 4;
    unsigned int WEYEWN   : 1;
    unsigned int WBDWN    : 1;
    unsigned int DTERR    : 1;
    unsigned int ___1     : 1;
  } b;
} S_DDRPHY_204_DX1GSR0;

typedef union {
  unsigned int w;
} S_DDRPHY_208_DX1GSR1;

typedef union {
  unsigned int w;
} S_DDRPHY_20C_DX1BDLR0;

typedef union {
  unsigned int w;
} S_DDRPHY_210_DX1BDLR1;

typedef union {
  unsigned int w;
} S_DDRPHY_214_DX1BDLR2;

typedef union {
  unsigned int w;
} S_DDRPHY_218_DX1BDLR3;

typedef union {
  unsigned int w;
} S_DDRPHY_21C_DX1BDLR4;

typedef union {
  unsigned int w;
} S_DDRPHY_220_DX1LCDLR0;

typedef union {
  unsigned int w;
} S_DDRPHY_224_DX1LCDLR1;

typedef union {
  unsigned int w;
} S_DDRPHY_228_DX1LCDLR2;

typedef union {
  unsigned int w;
} S_DDRPHY_22C_DX1MDLR;

typedef union {
  struct {
    unsigned int R0DGSL         : 3;
    unsigned int R1DGSL         : 3;
    unsigned int R2DGSL         : 3;
    unsigned int R3DGSL         : 3;
    unsigned int R0WLSL         : 2;
    unsigned int R1WLSL         : 2;
    unsigned int R2WLSL         : 2;
    unsigned int R3WLSL         : 2;
    unsigned int Reserved_31_20 : 12;
  } b;
  unsigned int w;
} S_DDRPHY_230_DX1GTR;

typedef union {
  unsigned int w;
} S_DDRPHY_240_DX2GCR;

typedef union {
  unsigned int w;
} S_DDRPHY_244_DX2GSR0;

typedef union {
  unsigned int w;
} S_DDRPHY_248_DX2GSR1;

typedef union {
  unsigned int w;
} S_DDRPHY_24C_DX2BDLR0;

typedef union {
  unsigned int w;
} S_DDRPHY_250_DX2BDLR1;

typedef union {
  unsigned int w;
} S_DDRPHY_254_DX2BDLR2;

typedef union {
  unsigned int w;
} S_DDRPHY_258_DX2BDLR3;

typedef union {
  unsigned int w;
} S_DDRPHY_25C_DX2BDLR4;

typedef union {
  unsigned int w;
} S_DDRPHY_260_DX2LCDLR0;

typedef union {
  unsigned int w;
} S_DDRPHY_264_DX2LCDLR1;

typedef union {
  unsigned int w;
} S_DDRPHY_268_DX2LCDLR2;

typedef union {
  unsigned int w;
} S_DDRPHY_26C_DX2MDLR;

typedef union {
  unsigned int w;
} S_DDRPHY_270_DX2GTR;

typedef union {
  unsigned int w;
} S_DDRPHY_280_DX3GCR;

typedef union {
  unsigned int w;
} S_DDRPHY_284_DX3GSR0;

typedef union {
  unsigned int w;
} S_DDRPHY_288_DX3GSR1;

typedef union {
  unsigned int w;
} S_DDRPHY_28C_DX3BDLR0;

typedef union {
  unsigned int w;
} S_DDRPHY_290_DX3BDLR1;

typedef union {
  unsigned int w;
} S_DDRPHY_294_DX3BDLR2;

typedef union {
  unsigned int w;
} S_DDRPHY_298_DX3BDLR3;

typedef union {
  unsigned int w;
} S_DDRPHY_29C_DX3BDLR4;

typedef union {
  unsigned int w;
} S_DDRPHY_2A0_DX3LCDLR0;

typedef union {
  unsigned int w;
} S_DDRPHY_2A4_DX3LCDLR1;

typedef union {
  unsigned int w;
} S_DDRPHY_2A8_DX3LCDLR2;

typedef union {
  unsigned int w;
} S_DDRPHY_2AC_DX3MDLR;

typedef union {
  unsigned int w;
} S_DDRPHY_2B0_DX3GTR;

typedef union {
  unsigned int w;
} S_DDRPHY_2C0_DX4GCR;

typedef union {
  unsigned int w;
} S_DDRPHY_2C4_DX4GSR0;

typedef union {
  unsigned int w;
} S_DDRPHY_2C8_DX4GSR1;

typedef union {
  unsigned int w;
} S_DDRPHY_2CC_DX4BDLR0;

typedef union {
  unsigned int w;
} S_DDRPHY_2D0_DX4BDLR1;

typedef union {
  unsigned int w;
} S_DDRPHY_2D4_DX4BDLR2;

typedef union {
  unsigned int w;
} S_DDRPHY_2D8_DX4BDLR3;

typedef union {
  unsigned int w;
} S_DDRPHY_2DC_DX4BDLR4;

typedef union {
  unsigned int w;
} S_DDRPHY_2E0_DX4LCDLR0;

typedef union {
  unsigned int w;
} S_DDRPHY_2E4_DX4LCDLR1;

typedef union {
  unsigned int w;
} S_DDRPHY_2E8_DX4LCDLR2;

typedef union {
  unsigned int w;
} S_DDRPHY_2EC_DX4MDLR;

typedef union {
  unsigned int w;
} S_DDRPHY_2F0_DX4GTR;

typedef union {
  unsigned int w;
} S_DDRPHY_300_DX5GCR;

typedef union {
  unsigned int w;
} S_DDRPHY_304_DX5GSR0;

typedef union {
  unsigned int w;
} S_DDRPHY_308_DX5GSR1;

typedef union {
  unsigned int w;
} S_DDRPHY_30C_DX5BDLR0;

typedef union {
  unsigned int w;
} S_DDRPHY_310_DX5BDLR1;

typedef union {
  unsigned int w;
} S_DDRPHY_314_DX5BDLR2;

typedef union {
  unsigned int w;
} S_DDRPHY_318_DX5BDLR3;

typedef union {
  unsigned int w;
} S_DDRPHY_31C_DX5BDLR4;

typedef union {
  unsigned int w;
} S_DDRPHY_320_DX5LCDLR0;

typedef union {
  unsigned int w;
} S_DDRPHY_324_DX5LCDLR1;

typedef union {
  unsigned int w;
} S_DDRPHY_328_DX5LCDLR2;

typedef union {
  unsigned int w;
} S_DDRPHY_32C_DX5MDLR;

typedef union {
  unsigned int w;
} S_DDRPHY_330_DX5GTR;

typedef union {
  unsigned int w;
} S_DDRPHY_340_DX6GCR;

typedef union {
  unsigned int w;
} S_DDRPHY_344_DX6GSR0;

typedef union {
  unsigned int w;
} S_DDRPHY_348_DX6GSR1;

typedef union {
  unsigned int w;
} S_DDRPHY_34C_DX6BDLR0;

typedef union {
  unsigned int w;
} S_DDRPHY_350_DX6BDLR1;

typedef union {
  unsigned int w;
} S_DDRPHY_354_DX6BDLR2;

typedef union {
  unsigned int w;
} S_DDRPHY_358_DX6BDLR3;

typedef union {
  unsigned int w;
} S_DDRPHY_35C_DX6BDLR4;

typedef union {
  unsigned int w;
} S_DDRPHY_360_DX6LCDLR0;

typedef union {
  unsigned int w;
} S_DDRPHY_364_DX6LCDLR1;

typedef union {
  unsigned int w;
} S_DDRPHY_368_DX6LCDLR2;

typedef union {
  unsigned int w;
} S_DDRPHY_36C_DX6MDLR;

typedef union {
  unsigned int w;
} S_DDRPHY_370_DX6GTR;

typedef union {
  unsigned int w;
} S_DDRPHY_380_DX7GCR;

typedef union {
  unsigned int w;
} S_DDRPHY_384_DX7GSR0;

typedef union {
  unsigned int w;
} S_DDRPHY_388_DX7GSR1;

typedef union {
  unsigned int w;
} S_DDRPHY_38C_DX7BDLR0;

typedef union {
  unsigned int w;
} S_DDRPHY_390_DX7BDLR1;

typedef union {
  unsigned int w;
} S_DDRPHY_394_DX7BDLR2;

typedef union {
  unsigned int w;
} S_DDRPHY_398_DX7BDLR3;

typedef union {
  unsigned int w;
} S_DDRPHY_39C_DX7BDLR4;

typedef union {
  unsigned int w;
} S_DDRPHY_3A0_DX7LCDLR0;

typedef union {
  unsigned int w;
} S_DDRPHY_3A4_DX7LCDLR1;

typedef union {
  unsigned int w;
} S_DDRPHY_3A8_DX7LCDLR2;

typedef union {
  unsigned int w;
} S_DDRPHY_3AC_DX7MDLR;

typedef union {
  unsigned int w;
} S_DDRPHY_3B0_DX7GTR;

typedef union {
  unsigned int w;
} S_DDRPHY_3C0_DX8GCR;

typedef union {
  unsigned int w;
} S_DDRPHY_3C4_DX8GSR0;

typedef union {
  unsigned int w;
} S_DDRPHY_3C8_DX8GSR1;

typedef union {
  unsigned int w;
} S_DDRPHY_3CC_DX8BDLR0;

typedef union {
  unsigned int w;
} S_DDRPHY_3D0_DX8BDLR1;

typedef union {
  unsigned int w;
} S_DDRPHY_3D4_DX8BDLR2;

typedef union {
  unsigned int w;
} S_DDRPHY_3D8_DX8BDLR3;

typedef union {
  unsigned int w;
} S_DDRPHY_3DC_DX8BDLR4;

typedef union {
  unsigned int w;
} S_DDRPHY_3E0_DX8LCDLR0;

typedef union {
  unsigned int w;
} S_DDRPHY_3E4_DX8LCDLR1;

typedef union {
  unsigned int w;
} S_DDRPHY_3E8_DX8LCDLR2;

typedef union {
  unsigned int w;
} S_DDRPHY_3EC_DX8MDLR;

typedef union {
  unsigned int w;
} S_DDRPHY_3F0_DX8GTR;

#define REG_DDRPHY_000_RIDR(base)      (*(volatile S_DDRPHY_000_RIDR      *)(base + 0x000))
#define REG_DDRPHY_004_PIR(base)       (*(volatile S_DDRPHY_004_PIR       *)(base + 0x004))
#define REG_DDRPHY_008_PGCR0(base)     (*(volatile S_DDRPHY_008_PGCR0     *)(base + 0x008))
#define REG_DDRPHY_00C_PGCR1(base)     (*(volatile S_DDRPHY_00C_PGCR1     *)(base + 0x00C))
#define REG_DDRPHY_010_PGSR0(base)     (*(volatile S_DDRPHY_010_PGSR0     *)(base + 0x010))
#define REG_DDRPHY_014_PGSR1(base)     (*(volatile S_DDRPHY_014_PGSR1     *)(base + 0x014))
#define REG_DDRPHY_018_PLLCR(base)     (*(volatile S_DDRPHY_018_PLLCR     *)(base + 0x018))
#define REG_DDRPHY_01C_PTR0(base)      (*(volatile S_DDRPHY_01C_PTR0      *)(base + 0x01C))
#define REG_DDRPHY_020_PTR1(base)      (*(volatile S_DDRPHY_020_PTR1      *)(base + 0x020))
#define REG_DDRPHY_024_PTR2(base)      (*(volatile S_DDRPHY_024_PTR2      *)(base + 0x024))
#define REG_DDRPHY_028_PTR3(base)      (*(volatile S_DDRPHY_028_PTR3      *)(base + 0x028))
#define REG_DDRPHY_02C_PTR4(base)      (*(volatile S_DDRPHY_02C_PTR4      *)(base + 0x02C))
#define REG_DDRPHY_030_ACMDLR(base)    (*(volatile S_DDRPHY_030_ACMDLR    *)(base + 0x030))
#define REG_DDRPHY_034_ACBDLR(base)    (*(volatile S_DDRPHY_034_ACBDLR    *)(base + 0x034))
#define REG_DDRPHY_038_ACIOCR(base)    (*(volatile S_DDRPHY_038_ACIOCR    *)(base + 0x038))
#define REG_DDRPHY_03C_DXCCR(base)     (*(volatile S_DDRPHY_03C_DXCCR     *)(base + 0x03C))
#define REG_DDRPHY_040_DSGCR(base)     (*(volatile S_DDRPHY_040_DSGCR     *)(base + 0x040))
#define REG_DDRPHY_044_DCR(base)       (*(volatile S_DDRPHY_044_DCR       *)(base + 0x044))
#define REG_DDRPHY_048_DTPR0(base)     (*(volatile S_DDRPHY_048_DTPR0     *)(base + 0x048))
#define REG_DDRPHY_04C_DTPR1(base)     (*(volatile S_DDRPHY_04C_DTPR1     *)(base + 0x04C))
#define REG_DDRPHY_050_DTPR2(base)     (*(volatile S_DDRPHY_050_DTPR2     *)(base + 0x050))
#define REG_DDRPHY_054_MR0(base)       (*(volatile S_DDRPHY_054_MR0       *)(base + 0x054))
#define REG_DDRPHY_058_MR1(base)       (*(volatile S_DDRPHY_058_MR1       *)(base + 0x058))
#define REG_DDRPHY_05C_MR2(base)       (*(volatile S_DDRPHY_05C_MR2       *)(base + 0x05C))
#define REG_DDRPHY_060_MR3(base)       (*(volatile S_DDRPHY_060_MR3       *)(base + 0x060))
#define REG_DDRPHY_064_ODTCR(base)     (*(volatile S_DDRPHY_064_ODTCR     *)(base + 0x064))
#define REG_DDRPHY_068_DTCR(base)      (*(volatile S_DDRPHY_068_DTCR      *)(base + 0x068))
#define REG_DDRPHY_06C_DTAR0(base)     (*(volatile S_DDRPHY_06C_DTAR0     *)(base + 0x06C))
#define REG_DDRPHY_070_DTAR1(base)     (*(volatile S_DDRPHY_070_DTAR1     *)(base + 0x070))
#define REG_DDRPHY_074_DTAR2(base)     (*(volatile S_DDRPHY_074_DTAR2     *)(base + 0x074))
#define REG_DDRPHY_078_DTAR3(base)     (*(volatile S_DDRPHY_078_DTAR3     *)(base + 0x078))
#define REG_DDRPHY_07C_DTDR0(base)     (*(volatile S_DDRPHY_07C_DTDR0     *)(base + 0x07C))
#define REG_DDRPHY_080_DTDR1(base)     (*(volatile S_DDRPHY_080_DTDR1     *)(base + 0x080))
#define REG_DDRPHY_084_DTEDR0(base)    (*(volatile S_DDRPHY_084_DTEDR0    *)(base + 0x084))
#define REG_DDRPHY_088_DTEDR1(base)    (*(volatile S_DDRPHY_088_DTEDR1    *)(base + 0x088))
#define REG_DDRPHY_0C0_DCUAR(base)     (*(volatile S_DDRPHY_0C0_DCUAR     *)(base + 0x0C0))
#define REG_DDRPHY_0C4_DCUDR(base)     (*(volatile S_DDRPHY_0C4_DCUDR     *)(base + 0x0C4))
#define REG_DDRPHY_0C8_DCURR(base)     (*(volatile S_DDRPHY_0C8_DCURR     *)(base + 0x0C8))
#define REG_DDRPHY_0CC_DCULR(base)     (*(volatile S_DDRPHY_0CC_DCULR     *)(base + 0x0CC))
#define REG_DDRPHY_0D0_DCUGCR(base)    (*(volatile S_DDRPHY_0D0_DCUGCR    *)(base + 0x0D0))
#define REG_DDRPHY_0D4_DCUTPR(base)    (*(volatile S_DDRPHY_0D4_DCUTPR    *)(base + 0x0D4))
#define REG_DDRPHY_0D8_DCUSR0(base)    (*(volatile S_DDRPHY_0D8_DCUSR0    *)(base + 0x0D8))
#define REG_DDRPHY_0DC_DCUSR1(base)    (*(volatile S_DDRPHY_0DC_DCUSR1    *)(base + 0x0DC))
#define REG_DDRPHY_100_BISTRR(base)    (*(volatile S_DDRPHY_100_BISTRR    *)(base + 0x100))
#define REG_DDRPHY_104_BISTWCR(base)   (*(volatile S_DDRPHY_104_BISTWCR   *)(base + 0x104))
#define REG_DDRPHY_108_BISTMSKR0(base) (*(volatile S_DDRPHY_108_BISTMSKR0 *)(base + 0x108))
#define REG_DDRPHY_10C_BISTMSKR1(base) (*(volatile S_DDRPHY_10C_BISTMSKR1 *)(base + 0x10C))
#define REG_DDRPHY_110_BISTMSKR2(base) (*(volatile S_DDRPHY_110_BISTMSKR2 *)(base + 0x110))
#define REG_DDRPHY_114_BISTLSR(base)   (*(volatile S_DDRPHY_114_BISTLSR   *)(base + 0x114))
#define REG_DDRPHY_118_BISTAR0(base)   (*(volatile S_DDRPHY_118_BISTAR0   *)(base + 0x118))
#define REG_DDRPHY_11C_BISTAR1(base)   (*(volatile S_DDRPHY_11C_BISTAR1   *)(base + 0x11C))
#define REG_DDRPHY_120_BISTAR2(base)   (*(volatile S_DDRPHY_120_BISTAR2   *)(base + 0x120))
#define REG_DDRPHY_124_BISTUDPR(base)  (*(volatile S_DDRPHY_124_BISTUDPR  *)(base + 0x124))
#define REG_DDRPHY_128_BISTGSR(base)   (*(volatile S_DDRPHY_128_BISTGSR   *)(base + 0x128))
#define REG_DDRPHY_12C_BISTWER(base)   (*(volatile S_DDRPHY_12C_BISTWER   *)(base + 0x12C))
#define REG_DDRPHY_130_BISTBER0(base)  (*(volatile S_DDRPHY_130_BISTBER0  *)(base + 0x130))
#define REG_DDRPHY_134_BISTBER1(base)  (*(volatile S_DDRPHY_134_BISTBER1  *)(base + 0x134))
#define REG_DDRPHY_138_BISTBER2(base)  (*(volatile S_DDRPHY_138_BISTBER2  *)(base + 0x138))
#define REG_DDRPHY_13C_BISTBER3(base)  (*(volatile S_DDRPHY_13C_BISTBER3  *)(base + 0x13C))
#define REG_DDRPHY_140_BISTWCSR(base)  (*(volatile S_DDRPHY_140_BISTWCSR  *)(base + 0x140))
#define REG_DDRPHY_144_BISTFWR0(base)  (*(volatile S_DDRPHY_144_BISTFWR0  *)(base + 0x144))
#define REG_DDRPHY_148_BISTFWR1(base)  (*(volatile S_DDRPHY_148_BISTFWR1  *)(base + 0x148))
#define REG_DDRPHY_14C_BISTFWR2(base)  (*(volatile S_DDRPHY_14C_BISTFWR2  *)(base + 0x14C))
#define REG_DDRPHY_178_GPR0(base)      (*(volatile S_DDRPHY_178_GPR0      *)(base + 0x178))
#define REG_DDRPHY_17C_GPR1(base)      (*(volatile S_DDRPHY_17C_GPR1      *)(base + 0x17C))
#define REG_DDRPHY_180_ZQ0CR0(base)    (*(volatile S_DDRPHY_180_ZQ0CR0    *)(base + 0x180))
#define REG_DDRPHY_184_ZQ0CR1(base)    (*(volatile S_DDRPHY_184_ZQ0CR1    *)(base + 0x184))
#define REG_DDRPHY_188_ZQ0SR0(base)    (*(volatile S_DDRPHY_188_ZQ0SR0    *)(base + 0x188))
#define REG_DDRPHY_18C_ZQ0SR1(base)    (*(volatile S_DDRPHY_18C_ZQ0SR1    *)(base + 0x18C))
#define REG_DDRPHY_190_ZQ1CR0(base)    (*(volatile S_DDRPHY_190_ZQ1CR0    *)(base + 0x190))
#define REG_DDRPHY_194_ZQ1CR1(base)    (*(volatile S_DDRPHY_194_ZQ1CR1    *)(base + 0x194))
#define REG_DDRPHY_198_ZQ1SR0(base)    (*(volatile S_DDRPHY_198_ZQ1SR0    *)(base + 0x198))
#define REG_DDRPHY_19C_ZQ1SR1(base)    (*(volatile S_DDRPHY_19C_ZQ1SR1    *)(base + 0x19C))
#define REG_DDRPHY_1A0_ZQ2CR0(base)    (*(volatile S_DDRPHY_1A0_ZQ2CR0    *)(base + 0x1A0))
#define REG_DDRPHY_1A4_ZQ2CR1(base)    (*(volatile S_DDRPHY_1A4_ZQ2CR1    *)(base + 0x1A4))
#define REG_DDRPHY_1A8_ZQ3SR0(base)    (*(volatile S_DDRPHY_1A8_ZQ3SR0    *)(base + 0x1A8))
#define REG_DDRPHY_1AC_ZQ3SR1(base)    (*(volatile S_DDRPHY_1AC_ZQ3SR1    *)(base + 0x1AC))
#define REG_DDRPHY_1B0_ZQ3CR0(base)    (*(volatile S_DDRPHY_1B0_ZQ3CR0    *)(base + 0x1B0))
#define REG_DDRPHY_1B4_ZQ3CR1(base)    (*(volatile S_DDRPHY_1B4_ZQ3CR1    *)(base + 0x1B4))
#define REG_DDRPHY_1B8_ZQ3SR0(base)    (*(volatile S_DDRPHY_1B8_ZQ3SR0    *)(base + 0x1B8))
#define REG_DDRPHY_1BC_ZQ3SR1(base)    (*(volatile S_DDRPHY_1BC_ZQ3SR1    *)(base + 0x1BC))
#define REG_DDRPHY_1C0_DX0GCR(base)    (*(volatile S_DDRPHY_1C0_DX0GCR    *)(base + 0x1C0))
#define REG_DDRPHY_1C4_DX0GSR0(base)   (*(volatile S_DDRPHY_1C4_DX0GSR0   *)(base + 0x1C4))
#define REG_DDRPHY_1C8_DX0GSR1(base)   (*(volatile S_DDRPHY_1C8_DX0GSR1   *)(base + 0x1C8))
#define REG_DDRPHY_1CC_DX0BDLR0(base)  (*(volatile S_DDRPHY_1CC_DX0BDLR0  *)(base + 0x1CC))
#define REG_DDRPHY_1D0_DX0BDLR1(base)  (*(volatile S_DDRPHY_1D0_DX0BDLR1  *)(base + 0x1D0))
#define REG_DDRPHY_1D4_DX0BDLR2(base)  (*(volatile S_DDRPHY_1D4_DX0BDLR2  *)(base + 0x1D4))
#define REG_DDRPHY_1D8_DX0BDLR3(base)  (*(volatile S_DDRPHY_1D8_DX0BDLR3  *)(base + 0x1D8))
#define REG_DDRPHY_1DC_DX0BDLR4(base)  (*(volatile S_DDRPHY_1DC_DX0BDLR4  *)(base + 0x1DC))
#define REG_DDRPHY_1E0_DX0LCDLR0(base) (*(volatile S_DDRPHY_1E0_DX0LCDLR0 *)(base + 0x1E0))
#define REG_DDRPHY_1E4_DX0LCDLR1(base) (*(volatile S_DDRPHY_1E4_DX0LCDLR1 *)(base + 0x1E4))
#define REG_DDRPHY_1E8_DX0LCDLR2(base) (*(volatile S_DDRPHY_1E8_DX0LCDLR2 *)(base + 0x1E8))
#define REG_DDRPHY_1EC_DX0MDLR(base)   (*(volatile S_DDRPHY_1EC_DX0MDLR   *)(base + 0x1EC))
#define REG_DDRPHY_1F0_DX0GTR(base)    (*(volatile S_DDRPHY_1F0_DX0GTR    *)(base + 0x1F0))
#define REG_DDRPHY_200_DX1GCR(base)    (*(volatile S_DDRPHY_200_DX1GCR    *)(base + 0x200))
#define REG_DDRPHY_204_DX1GSR0(base)   (*(volatile S_DDRPHY_204_DX1GSR0   *)(base + 0x204))
#define REG_DDRPHY_208_DX1GSR1(base)   (*(volatile S_DDRPHY_208_DX1GSR1   *)(base + 0x208))
#define REG_DDRPHY_20C_DX1BDLR0(base)  (*(volatile S_DDRPHY_20C_DX1BDLR0  *)(base + 0x20C))
#define REG_DDRPHY_210_DX1BDLR1(base)  (*(volatile S_DDRPHY_210_DX1BDLR1  *)(base + 0x210))
#define REG_DDRPHY_214_DX1BDLR2(base)  (*(volatile S_DDRPHY_214_DX1BDLR2  *)(base + 0x214))
#define REG_DDRPHY_218_DX1BDLR3(base)  (*(volatile S_DDRPHY_218_DX1BDLR3  *)(base + 0x218))
#define REG_DDRPHY_21C_DX1BDLR4(base)  (*(volatile S_DDRPHY_21C_DX1BDLR4  *)(base + 0x21C))
#define REG_DDRPHY_220_DX1LCDLR0(base) (*(volatile S_DDRPHY_220_DX1LCDLR0 *)(base + 0x220))
#define REG_DDRPHY_224_DX1LCDLR1(base) (*(volatile S_DDRPHY_224_DX1LCDLR1 *)(base + 0x224))
#define REG_DDRPHY_228_DX1LCDLR2(base) (*(volatile S_DDRPHY_228_DX1LCDLR2 *)(base + 0x228))
#define REG_DDRPHY_22C_DX1MDLR(base)   (*(volatile S_DDRPHY_22C_DX1MDLR   *)(base + 0x22C))
#define REG_DDRPHY_230_DX1GTR(base)    (*(volatile S_DDRPHY_230_DX1GTR    *)(base + 0x230))
#define REG_DDRPHY_240_DX2GCR(base)    (*(volatile S_DDRPHY_240_DX2GCR    *)(base + 0x240))
#define REG_DDRPHY_244_DX2GSR0(base)   (*(volatile S_DDRPHY_244_DX2GSR0   *)(base + 0x244))
#define REG_DDRPHY_248_DX2GSR1(base)   (*(volatile S_DDRPHY_248_DX2GSR1   *)(base + 0x248))
#define REG_DDRPHY_24C_DX2BDLR0(base)  (*(volatile S_DDRPHY_24C_DX2BDLR0  *)(base + 0x24C))
#define REG_DDRPHY_250_DX2BDLR1(base)  (*(volatile S_DDRPHY_250_DX2BDLR1  *)(base + 0x250))
#define REG_DDRPHY_254_DX2BDLR2(base)  (*(volatile S_DDRPHY_254_DX2BDLR2  *)(base + 0x254))
#define REG_DDRPHY_258_DX2BDLR3(base)  (*(volatile S_DDRPHY_258_DX2BDLR3  *)(base + 0x258))
#define REG_DDRPHY_25C_DX2BDLR4(base)  (*(volatile S_DDRPHY_25C_DX2BDLR4  *)(base + 0x25C))
#define REG_DDRPHY_260_DX2LCDLR0(base) (*(volatile S_DDRPHY_260_DX2LCDLR0 *)(base + 0x260))
#define REG_DDRPHY_264_DX2LCDLR1(base) (*(volatile S_DDRPHY_264_DX2LCDLR1 *)(base + 0x264))
#define REG_DDRPHY_268_DX2LCDLR2(base) (*(volatile S_DDRPHY_268_DX2LCDLR2 *)(base + 0x268))
#define REG_DDRPHY_26C_DX2MDLR(base)   (*(volatile S_DDRPHY_26C_DX2MDLR   *)(base + 0x26C))
#define REG_DDRPHY_270_DX2GTR(base)    (*(volatile S_DDRPHY_270_DX2GTR    *)(base + 0x270))
#define REG_DDRPHY_280_DX3GCR(base)    (*(volatile S_DDRPHY_280_DX3GCR    *)(base + 0x280))
#define REG_DDRPHY_284_DX3GSR0(base)   (*(volatile S_DDRPHY_284_DX3GSR0   *)(base + 0x284))
#define REG_DDRPHY_288_DX3GSR1(base)   (*(volatile S_DDRPHY_288_DX3GSR1   *)(base + 0x288))
#define REG_DDRPHY_28C_DX3BDLR0(base)  (*(volatile S_DDRPHY_28C_DX3BDLR0  *)(base + 0x28C))
#define REG_DDRPHY_290_DX3BDLR1(base)  (*(volatile S_DDRPHY_290_DX3BDLR1  *)(base + 0x290))
#define REG_DDRPHY_294_DX3BDLR2(base)  (*(volatile S_DDRPHY_294_DX3BDLR2  *)(base + 0x294))
#define REG_DDRPHY_298_DX3BDLR3(base)  (*(volatile S_DDRPHY_298_DX3BDLR3  *)(base + 0x298))
#define REG_DDRPHY_29C_DX3BDLR4(base)  (*(volatile S_DDRPHY_29C_DX3BDLR4  *)(base + 0x29C))
#define REG_DDRPHY_2A0_DX3LCDLR0(base) (*(volatile S_DDRPHY_2A0_DX3LCDLR0 *)(base + 0x2A0))
#define REG_DDRPHY_2A4_DX3LCDLR1(base) (*(volatile S_DDRPHY_2A4_DX3LCDLR1 *)(base + 0x2A4))
#define REG_DDRPHY_2A8_DX3LCDLR2(base) (*(volatile S_DDRPHY_2A8_DX3LCDLR2 *)(base + 0x2A8))
#define REG_DDRPHY_2AC_DX3MDLR(base)   (*(volatile S_DDRPHY_2AC_DX3MDLR   *)(base + 0x2AC))
#define REG_DDRPHY_2B0_DX3GTR(base)    (*(volatile S_DDRPHY_2B0_DX3GTR    *)(base + 0x2B0))
#define REG_DDRPHY_2C0_DX4GCR(base)    (*(volatile S_DDRPHY_2C0_DX4GCR    *)(base + 0x2C0))
#define REG_DDRPHY_2C4_DX4GSR0(base)   (*(volatile S_DDRPHY_2C4_DX4GSR0   *)(base + 0x2C4))
#define REG_DDRPHY_2C8_DX4GSR1(base)   (*(volatile S_DDRPHY_2C8_DX4GSR1   *)(base + 0x2C8))
#define REG_DDRPHY_2CC_DX4BDLR0(base)  (*(volatile S_DDRPHY_2CC_DX4BDLR0  *)(base + 0x2CC))
#define REG_DDRPHY_2D0_DX4BDLR1(base)  (*(volatile S_DDRPHY_2D0_DX4BDLR1  *)(base + 0x2D0))
#define REG_DDRPHY_2D4_DX4BDLR2(base)  (*(volatile S_DDRPHY_2D4_DX4BDLR2  *)(base + 0x2D4))
#define REG_DDRPHY_2D8_DX4BDLR3(base)  (*(volatile S_DDRPHY_2D8_DX4BDLR3  *)(base + 0x2D8))
#define REG_DDRPHY_2DC_DX4BDLR4(base)  (*(volatile S_DDRPHY_2DC_DX4BDLR4  *)(base + 0x2DC))
#define REG_DDRPHY_2E0_DX4LCDLR0(base) (*(volatile S_DDRPHY_2E0_DX4LCDLR0 *)(base + 0x2E0))
#define REG_DDRPHY_2E4_DX4LCDLR1(base) (*(volatile S_DDRPHY_2E4_DX4LCDLR1 *)(base + 0x2E4))
#define REG_DDRPHY_2E8_DX4LCDLR2(base) (*(volatile S_DDRPHY_2E8_DX4LCDLR2 *)(base + 0x2E8))
#define REG_DDRPHY_2EC_DX4MDLR(base)   (*(volatile S_DDRPHY_2EC_DX4MDLR   *)(base + 0x2EC))
#define REG_DDRPHY_2F0_DX4GTR(base)    (*(volatile S_DDRPHY_2F0_DX4GTR    *)(base + 0x2F0))
#define REG_DDRPHY_300_DX5GCR(base)    (*(volatile S_DDRPHY_300_DX5GCR    *)(base + 0x300))
#define REG_DDRPHY_304_DX5GSR0(base)   (*(volatile S_DDRPHY_304_DX5GSR0   *)(base + 0x304))
#define REG_DDRPHY_308_DX5GSR1(base)   (*(volatile S_DDRPHY_308_DX5GSR1   *)(base + 0x308))
#define REG_DDRPHY_30C_DX5BDLR0(base)  (*(volatile S_DDRPHY_30C_DX5BDLR0  *)(base + 0x30C))
#define REG_DDRPHY_310_DX5BDLR1(base)  (*(volatile S_DDRPHY_310_DX5BDLR1  *)(base + 0x310))
#define REG_DDRPHY_314_DX5BDLR2(base)  (*(volatile S_DDRPHY_314_DX5BDLR2  *)(base + 0x314))
#define REG_DDRPHY_318_DX5BDLR3(base)  (*(volatile S_DDRPHY_318_DX5BDLR3  *)(base + 0x318))
#define REG_DDRPHY_31C_DX5BDLR4(base)  (*(volatile S_DDRPHY_31C_DX5BDLR4  *)(base + 0x31C))
#define REG_DDRPHY_320_DX5LCDLR0(base) (*(volatile S_DDRPHY_320_DX5LCDLR0 *)(base + 0x320))
#define REG_DDRPHY_324_DX5LCDLR1(base) (*(volatile S_DDRPHY_324_DX5LCDLR1 *)(base + 0x324))
#define REG_DDRPHY_328_DX5LCDLR2(base) (*(volatile S_DDRPHY_328_DX5LCDLR2 *)(base + 0x328))
#define REG_DDRPHY_32C_DX5MDLR(base)   (*(volatile S_DDRPHY_32C_DX5MDLR   *)(base + 0x32C))
#define REG_DDRPHY_330_DX5GTR(base)    (*(volatile S_DDRPHY_330_DX5GTR    *)(base + 0x330))
#define REG_DDRPHY_340_DX6GCR(base)    (*(volatile S_DDRPHY_340_DX6GCR    *)(base + 0x340))
#define REG_DDRPHY_344_DX6GSR0(base)   (*(volatile S_DDRPHY_344_DX6GSR0   *)(base + 0x344))
#define REG_DDRPHY_348_DX6GSR1(base)   (*(volatile S_DDRPHY_348_DX6GSR1   *)(base + 0x348))
#define REG_DDRPHY_34C_DX6BDLR0(base)  (*(volatile S_DDRPHY_34C_DX6BDLR0  *)(base + 0x34C))
#define REG_DDRPHY_350_DX6BDLR1(base)  (*(volatile S_DDRPHY_350_DX6BDLR1  *)(base + 0x350))
#define REG_DDRPHY_354_DX6BDLR2(base)  (*(volatile S_DDRPHY_354_DX6BDLR2  *)(base + 0x354))
#define REG_DDRPHY_358_DX6BDLR3(base)  (*(volatile S_DDRPHY_358_DX6BDLR3  *)(base + 0x358))
#define REG_DDRPHY_35C_DX6BDLR4(base)  (*(volatile S_DDRPHY_35C_DX6BDLR4  *)(base + 0x35C))
#define REG_DDRPHY_360_DX6LCDLR0(base) (*(volatile S_DDRPHY_360_DX6LCDLR0 *)(base + 0x360))
#define REG_DDRPHY_364_DX6LCDLR1(base) (*(volatile S_DDRPHY_364_DX6LCDLR1 *)(base + 0x364))
#define REG_DDRPHY_368_DX6LCDLR2(base) (*(volatile S_DDRPHY_368_DX6LCDLR2 *)(base + 0x368))
#define REG_DDRPHY_36C_DX6MDLR(base)   (*(volatile S_DDRPHY_36C_DX6MDLR   *)(base + 0x36C))
#define REG_DDRPHY_370_DX6GTR(base)    (*(volatile S_DDRPHY_370_DX6GTR    *)(base + 0x370))
#define REG_DDRPHY_380_DX7GCR(base)    (*(volatile S_DDRPHY_380_DX7GCR    *)(base + 0x380))
#define REG_DDRPHY_384_DX7GSR0(base)   (*(volatile S_DDRPHY_384_DX7GSR0   *)(base + 0x384))
#define REG_DDRPHY_388_DX7GSR1(base)   (*(volatile S_DDRPHY_388_DX7GSR1   *)(base + 0x388))
#define REG_DDRPHY_38C_DX7BDLR0(base)  (*(volatile S_DDRPHY_38C_DX7BDLR0  *)(base + 0x38C))
#define REG_DDRPHY_390_DX7BDLR1(base)  (*(volatile S_DDRPHY_390_DX7BDLR1  *)(base + 0x390))
#define REG_DDRPHY_394_DX7BDLR2(base)  (*(volatile S_DDRPHY_394_DX7BDLR2  *)(base + 0x394))
#define REG_DDRPHY_398_DX7BDLR3(base)  (*(volatile S_DDRPHY_398_DX7BDLR3  *)(base + 0x398))
#define REG_DDRPHY_39C_DX7BDLR4(base)  (*(volatile S_DDRPHY_39C_DX7BDLR4  *)(base + 0x39C))
#define REG_DDRPHY_3A0_DX7LCDLR0(base) (*(volatile S_DDRPHY_3A0_DX7LCDLR0 *)(base + 0x3A0))
#define REG_DDRPHY_3A4_DX7LCDLR1(base) (*(volatile S_DDRPHY_3A4_DX7LCDLR1 *)(base + 0x3A4))
#define REG_DDRPHY_3A8_DX7LCDLR2(base) (*(volatile S_DDRPHY_3A8_DX7LCDLR2 *)(base + 0x3A8))
#define REG_DDRPHY_3AC_DX7MDLR(base)   (*(volatile S_DDRPHY_3AC_DX7MDLR   *)(base + 0x3AC))
#define REG_DDRPHY_3B0_DX7GTR(base)    (*(volatile S_DDRPHY_3B0_DX7GTR    *)(base + 0x3B0))
#define REG_DDRPHY_3C0_DX8GCR(base)    (*(volatile S_DDRPHY_3C0_DX8GCR    *)(base + 0x3C0))
#define REG_DDRPHY_3C4_DX8GSR0(base)   (*(volatile S_DDRPHY_3C4_DX8GSR0   *)(base + 0x3C4))
#define REG_DDRPHY_3C8_DX8GSR1(base)   (*(volatile S_DDRPHY_3C8_DX8GSR1   *)(base + 0x3C8))
#define REG_DDRPHY_3CC_DX8BDLR0(base)  (*(volatile S_DDRPHY_3CC_DX8BDLR0  *)(base + 0x3CC))
#define REG_DDRPHY_3D0_DX8BDLR1(base)  (*(volatile S_DDRPHY_3D0_DX8BDLR1  *)(base + 0x3D0))
#define REG_DDRPHY_3D4_DX8BDLR2(base)  (*(volatile S_DDRPHY_3D4_DX8BDLR2  *)(base + 0x3D4))
#define REG_DDRPHY_3D8_DX8BDLR3(base)  (*(volatile S_DDRPHY_3D8_DX8BDLR3  *)(base + 0x3D8))
#define REG_DDRPHY_3DC_DX8BDLR4(base)  (*(volatile S_DDRPHY_3DC_DX8BDLR4  *)(base + 0x3DC))
#define REG_DDRPHY_3E0_DX8LCDLR0(base) (*(volatile S_DDRPHY_3E0_DX8LCDLR0 *)(base + 0x3E0))
#define REG_DDRPHY_3E4_DX8LCDLR1(base) (*(volatile S_DDRPHY_3E4_DX8LCDLR1 *)(base + 0x3E4))
#define REG_DDRPHY_3E8_DX8LCDLR2(base) (*(volatile S_DDRPHY_3E8_DX8LCDLR2 *)(base + 0x3E8))
#define REG_DDRPHY_3EC_DX8MDLR(base)   (*(volatile S_DDRPHY_3EC_DX8MDLR   *)(base + 0x3EC))
#define REG_DDRPHY_3F0_DX8GTR(base)    (*(volatile S_DDRPHY_3F0_DX8GTR    *)(base + 0x3F0))

//DDRCON
typedef union {
  unsigned int w;
} S_DDRCON_COMMON;

#define REG_DDRCON_000(base) (*(volatile S_DDRCON_COMMON *)(base + 0x000))
#define REG_DDRCON_004(base) (*(volatile S_DDRCON_COMMON *)(base + 0x004))
#define REG_DDRCON_008(base) (*(volatile S_DDRCON_COMMON *)(base + 0x008))
#define REG_DDRCON_00C(base) (*(volatile S_DDRCON_COMMON *)(base + 0x00C))
#define REG_DDRCON_010(base) (*(volatile S_DDRCON_COMMON *)(base + 0x010))
#define REG_DDRCON_014(base) (*(volatile S_DDRCON_COMMON *)(base + 0x014))
#define REG_DDRCON_018(base) (*(volatile S_DDRCON_COMMON *)(base + 0x018))
#define REG_DDRCON_01C(base) (*(volatile S_DDRCON_COMMON *)(base + 0x01C))
#define REG_DDRCON_020(base) (*(volatile S_DDRCON_COMMON *)(base + 0x020))
#define REG_DDRCON_024(base) (*(volatile S_DDRCON_COMMON *)(base + 0x024))
#define REG_DDRCON_028(base) (*(volatile S_DDRCON_COMMON *)(base + 0x028))
#define REG_DDRCON_02C(base) (*(volatile S_DDRCON_COMMON *)(base + 0x02C))
#define REG_DDRCON_030(base) (*(volatile S_DDRCON_COMMON *)(base + 0x030))
#define REG_DDRCON_034(base) (*(volatile S_DDRCON_COMMON *)(base + 0x034))
#define REG_DDRCON_038(base) (*(volatile S_DDRCON_COMMON *)(base + 0x038))
#define REG_DDRCON_03C(base) (*(volatile S_DDRCON_COMMON *)(base + 0x03C))
#define REG_DDRCON_040(base) (*(volatile S_DDRCON_COMMON *)(base + 0x040))
#define REG_DDRCON_044(base) (*(volatile S_DDRCON_COMMON *)(base + 0x044))
#define REG_DDRCON_048(base) (*(volatile S_DDRCON_COMMON *)(base + 0x048))
#define REG_DDRCON_04C(base) (*(volatile S_DDRCON_COMMON *)(base + 0x04C))
#define REG_DDRCON_050(base) (*(volatile S_DDRCON_COMMON *)(base + 0x050))
#define REG_DDRCON_054(base) (*(volatile S_DDRCON_COMMON *)(base + 0x054))
#define REG_DDRCON_058(base) (*(volatile S_DDRCON_COMMON *)(base + 0x058))
#define REG_DDRCON_05C(base) (*(volatile S_DDRCON_COMMON *)(base + 0x05C))
#define REG_DDRCON_060(base) (*(volatile S_DDRCON_COMMON *)(base + 0x060))
#define REG_DDRCON_064(base) (*(volatile S_DDRCON_COMMON *)(base + 0x064))
#define REG_DDRCON_068(base) (*(volatile S_DDRCON_COMMON *)(base + 0x068))
#define REG_DDRCON_06C(base) (*(volatile S_DDRCON_COMMON *)(base + 0x06C))
#define REG_DDRCON_070(base) (*(volatile S_DDRCON_COMMON *)(base + 0x070))
#define REG_DDRCON_074(base) (*(volatile S_DDRCON_COMMON *)(base + 0x074))
#define REG_DDRCON_078(base) (*(volatile S_DDRCON_COMMON *)(base + 0x078))
#define REG_DDRCON_07C(base) (*(volatile S_DDRCON_COMMON *)(base + 0x07C))
#define REG_DDRCON_080(base) (*(volatile S_DDRCON_COMMON *)(base + 0x080))
#define REG_DDRCON_084(base) (*(volatile S_DDRCON_COMMON *)(base + 0x084))
#define REG_DDRCON_088(base) (*(volatile S_DDRCON_COMMON *)(base + 0x088))
#define REG_DDRCON_08C(base) (*(volatile S_DDRCON_COMMON *)(base + 0x08C))
#define REG_DDRCON_090(base) (*(volatile S_DDRCON_COMMON *)(base + 0x090))
#define REG_DDRCON_094(base) (*(volatile S_DDRCON_COMMON *)(base + 0x094))
#define REG_DDRCON_098(base) (*(volatile S_DDRCON_COMMON *)(base + 0x098))
#define REG_DDRCON_09C(base) (*(volatile S_DDRCON_COMMON *)(base + 0x09C))
#define REG_DDRCON_0A0(base) (*(volatile S_DDRCON_COMMON *)(base + 0x0A0))
#define REG_DDRCON_0A4(base) (*(volatile S_DDRCON_COMMON *)(base + 0x0A4))
#define REG_DDRCON_0A8(base) (*(volatile S_DDRCON_COMMON *)(base + 0x0A8))
#define REG_DDRCON_0AC(base) (*(volatile S_DDRCON_COMMON *)(base + 0x0AC))
#define REG_DDRCON_0B0(base) (*(volatile S_DDRCON_COMMON *)(base + 0x0B0))
#define REG_DDRCON_0B4(base) (*(volatile S_DDRCON_COMMON *)(base + 0x0B4))
#define REG_DDRCON_0B8(base) (*(volatile S_DDRCON_COMMON *)(base + 0x0B8))
#define REG_DDRCON_0BC(base) (*(volatile S_DDRCON_COMMON *)(base + 0x0BC))
#define REG_DDRCON_0C0(base) (*(volatile S_DDRCON_COMMON *)(base + 0x0C0))
#define REG_DDRCON_0C4(base) (*(volatile S_DDRCON_COMMON *)(base + 0x0C4))
#define REG_DDRCON_0C8(base) (*(volatile S_DDRCON_COMMON *)(base + 0x0C8))
#define REG_DDRCON_0CC(base) (*(volatile S_DDRCON_COMMON *)(base + 0x0CC))
#define REG_DDRCON_0D0(base) (*(volatile S_DDRCON_COMMON *)(base + 0x0D0))
#define REG_DDRCON_0D4(base) (*(volatile S_DDRCON_COMMON *)(base + 0x0D4))
#define REG_DDRCON_0D8(base) (*(volatile S_DDRCON_COMMON *)(base + 0x0D8))
#define REG_DDRCON_0DC(base) (*(volatile S_DDRCON_COMMON *)(base + 0x0DC))
#define REG_DDRCON_0E0(base) (*(volatile S_DDRCON_COMMON *)(base + 0x0E0))
#define REG_DDRCON_0E4(base) (*(volatile S_DDRCON_COMMON *)(base + 0x0E4))
#define REG_DDRCON_0E8(base) (*(volatile S_DDRCON_COMMON *)(base + 0x0E8))
#define REG_DDRCON_0EC(base) (*(volatile S_DDRCON_COMMON *)(base + 0x0EC))
#define REG_DDRCON_0F0(base) (*(volatile S_DDRCON_COMMON *)(base + 0x0F0))
#define REG_DDRCON_0F4(base) (*(volatile S_DDRCON_COMMON *)(base + 0x0F4))
#define REG_DDRCON_0F8(base) (*(volatile S_DDRCON_COMMON *)(base + 0x0F8))
#define REG_DDRCON_0FC(base) (*(volatile S_DDRCON_COMMON *)(base + 0x0FC))
#define REG_DDRCON_100(base) (*(volatile S_DDRCON_COMMON *)(base + 0x100))
#define REG_DDRCON_104(base) (*(volatile S_DDRCON_COMMON *)(base + 0x104))
#define REG_DDRCON_108(base) (*(volatile S_DDRCON_COMMON *)(base + 0x108))
#define REG_DDRCON_10C(base) (*(volatile S_DDRCON_COMMON *)(base + 0x10C))
#define REG_DDRCON_110(base) (*(volatile S_DDRCON_COMMON *)(base + 0x110))
#define REG_DDRCON_114(base) (*(volatile S_DDRCON_COMMON *)(base + 0x114))
#define REG_DDRCON_118(base) (*(volatile S_DDRCON_COMMON *)(base + 0x118))
#define REG_DDRCON_11C(base) (*(volatile S_DDRCON_COMMON *)(base + 0x11C))
#define REG_DDRCON_120(base) (*(volatile S_DDRCON_COMMON *)(base + 0x120))
#define REG_DDRCON_124(base) (*(volatile S_DDRCON_COMMON *)(base + 0x124))
#define REG_DDRCON_128(base) (*(volatile S_DDRCON_COMMON *)(base + 0x128))
#define REG_DDRCON_12C(base) (*(volatile S_DDRCON_COMMON *)(base + 0x12C))
#define REG_DDRCON_130(base) (*(volatile S_DDRCON_COMMON *)(base + 0x130))
#define REG_DDRCON_134(base) (*(volatile S_DDRCON_COMMON *)(base + 0x134))
#define REG_DDRCON_138(base) (*(volatile S_DDRCON_COMMON *)(base + 0x138))
#define REG_DDRCON_13C(base) (*(volatile S_DDRCON_COMMON *)(base + 0x13C))
#define REG_DDRCON_140(base) (*(volatile S_DDRCON_COMMON *)(base + 0x140))

#endif	/* __REG_DDR_H */
