/**
   set_mac_addr.c
   
   Copyright (C) 2012- Sony Corporation.
*/

#include <config.h>
#include <command.h>
#include <common.h>
#include <i2c.h>
#include <asm/arch/xarina.h>
#include "set_mac_addr.h"
#include "hw_reg_vss.h"

#if defined(CONFIG_XARINA_VSS) && !defined(CONFIG_XARINA_SPL)

void set_mac_addr(uchar *enetaddr)
{
    int devid;
    unsigned int bus_id;
    char buf[VSS_EEPROM_MAC_ADDR_SIZE];
    devid = xarina_hw_devid_get();
            
    switch (devid) {
    case XARINA_DEVICE_ES1:
        bus_id = VSS_EEPROM_BOARD_TYPE_I2C_BUS0;
        break;
    case XARINA_DEVICE_ES2:
    case XARINA_DEVICE_ES3:
        bus_id = VSS_EEPROM_BOARD_TYPE_I2C_BUS1;
        break;
    default:
        /* unknown */
        bus_id = VSS_EEPROM_BOARD_TYPE_I2C_BUS1;
        break;
    }
    int ret = 0;
    ret = i2c_set_bus_num(bus_id);
    if (ret) {
        error("i2c_set_bus_num");
        return;
    }
    memset(buf, 0, sizeof(buf));
    ret = eeprom_read(CONFIG_SYS_I2C_EEPROM_ADDR, VSS_EEPROM_MAC_ADDR_OFFSET,
                      buf, VSS_EEPROM_MAC_ADDR_SIZE);
    if (ret) {
        error("eeprom_read");
        eth_parse_enetaddr(getenv("ethaddr"), enetaddr);
    } else {
        if ((u_int8_t)buf[0] == 0xff) {
            strncpy(buf, "02 00 00 00 00 00", VSS_EEPROM_MAC_ADDR_SIZE-1);
        }
        eth_parse_enetaddr(buf, enetaddr);
    }
}

#endif /* !defined(CONFIG_XARINA_VSS) && !defined(CONFIG_XARINA_SPL) */

