/*
 * (C) Copyright 2007, 2011 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * Version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef VIN_H
#define VIN_H

#include <config.h>

#if defined(CONFIG_XARINA_VSS)

#define VDEC_I2C_SLAVE_ADDR		0x4C	/* THC7984 Slave address */
#define VDEC_I2C_DEV			1       /* THC7984 dev no.       */

#else /* defined(CONFIG_XARINA_VSS) */

/*#define VDEC_I2C_SLAVE_ADDR		0x5C*/	/* TVP5150AM1 Slave address */
#define VDEC_I2C_SLAVE_ADDR		0x5D	/* TVP5150AM1 Slave address */
#define VDEC_I2C_DEV			1	/* TVP5150AM1 dev no.       */

#endif /* defined(CONFIG_XARINA_VSS) */

/* TYPE */
#define VDEC_TYPE_NTSC			(1)	/* NTSC */
#define VDEC_TYPE_PAL			(2)	/* PAL */

#define VIN_DEV_NONE			(0)	/* not use */
#define VIN_DEV_VDEC			(1)	/* video decoder */

#define VIN_DEV_DEFAULT			VIN_DEV_NONE


struct s_vdec_data_tbl {
	unsigned char addr;
	unsigned char data;
};

#if defined(CONFIG_XARINA_VSS)
extern int vdec_init(unsigned long video_size, unsigned long video_frame);
#else /* defined(CONFIG_XARINA_VSS) */
extern int vdec_init(unsigned long type);
#endif /* defined(CONFIG_XARINA_VSS) */
extern void set_vin_dev(int dev);
extern int get_vin_dev(void);
extern void init_vin_dev(void);

#endif /* VIN_H */
