/*
 * (C) Copyright 2007, 2011 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * Version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef VOUT_H
#define VOUT_H
#include <config.h>
#include "corefw_comm_param.h"

#define VENC_DEFAULT_TYPE	SC_SYS_VIDEO_VOUT_FMT_720_486_59I_BT656_5
#define HDMI_DEFAULT_TYPE	SC_SYS_VIDEO_VOUT_FMT_1280_720_60P_SMPTE296M

#if defined(CONFIG_XARINA_VSS)

#define VENC_I2C_SLAVE_ADDR		0x20	/* AK8817 Slave address  */
#define VENC_I2C_DEV			1       /* AK8817 i2c dev no     */

#else /* defined(CONFIG_XARINA_VSS */

#ifdef CONFIG_XARINA_EVBRD_PRE

/*#define VENC_I2C_SLAVE_ADDR		0x46*/	/* SAA7129AH Slave address */
#define VENC_I2C_SLAVE_ADDR		0x44	/* SAA7129AH Slave address */
#define VENC_I2C_DEV			0	/* SAA7129AH dev no.       */
#else
#define VENC_I2C_SLAVE_ADDR		0x6a	/* ADV7344 Slave address */
#define VENC_I2C_DEV			1	/* ADV7344 i2c dev no    */
#define HDMI_I2C_SLAVE_ADDR		0x70	/* TDA9983B Slave address */
#define HDMI_I2C_DEV			1	/* TDA9983B i2c dev no    */
#endif

#endif /* defined(CONFIG_XARINA_VSS) */

/* subaddr */
#define VENC_I2C_OUT_PORT_CTRL_SADDR	0x2D	/* output port control */

/* data */
#define VENC_I2C_OUT_PORT_CTRL_STOP	0x00	/* output stop */


/* TYPE */
#define VENC_TYPE_NTSC			(1)	/* NTSC */
#define VENC_TYPE_PAL			(2)	/* PAL */

#define VENC_TYPE_OUT_STOP		(0)	/* OUTPUT STOP */

/* DEVICE */
#define VOUT_DEV_NUM			(2)	/* T.B.D */
#define VOUT_DEV_VENC			(0)
#define VOUT_DEV_HDMI			(1)
#define VOUT_DEV_DEFAULT		VOUT_DEV_VENC

extern int venc_evb_init(unsigned long fmt);
extern int venc_rd_init(unsigned long fmt);
extern int hdmi_init(unsigned long fmt);

extern void set_vout_dev(int dev);
extern int get_vout_dev(void);
extern void init_vout_dev(void);
extern int check_venc_support(unsigned char fmt);
extern int check_hdmi_support(unsigned char fmt);

#if defined(CONFIG_XARINA_VSS)
extern int venc_vss_init(unsigned long fmt);
#endif /* defined(CONFIG_XARINA_VSS) */

#endif /* VOUT_H */
