/*
 * (C) Copyright 2007 Sony Corporation.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef BOOT_PARAM_H
#define BOOT_PARAM_H

/************************************/
/* prototype                        */
/************************************/
/* boot_check() return code */
#define E_CMD_EXPANSION_SUCCESS		(1)
#define E_CMD_EXPANSION_ADDR_ERROR	(-1)
#define E_CMD_EXPANSION_SIZE_ERROR	(-2)
#define E_CMD_EXPANSION_ID_ERROR	(-3)

/* file identifier */
#define CAMFW_BLEMISH_FILE_IDENTIFIER		"BLDA"
#define CAMFW_SHADING_FILE_IDENTIFIER		"SHDA"
#define OSD_COLOR_PALETTE_FILE_IDENTIFIER	"OSCO"
#define OSD_DATA_FILE_IDENTIFIER		"OSDA"
#define MASK_DATA_FILE_IDENTIFIER		"MADA"

#define COREFW_PARAM_DEFAULT_ADDR		(0x60000040)
#define CAMFW_PARAM_DEFAULT_ADDR		(0x60001000)

struct s_param_data_image_header {
	char		identifier[4];		/* identifier */
	unsigned long	reserved[3];
	char		date[32];
	char		version[32];
	unsigned long	addr;
	unsigned long	size;
	char		information[40];
};

extern int boot_param_data_expansion(struct s_param_data_image_header *p_header, const char *identifier);
extern int boot_param_cam_set_param_load(unsigned long bank);
extern int boot_param_load(void);
extern int boot_param_load_file_name(char *name, u32 addr, u32 size);
extern int boot_param_load_file_env(char *name, u32 addr, u32 size);

extern int boot_param_cam_video_size_frame_set(unsigned long type);
extern int boot_param_cam_videoin_default_param_load(unsigned long type);
extern int boot_param_cam_sens_default_param_load(unsigned char senssys, unsigned char basicfps);
extern int boot_param_cam_restore(void);
extern int boot_param_corefw_param_restore(void);
extern unsigned long boot_param_cam_addr_get(void);
extern unsigned long boot_param_core_addr_get(void);

#endif /* BOOT_PARAM_H */
