/*
 * (C) Copyright 2007 Sony Corporation.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef CAM_COMM_PARAM_H
#define CAM_COMM_PARAM_H
#if 0
/* senssystem */
#define CAM_PARAM_SENSSYS_IMX012		(0x00)
#define CAM_PARAM_SENSSYS_IMX035		(0x01)
#define CAM_PARAM_SENSSYS_ICX614		(0x10)
#define CAM_PARAM_SENSSYS_ICX618		(0x11)
#define CAM_PARAM_SENSSYS_ICX445		(0x12)
#define CAM_PARAM_SENSSYS_BT656I		(0x20)
#define CAM_PARAM_SENSSYS_IT1			(0x26)
#define CAM_PARAM_SENSSYS_VIDEO_DEF		(0x80)

#define CAM_PARAM_SENSSYS_MAX			(0xFF)

#define CAM_PARAM_SENSSYS_TYPE_MASK		(0x70)
#define CAM_PARAM_SENSSYS_SENSOR_IMX_TYPE	(0x00)
#define CAM_PARAM_SENSSYS_SENSOR_ICX_TYPE	(0x10)
#define CAM_PARAM_SENSSYS_VIDEOIN_TYPE		(0x20)

/* sensmode */
#define CAM_PARAM_SENSMODE_ALL_PIXEL		(0)
#define CAM_PARAM_SENSMODE_EXCEPT 		(1)

/* basicfps */
#define CAM_PARAM_BASICFPS_30FPS		(0)
#define CAM_PARAM_BASICFPS_25FPS		(1)

#define CAM_PARAM_BASICFPS_VIDEO_DEF		CAM_PARAM_BASICFPS_30FPS
#define CAM_PARAM_BASICFPS_MAX			(2)

/* miris */
/* sysmiris */
#define CAM_PARAM_MIRIS_SYSMIRIS_NONE		(0x00)
#define CAM_PARAM_MIRIS_SYSMIRIS_YES		(0x01)
#define CAM_PARAM_MIRIS_SYSMIRIS		(0x01)

/* maxframe */
#define CAM_PARAM_MAXFRAME_30_25_FPS		(0)
#define CAM_PARAM_MAXFRAME_60_50_FPS		(1)

/* osctype */
#define CAM_PARAM_OSCTYPE_INTERNAL		(0)
#define CAM_PARAM_OSCTYPE_EXTERNAL		(1)

#define CAM_PARAM_OSCTYPE_MAX			(2)

/* videosize */
#define CAM_PARAM_VIDEOSIZE_VGA			(0x00)
#define CAM_PARAM_VIDEOSIZE_QVGA		(0x02)
#define CAM_PARAM_VIDEOSIZE_SD_NTSC		(0x11)
#define CAM_PARAM_VIDEOSIZE_SD_PAL		(0x12)

#define CAM_PARAM_VIDEOSIZE_MAX			(0xFF)

/* videoframe */
#define CAM_PARAM_VIDEOFRAME_5994FPS		(0x11)
#define CAM_PARAM_VIDEOFRAME_2997FPS		(0x12)
#define CAM_PARAM_VIDEOFRAME_1499FPS		(0x13)
#define CAM_PARAM_VIDEOFRAME_50FPS		(0x21)
#define CAM_PARAM_VIDEOFRAME_25FPS		(0x22)
#define CAM_PARAM_VIDEOFRAME_1250FPS		(0x23)

#define CAM_PARAM_VIDEOFRAME_MAX		(0xFF)

/* videorange */
#define CAM_PARAM_VIDEORANGE_FULL		(0x00)
#define CAM_PARAM_VIDEORANGE_BT601		(0x01)


/* Cam FW Comm Parameter */
struct s_cam_comm_param {
	unsigned short	vc;
	unsigned char	hld;
	unsigned char	mutecnt;
	unsigned char	senssystem;
	unsigned char	sensmode;
	unsigned char	basicfps;
	unsigned char	miris;
	unsigned char	pgsel;
	unsigned char	adjmode;
	unsigned char	adjsubmode;
	unsigned char	maxframe;
	unsigned char	afesystem;
	unsigned char	osctype;
	unsigned char	videosize;
	unsigned char	videoframe;
	unsigned char	videorange;
	unsigned char	reserve[13];
	unsigned short	cparsize;
};
#endif
/* senssystem */
#define CAM_PARAM_SENSSYS_IMX035		(0x00)
#define CAM_PARAM_SENSSYS_IMX037		(0x01)
#define CAM_PARAM_SENSSYS_IMX039		(0x02)
#define CAM_PARAM_SENSSYS_IMX122		(0x03)
#define CAM_PARAM_SENSSYS_IMX140		(0x04)
#define CAM_PARAM_SENSSYS_IMX103		(0x05)
#define CAM_PARAM_SENSSYS_IMX123MIPI		(0x06)
#define CAM_PARAM_SENSSYS_IMX123MIPIW		(0x07)
#define CAM_PARAM_SENSSYS_ICX445		(0x10)
#define CAM_PARAM_SENSSYS_ICX692		(0x11)
#define CAM_PARAM_SENSSYS_ICX___		(0x12)
#define CAM_PARAM_SENSSYS_BT656			(0x20)
#define CAM_PARAM_SENSSYS_SMPTE296M		(0x21)
#define CAM_PARAM_SENSSYS_SMPTE274M		(0x22)
#define CAM_PARAM_SENSSYS_ETC			(0x23)
#define CAM_PARAM_SENSSYS_VIDEOIN_MASK		(0x20)

/* videosize */
#define CAM_PARAM_VIDEOSIZE_VGA			(0x00)
#define CAM_PARAM_VIDEOSIZE_QUADVGA		(0x01)
#define CAM_PARAM_VIDEOSIZE_SXGA		(0x02)
#define CAM_PARAM_VIDEOSIZE_9VGA		(0x03)
#define CAM_PARAM_VIDEOSIZE_QXGA		(0x04)
#define CAM_PARAM_VIDEOSIZE_SVGA		(0x05)
#define CAM_PARAM_VIDEOSIZE_720			(0x10)
#define CAM_PARAM_VIDEOSIZE_1080		(0x11)
#define CAM_PARAM_VIDEOSIZE_NTSC		(0x20)
#define CAM_PARAM_VIDEOSIZE_PAL			(0x21)
#define CAM_PARAM_VIDEOSIZE_5M			(0x22)
#define CAM_PARAM_VIDEOSIZE_6M			(0x23)
/* videoframe */
#define CAM_PARAM_VIDEOFRAME_60FPS		(0x00)
#define CAM_PARAM_VIDEOFRAME_30FPS		(0x01)
#define CAM_PARAM_VIDEOFRAME_15FPS		(0x02)
#define CAM_PARAM_VIDEOFRAME_7_5FPS		(0x03)
#define CAM_PARAM_VIDEOFRAME_59_94FPS		(0x10)
#define CAM_PARAM_VIDEOFRAME_29_97FPS		(0x11)
#define CAM_PARAM_VIDEOFRAME_50FPS		(0x20)
#define CAM_PARAM_VIDEOFRAME_25FPS		(0x21)
#define CAM_PARAM_VIDEOFRAME_12_5FPS		(0x22)
#define CAM_PARAM_VIDEOFRAME_6_25FPS		(0x23)
#define CAM_PARAM_VIDEOFRAME_22_8FPS		(0x30)

/* videorange */
#define CAM_PARAM_VIDEORANGE_FULL		(0x00)
#define CAM_PARAM_VIDEORANGE_BT601		(0x01)

/* evr_type */
#define CAM_PARAM_EVR_TYPE_SCI			(0x00)
#define CAM_PARAM_EVR_TYPE_SPI			(0x01)

/* sysmiris */
#define CAM_PARAM_MIRIS_SYSMIRIS_NONE		(0x00)
#define CAM_PARAM_MIRIS_SYSMIRIS_YES		(0x01)
#define CAM_PARAM_MIRIS_SYSMIRIS		(0x01)

/* pll2_clk */
#define CAM_PARAM_PLL2_CLK_216MHZ		(0x00)
#define CAM_PARAM_PLL2_CLK_216_216MHZ		(0x01)
#define CAM_PARAM_PLL2_CLK_148_5MHZ		(0x02)
#define CAM_PARAM_PLL2_CLK_148_352MHZ		(0x03)
#define CAM_PARAM_PLL2_CLK_144MHZ		(0x04)
#define CAM_PARAM_PLL2_CLK_116MHZ		(0x05)
#define CAM_PARAM_PLL2_CLK_75_6MHZ		(0x06)
#define CAM_PARAM_PLL2_CLK_90MHZ		(0x07)

struct s_cam_comm_param {
	unsigned char	cam_mode;
	unsigned char	senssystem;
	unsigned char	videosize;
	unsigned char	sensmode;
	unsigned char	wdmode;
	unsigned char	sensbit;
	unsigned char	videoframe;
	unsigned char	videoif;
	unsigned char	videosync;
	unsigned char	videorange;
	unsigned char	evr_type;
	unsigned char	sysmiris;
	unsigned long	vramband;
	unsigned char	pll2_clk;
	unsigned char	uart_baudrate;
	unsigned short	ssptimer;
	unsigned char	reserved[95];
};


#endif /* CAM_COMM_PARAM_H */

