/*
 * (C) Copyright 2007 Sony Corporation.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef CMD_ARM9_H
#define CMD_ARM9_H

#include "corefw_boot_param.h"


#define ARM9_BOOT_RES_OK	(ARM9_BOOT_RES_OK_OS_INIT | ARM9_BOOT_RES_OK_RM_INIT)
#define ARM9_BOOT_RES_OK_COMP	(ARM9_BOOT_RES_OK_OS_INIT | ARM9_BOOT_RES_OK_RM_INIT | ARM9_BOOT_RES_OK_VOUT_START)

/* error bit mask */
#define ARM9_BOOT_RES_ERROR_MASK  (ARM9_BOOT_RES_ERR_PARAM | ARM9_BOOT_RES_ERR_SPF | ARM9_BOOT_RES_ERR_DRV | ARM9_BOOT_RES_ERR_RM | ARM9_BOOT_RES_ERR_VIDEO | ARM9_BOOT_RES_ERR_AUDIO | ARM9_BOOT_RES_ERR_CAM | ARM9_BOOT_RES_ERR_V_OPEN | ARM9_BOOT_RES_ERR_A_OPEN)

/* warning bit mask */
#define ARM9_BOOT_RES_WARNING_MASK  (ARM9_BOOT_RES_WAR_COLOR | ARM9_BOOT_RES_WAR_OSD | ARM9_BOOT_RES_WAR_MASK)

/* boot_check() return code */
#define E_CMD_BOOT_NOT_YET		(0)
#define E_CMD_BOOT_SUCCESS		(1)
#define E_CMD_BOOT_ERROR		(-1)
#define E_CMD_BOOT_WARNING		(2)

/* boot_arm9() return code */
#define E_CMD_BOOTARM9_ADDR		(-1)
#define E_CMD_BOOTARM9_FW_IMAGE		(-2)
#define E_CMD_BOOTARM9_TMOUT		(-3)
#define E_CMD_BOOTARM9_FAILURE		(-4)



#define INPUT_MAX_NUM			(3)
#define ENV_BIN_FILE_IMX035		"cam_bin_imx035"
#define ENV_BIN_FILE_IMX122		"cam_bin_imx122"
#define ENV_BIN_FILE_ICX445		"cam_bin_icx445"


struct s_input_table {
	unsigned char id;
	char *env;
};
extern void sensfw_info_out_all(void);
#endif /* CMD_ARM9_H */

