/*
 * (C) Copyright 2007 Sony Corporation.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef CMD_MENU_H
#define CMD_MENU_H

/* menu item number max */
#define MENU_ITEM_NUM_MAX			(16)

/* menu item char */
#define MENU_SELECT_CHAR_RET_MENU		('.')
#define MENU_SELECT_CHAR_EXIT_MENU		('0')
/* menu item number */
#define MENU_SELECT_VAL_RET_MENU		(MENU_SELECT_CHAR_RET_MENU  + 0x10000)
#define MENU_SELECT_VAL_EXIT_MENU		(MENU_SELECT_CHAR_EXIT_MENU + 0x10000)

/* item option */
#define MENU_OPTION_NONE			(0)
#define MENU_OPTION_MAX				(1)

/* item option to table index */
#define OPT2INDEX(X)				((X) - MENU_OPTION_CHANGE_CHECK)

 /* menu process struct */
struct menu_proc {
	int b_disable[MENU_ITEM_NUM_MAX];	/* output menu item enable/disable */
	int b_choice[MENU_ITEM_NUM_MAX];	/* output menu item choise mark */
	int select_num;				/* select menu item number */
};

struct menu_info;

 /* menu item struct */
struct menu_item {
	char *p_str;			/* item name */
	int (*p_func)(struct menu_info *, struct menu_item *, struct menu_proc *);
					/* function to execute if item select */
	struct menu_info *next;		/* next menu if item select */
	unsigned long option;		/* menu item option */
	unsigned long info;		/* some kind of item original information */
};

 /* menu infomation struct */
struct menu_info {
	char *p_str;			/* menu title name */
	int (*p_pre_func)(struct menu_info *, struct menu_proc *);
					/* preprocess function */
	int (*p_print_func)(struct menu_info *, struct menu_proc *);
					/* output function */
	char *p_add_str;		/* menu additional string*/
	unsigned long item_num;		/* menu item number in menu */
	struct menu_item *p_item[MENU_ITEM_NUM_MAX];
					/* menu item in menu */
	struct menu_item *p_ret_item;	/* menu return item in menu */
	struct menu_item *p_exit_item;	/* menu exit item in menu */
	unsigned long info;		/* some kind of menu original information */
};

#endif /* CMD_MENU_H */

