/*
 * (C) Copyright 2007 Sony Corporation.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef CMD_PINMUX_H
#define CMD_PINMUX_H

/* pinmux type */
#define CMD_PINMUX_TYPE_GPIOC			"gpioc"
#define CMD_PINMUX_TYPE_VOUT			"vout"
#define CMD_PINMUX_TYPE_SVI			"svi"
#define CMD_PINMUX_TYPE_VOUT_INVALID		"vout_invalid"
#define CMD_PINMUX_TYPE_GPIOE0			"gpioe0"
#define CMD_PINMUX_TYPE_SPI0			"spi0"
#define CMD_PINMUX_TYPE_GPIOE1			"gpioe1"
#define CMD_PINMUX_TYPE_UART0			"uart0"
#define CMD_PINMUX_TYPE_GPIOG0			"gpiog0"
#define CMD_PINMUX_TYPE_UART1			"uart1"
#define CMD_PINMUX_TYPE_GPIOG1			"gpiog1"
#define CMD_PINMUX_TYPE_UART2			"uart2"
#define CMD_PINMUX_TYPE_SPI2			"spi2"
#define CMD_PINMUX_TYPE_GPIOH			"gpioh"
#define CMD_PINMUX_TYPE_SDIF			"sdif"
#define CMD_PINMUX_TYPE_GPIOI0			"gpioi0"
#define CMD_PINMUX_TYPE_SPI3			"spi3"
#define CMD_PINMUX_TYPE_GPIOI1			"gpioi1"
#define CMD_PINMUX_TYPE_PWM0			"pwm0"
#define CMD_PINMUX_TYPE_GPIOI2			"gpioi2"
#define CMD_PINMUX_TYPE_PWM1			"pwm1"
#define CMD_PINMUX_TYPE_GPIOI3			"gpioi3"
#define CMD_PINMUX_TYPE_NCE1			"nce1"
#define CMD_PINMUX_TYPE_GPIOHI			"gpiohi"
#define CMD_PINMUX_TYPE_EMCSM2			"emcsm2"
#define CMD_PINMUX_TYPE_SDIF0			"sdif0"
#ifdef CONFIG_FOR_DEVELOPMENT
#define CMD_PINMUX_TYPE_SVI_DESELECT		"svi_none"
#define CMD_PINMUX_TYPE_SVI_SELECT		"svi_select"
#endif /* CONFIG_FOR_DEVELOPMENT */


/* do_pinmux() return code */
#define E_CMD_PINMUX_ARG_NUM			(-1)
#define E_CMD_PINMUX_TYPE			(-2)
#define E_CMD_PROHIBIT				(-3)


/* pinmux struct */
struct s_pinmux_info {
	char *p_type;		/* command arg type strings */
	int (*p_func)(int);	/* execute function */
	int arg;		/* execute function argument */
	int (*p_cond)(void);	/* condition befor execute function */
};


#endif /* CMD_MENU_H */

