/*
 * (C) Copyright 2007 Sony Corporation.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <config.h>
#include <command.h>
#include <common.h>
#include <asm/arch/xarina.h>
#include "hw_reg_ctrl.h"
#include "cmd_xarina_uboot.h"


extern void xarina_hw_gbe_disable(void);

static int cleanup(void)
{
	/* GbE Clock disable & Reset */
	xarina_hw_gbe_disable();

	cleanup_before_linux();

	return 0;
}


int do_xarina_uboot(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
{	
	unsigned long	addr;		/* Xarina U-Boot Load address */
	void (*jump)(void) = NULL;	/* reset vector jump */

	if (argc < 2) {
		addr = 	CONFIG_DEFAULT_UBOOT_LOAD_ADDR;
	} else {
		addr = simple_strtoul(argv[1], NULL, 16);
	}

	printf ("\n");
	printf ("## Starting Xarina U-Boot at 0x%08lx ...\n", addr);

	/* vector table early running on ddr sdram copy to BootRAM */
	memcpy((void *)XARINA_BOOTRAM_BASE, (void *)addr, XARINA_SPL_VECTOR_TABLE_SIZE);

	/* BootRAM remap */
	xarina_hw_bootram_remap();

	cleanup();

	/* jump to Xarina U-Boot */
	jump();

	return 0;
}


U_BOOT_CMD(
	xarina_uboot, 2, 0,	do_xarina_uboot,
	"xarina_uboot- boot U-Boot for Xarina binary\n",
	"[ addr ]\n"
	"    - boot U-Boot for Xarina binary"
	" from physical address 'addr'\n"
);

