/*
 * (C) Copyright 2007 Sony Corporation.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <config.h>
#include <version.h>
#include <common.h>
#include <command.h>
#include "xarina_bool.h"

char cmd_buff[CONFIG_SYS_CBSIZE];


#if 1
#define DEBUG_COMMAND_OUTPUT(x)		printf("%s\n", cmd_buff)
#endif


int erase_command(unsigned long start, unsigned long end)
{
	int ret;

	sprintf(cmd_buff,"erase %lx %lx", start, end);
	DEBUG_COMMAND_OUTPUT(x);
	ret = run_command(cmd_buff, 0);

	return ret;
}


int protect_off_command(unsigned long start, unsigned long end)
{
	int ret;

	sprintf(cmd_buff,"protect off %lx %lx", start, end);
	DEBUG_COMMAND_OUTPUT(x);
	ret = run_command(cmd_buff, 0);

	return ret;
}


int protect_on_command(unsigned long start, unsigned long end)
{
	int ret;

	sprintf(cmd_buff,"protect on %lx %lx", start, end);
	DEBUG_COMMAND_OUTPUT(x);
	ret = run_command(cmd_buff, 0);

	return ret;
}


int loads_command(unsigned long offset)
{
	int ret;

	sprintf(cmd_buff,"loads %lx", offset);
	DEBUG_COMMAND_OUTPUT(x);
	ret = run_command(cmd_buff, 0);

	return ret;
}


int loadx_command(unsigned long addr)
{
	int ret;

	sprintf(cmd_buff,"loadx %lx", addr);
	DEBUG_COMMAND_OUTPUT(x);
	ret = run_command(cmd_buff, 0);

	return ret;
}


int tftp_command(unsigned long addr, char *str)
{
	int ret;

	sprintf(cmd_buff,"tftp %lx %s", addr, str);
	DEBUG_COMMAND_OUTPUT(x);
	ret = run_command(cmd_buff, 0);

	return ret;
}


int cp_b_command(unsigned long src, unsigned long dest, unsigned long size)
{
	int ret;

	sprintf(cmd_buff,"cp.b %lx %lx %lx", src, dest, size);
	DEBUG_COMMAND_OUTPUT(x);
	ret = run_command(cmd_buff, 0);

	return ret;
}


int nand_write_jffs2_command(unsigned long addr, unsigned long off, unsigned long size)
{
	int ret;

	sprintf(cmd_buff,"nand write.jffs2 %lx %lx %lx", addr, off, size);
	DEBUG_COMMAND_OUTPUT(x);
	ret = run_command(cmd_buff, 0);

	return ret;
}


int nand_erase_command(unsigned long off, unsigned long size)
{
	int ret;

	sprintf(cmd_buff,"nand erase %lx %lx", off, size);
	DEBUG_COMMAND_OUTPUT(x);
	ret = run_command(cmd_buff, 0);

	return ret;
}

