/*
 * (C) Copyright 2007 Sony Corporation.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef COREFW_H
#define COREFW_H

/************************************/
/* ARM9 F/W Image Header            */
/************************************/
/* FW image identifier */
#define COREFW_IMAGE_IDENTIFIER		"Core"
#define SENSFW_IMAGE_IDENTIFIER		"Sens"
/* CoreFW image header */
struct corefw_image_header {
	char		identifier[4];
	unsigned long	size;
	char		reserved[8];
	char            date[32];
	char            version[32];
	unsigned long	vector_addr;
	unsigned long	vector_size;
	unsigned long	corefw_addr;
	unsigned long	corefw_size;
	unsigned long	audiofw_addr;
	unsigned long	audiofw_size;
	char            info[24];
};
/* Sensor FW image header */
struct sensfw_image_header {
	char		identifier[4];
	unsigned long	size;
	char		reserved[8];
	char            date[32];
	char            version[32];
	unsigned long	vector_addr;
	unsigned long	vector_size;
	unsigned long	sensfw_addr;
	unsigned long	sensfw_size;
	char            info[32];
};


#endif /* COREFW_H */

