/*
 * (C) Copyright 2007 Sony Corporation.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <config.h>
#include <version.h>
#include <common.h>
#include <flash.h>
#include "boot_param.h"
#include "corefw_boot_param.h"
#include "corefw_comm_param.h"
#include "command_exec.h"
#include "xarina_bool.h"


/************************************/
/* parameter member operation       */
/************************************/
unsigned char corefw_param_uart0_spi1_select_get(void)
{
	struct tagS_Arm9_CommParam *p_param = 
		(struct tagS_Arm9_CommParam *)boot_param_core_addr_get();
	return p_param->periIoInfo.uart0ssp1;
}

unsigned char corefw_param_camfw_extbusy_gpio_get(void)
{
	struct tagS_Arm9_CommParam *p_param = 
		(struct tagS_Arm9_CommParam *)boot_param_core_addr_get();
	return p_param->periIoInfo.camfwExtbusyGpio;
}

unsigned char corefw_param_camfw_vsub_gpio_get(void)
{
	struct tagS_Arm9_CommParam *p_param = 
		(struct tagS_Arm9_CommParam *)boot_param_core_addr_get();
	return p_param->periIoInfo.camfwVsubGpio;
}

void corefw_param_tvout_type_set(unsigned long data)
{
	struct tagS_Arm9_CommParam *p_param = 
		(struct tagS_Arm9_CommParam *)boot_param_core_addr_get();
	p_param->videoInfo.tvOutType = data;
	return;
}

unsigned long corefw_param_tvout_type_get(void)
{
	struct tagS_Arm9_CommParam *p_param = 
		(struct tagS_Arm9_CommParam *)boot_param_core_addr_get();
	return p_param->videoInfo.tvOutType;
}

unsigned long corefw_param_osd_mask_output_status_get(void)
{
	struct tagS_Arm9_CommParam *p_param = 
		(struct tagS_Arm9_CommParam *)boot_param_core_addr_get();
	return p_param->videoInfo.outputSet;
}

unsigned long corefw_param_osd_color_plt_addr_get(void)
{
	struct tagS_Arm9_CommParam *p_param = 
		(struct tagS_Arm9_CommParam *)boot_param_core_addr_get();
	return p_param->videoInfo.osdColorPltAddr;
}

unsigned long corefw_param_osd_data_addr_get(void)
{
	struct tagS_Arm9_CommParam *p_param = 
		(struct tagS_Arm9_CommParam *)boot_param_core_addr_get();
	return p_param->videoInfo.osdDataAddr;
}

unsigned long corefw_param_mask_data_addr_get(void)
{
	struct tagS_Arm9_CommParam *p_param = 
		(struct tagS_Arm9_CommParam *)boot_param_core_addr_get();
	return p_param->videoInfo.maskDataAddr;
}

unsigned char corefw_param_audio_use_get(void)
{
	struct tagS_Arm9_CommParam *p_param = 
		(struct tagS_Arm9_CommParam *)boot_param_core_addr_get();
	return p_param->audioInfo.audioUse;
}



int is_corefw_comm_param_uart0_spi1_select(void)
{
	unsigned char select;
	int ret = FALSE;

	select = corefw_param_uart0_spi1_select_get();

	switch(select) {
	case ARM9_IO_UART0_SELECT:
		/* FALLTHROUGH */
	case ARM9_IO_SPI1_SELECT:
		ret = TRUE;
		break;
	default:
		break;
	}

	return ret;
}






