/*
 * (C) Copyright 2007 Sony Corporation.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef HW_REG_CTRL_H
#define HW_REG_CTRL_H

#include <asm/io.h>
#include <asm/arch/hw_reg.h>

/* register access */
#define SYSREG1_RIN(n)		readl(SYSREG1_REG_BASE+(n))
#define SYSREG1_ROUT(n, v)	writel((v), SYSREG1_REG_BASE+(n))
#define SYSREG0_RIN(n)		readl(SYSREG0_REG_BASE+(n))
#define SYSREG0_ROUT(n, v)	writel((v), SYSREG0_REG_BASE+(n))
#define EMCSM2_RIN(n)		readl(EMC_SM2_REG_BASE+(n))
#define EMCSM2_ROUT(n, v)	writel((v), EMC_SM2_REG_BASE+(n))

#define CIS_108_0_PLL7		(0x00000040)
#define CIS_108_0_PLL2		(0x00031f02)
#define CIS_108_1_PLL7		(0x007C5A12)
#define CIS_108_1_PLL2		(0x00035702)
#define CIS_74_25_0_PLL7	(0x00000040)
#define CIS_74_25_0_PLL2	(0x00072b02)
#define CIS_74_25_1_PLL7	(0x00333102)
#define CIS_74_25_1_PLL2	(0x00062702)
#define CCD_NTSC_PLL7		(0x00000040)
#define CCD_NTSC_PLL2		(0x00082f02)
#define CCD_PAL_PLL7		(0x001A1C02)
#define CCD_PAL_PLL2		(0x00071F02)
#define CCD_SVGA_PLL7		(0x00000040)
#define CCD_SVGA_PLL2		(0x000e2902)
#define CCD_YC_5M_PLL7		(0x00000040)
#define CCD_YC_5M_PLL2		(0x00081D02)

#define PLL3_148_352MHZ		(0x00333102)
#define PLL4_148_352MHZ		(0x00062702)
#define PLL4_148_5MHZ		(0x00072b02)
#define PLL4_297MHZ		(0x00032b02)
#define PLL3_74_176MHZ		(0x00333102)
#define PLL4_74_176MHZ		(0x000D2702)



#if 0
extern void xarina_hw_cpu_peripheralport_vector(void);
extern void xarina_hw_cpu_peripheralport_peri_ex_ic2(void);
#endif
extern int xarina_hw_boot_type_get(void);
extern void xarina_hw_pinmux_set(unsigned long *p_reg);
extern void xarina_hw_bootram_remap(void);
extern void xarina_hw_nfif_clock_set(unsigned long clock);
extern void xarina_hw_cpu1_reset(void);
extern void xarina_hw_cpu1_unreset(void);
extern void xarina_hw_gbe_init(void);
extern void xarina_hw_pcie_init(void);
extern void xarina_hw_gpio_pullup_init(void);
extern unsigned long xarina_hw_devid_get(void);
extern void xarina_hw_sdout_clock_enable(void);
extern unsigned long xarina_hw_type_get(void);
extern unsigned long xarina_hw_date_get(void);
extern int xarina_hw_jtag_connection_check(void);
extern void xarina_hw_video_clock_select(unsigned long clock);
extern void xarina_hw_pll2_pll7_unselect(void);
extern void xarina_hw_pll2_pll7_select(int clock_type);
extern void xarina_hw_pll3_pll4_unselect(void);
extern void xarina_hw_pll3_pll4_select(int clock_type);
extern void xarina_hw_emc_sm2_init(void);

#endif /* HW_REG_CTRL_H */
