/*
 * (C) Copyright 2003, ARM Ltd.
 * Philippe Robin, <philippe.robin@arm.com>
 *
 * (C) Copyright 2007 Sony Corporation.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <config.h>
#include <version.h>


/* Set up the platform, once the cpu has been initialized */
.globl lowlevel_init
lowlevel_init:
	mov	r5, lr	/* link reg save */

#if !defined(CONFIG_XARINA_SPL)
	/* ARM9 Peripheral init */
	bl	ne3_hw_arm9_peri_init
#endif /* !defined(CONFIG_XARINA_SPL) */

#if defined(CONFIG_XARINA_SPL) || defined(CONFIG_XARINA_NOR_BOOT)
	/* SysRAM init */
	bl	ne3_hw_sysram_init
#endif /* defined(CONFIG_XARINA_SPL) || defined(CONFIG_XARINA_NOR_BOOT) */

#if !defined(CONFIG_XARINA_SPL) || defined(CONFIG_XARINA_NOR_BOOT)
	/* VRAM  init */
	bl	ne3_hw_vram_init
#endif /* !defined(CONFIG_XARINA_SPL) || defined(CONFIG_XARINA_NORBOOT) */

	mov	lr, r5	/* link reg load */

	mov	pc, lr
	

