/*
 * (C) Copyright 2007 Sony Corporation.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <config.h>
#include <version.h>
#include <common.h>
#include <command.h>
#include "cmd_menu.h"
#include "menu_top.h"
#include "menu_uboot.h"
#include "menu_output.h"
#include "menu_input.h"
#include "menu_update.h"
#include "menu_pinmux.h"
#include "menu_flash.h"
#include "menu_version.h"
#include "xarina_bool.h"

extern char console_buffer[];	/* readline buffer */

/**************************************/
/* boot linux                         */
/**************************************/
static int menu_boot(struct menu_info *p_info, struct menu_item *p_item, struct menu_proc *p_proc)
{
	char *s;

	/* corefw boot */
	run_command("bootcofw", 0);

	/* bootcmd exec */
	s = getenv ("bootcmd");
	if (s != NULL) {
		run_command (s, 0);
	} else {
		printf(	"error: no \"bootcmd\" set.\n"
			"       please set \"bootcmd\" in command line mode\n");
 	}

	return 0;
}


/**************************************/
/* main menu                          */
/**************************************/
struct menu_item item_top_boot = {
	"boot linux",  menu_boot, NULL, 0, 0,
};
struct menu_item item_top_uboot = {
	"u-boot setting", NULL, &info_uboot, 0, 0,
};
struct menu_item item_top_output = {
	"output setting", NULL, &info_output, 0, 0,
};
struct menu_item item_top_input = {
	"input setting", NULL, &info_input, 0, 0,
};
struct menu_item item_top_update = {
	"update", NULL, &info_update, 0, 0,
};
struct menu_item item_top_pinmux = {
	"pinmux setting", NULL, &info_pinmux, 0, 0,
};
struct menu_item item_top_flash = {
	"load data and write nand r/w", NULL, &info_flash, 0, 0,
};
struct menu_item item_top_ver = {
	"version", NULL, &info_ver, 0, 0,
};
struct menu_item item_top_cmdline = {
	"commandline mode", NULL, NULL, 0, 0,
};
struct menu_info info_top = {
	"main menu",
	NULL, NULL,
	NULL,
	8,
	{	&item_top_boot, &item_top_uboot, &item_top_output, &item_top_input, 
		&item_top_update, &item_top_pinmux, &item_top_flash, &item_top_ver,
	},
	NULL, &item_top_cmdline,
	0,
};

