/*
 * (C) Copyright 2007 Sony Corporation.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef MENU_UPDATE_H
#define MENU_UPDATE_H

/* update load type */
#define DOWNLOAD_TYPE_LOADS			(1)
#define DOWNLOAD_TYPE_LOADX			(2)
#define DOWNLOAD_TYPE_TFTP			(3)
#define DOWNLOAD_TYPE_UBIFS			(4)

/* extension num */
#define EXTENSION_NUM_MAX			(1000)


/* cancell check */
#define CANCELL_CHECK()				\
	if (ctrlc()) {				\
		clear_ctrlc();			\
		printf(	"\n"			\
			"Abort\n");		\
		return -1;			\
	}


/* console output macro */
#define CONSOLE_OUT_ERASE_START(x)				\
	printf(	"\n"						\
		"**********************************\n"		\
		"* erase start\n"				\
		"**********************************\n")

#define CONSOLE_OUT_WRITE_START(x)				\
	printf(	"\n"						\
		"**********************************\n"		\
		"* write start\n"				\
		"**********************************\n")

#define CONSOLE_OUT_WRITE_FAILURE_ERASE(x, y)					\
	do {									\
		printf(	"\n"							\
			"**********************************\n"			\
			"* write failure. erase start\n");			\
		printf(	"*  area start offset : 0x%08x\n", (x));		\
		printf(	"*  area end offset   : 0x%08x\n", (x) + (y) - 1);	\
		printf(	"*  area size         : 0x%08x\n", (y));		\
		printf(	"**********************************\n");		\
	} while(0)

#define CONSOLE_OUT_ERASE_FAILURE(x)				\
	printf(	"\n"						\
		"**********************************\n"		\
		"* erase failure.\n"				\
		"**********************************\n")

#define CONSOLE_OUT_DOWNLOAD_START(v, x, y, z)				\
	do {								\
		printf(	"\n"						\
			"**********************************\n"		\
			"* download start\n");				\
		if ((v) == DOWNLOAD_TYPE_TFTP) {			\
			printf(	"*  download file: %s\n", (x));		\
		}							\
		printf(	"*  download num : %d/%d\n", (y)+1, (z));	\
		printf(	"**********************************\n");	\
	} while(0)

#define CONSOLE_OUT_WRITE_SUCCESS(x, y, z)					\
	do {									\
		printf(	"\n"							\
			"**********************************\n"			\
			"* nand write success.\n");				\
		printf(	"*  area start offset : 0x%08x\n", (x));		\
		printf(	"*  area end offset   : 0x%08x\n", (x) + (y) - 1);	\
		printf(	"*  area size         : 0x%08x\n", (y));		\
		printf(	"*  data size         : 0x%08x\n", (z));		\
		printf(	"**********************************\n");		\
	} while(0)

#define CONSOLE_OUT_UPDATE_SUCCESS(x)						\
	do {									\
		printf(	"\n"							\
			"**********************************\n"			\
			"* update success\n");					\
		printf(	"*  total data size   : 0x%08x\n", (x));		\
		printf(	"**********************************\n");		\
	} while(0)


extern struct menu_info info_ud_uboot;
extern struct menu_info info_update;

#endif /* MENU_UPDATE_H */

