/*
 * (C) Copyright 2007 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * Version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef VENC_H
#define VENC_H

/*#define VENC_I2C_SLAVE_ADDR		0x46*/	/* SAA7129AH Slave address */
#define VENC_I2C_SLAVE_ADDR		0x44	/* SAA7129AH Slave address */
#define VENC_I2C_DEV			0	/* SAA7129AH dev no.       */

/* subaddr */
#define VENC_I2C_OUT_PORT_CTRL_SADDR	0x2D	/* output port control */

/* data */
#define VENC_I2C_OUT_PORT_CTRL_STOP	0x00	/* output stop */


/* TYPE */
#define VENC_TYPE_NTSC			(1)	/* NTSC */
#define VENC_TYPE_PAL			(2)	/* PAL */

#define VENC_TYPE_OUT_STOP		(0)	/* OUTPUT STOP */

/* DEVICE */
#define VOUT_DEV_VENC			(0)
#define VOUT_DEV_HDMI			(1)
#define VOUT_DEV_DVI			(2)
#define VOUT_DEV_HDCCTV			(3)
#define VOUT_DEV_DEFAULT		VOUT_DEV_VENC

extern int venc_init(unsigned long fps);
extern void set_vout_dev(int dev);
extern int get_vout_dev(void);
extern void init_vout_dev(void);
#endif /* VENC_H */
