#include <common.h>
#include <exports.h>
#include "xarina_nandif.h"
#include "xarina_nand_ctrl.h"

#define NANDIF_RIN(n)		readl(NANDIF_BASE+(n))
#define NANDIF_ROUT(n, v)	writel((v), NANDIF_BASE+(n))
#define PAGE_SIZE		(2048)
#define ECC_SIZE		(512)
#define ECC_LEN			(4)
#define OOB_SIZE		(8)
#define BLOCK_SIZE		(64)


extern int do_test_nand_biterr(int argc, char * const argv[]);


int nand_test (int argc, char * const argv[])
{
	int i;
	/* Print the ABI version */
	app_startup(argv);

	if (XF_VERSION != get_version()) {
		printf("Expects ABI version %d\n", XF_VERSION);
		printf("Actual U-Boot ABI version %lu\n", get_version());
		printf("Can't run\n\n");
		return 1;
	}
	
	printf ("argc = %d\n", argc);

	for (i=0; i<=argc; ++i) {
		printf ("argv[%d] = \"%s\"\n",
			i,
			argv[i] ? argv[i] : "<NULL>");
	}
	
	do_test_nand_biterr(argc, argv);
	
	return (0);
}



