/*
 * (C) Copyright 2007, 2011 Sony Corporation.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * Version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef _XARINA_NANDIF_H
#define _XARINA_NANDIF_H


#include <common.h>
#include <linux/mtd/nand.h>
#include <asm/io.h>

#define NANDIF_BASE		0x38006000

#define NANDIF_NF_MODE		0x0000
#define NANDIF_NF_DSIZE		0x0004
#define NANDIF_NF_TASK		0x0008
#define NANDIF_NF_CTLSTS	0x000C
#define NANDIF_NF_ID_ST_RDT_12	0x0010
#define NANDIF_NF_ID_ST_RDT_34	0x0014
#define NANDIF_NF_ID_ST_RDT_56	0x0018
#define NANDIF_NF_CMD1		0x0020
#define NANDIF_NF_CMD2		0x0030
#define NANDIF_NF_CMD3		0x0034
#define NANDIF_NF_CADR01	0x0024
#define NANDIF_NF_PADR01	0x0028
#define NANDIF_NF_PADR2		0x002C
#define NANDIF_NF_DATA01	0x0038
#define NANDIF_NF_DATA23	0x003C
#define NANDIF_NF_ECCLR		0x0040
#define NANDIF_NF_ECCHK		0x0044
#define NANDIF_NF_ECRSL_LM	0x0048
#define NANDIF_NF_ECRSL_H_STSD	0x004C
#define NANDIF_NF_ECERBIT	0x0050
#define NANDIF_NF_ECERADR	0x0058
#define NANDIF_NF_NANDMODE	0x0060
#define NANDIF_NF_AUTOCTL	0x0100
#define NANDIF_NF_STOP		0x0104
#define NANDIF_NF_RIS		0x0110
#define NANDIF_NF_IS		0x0114
#define NANDIF_NF_IEN		0x0118
#define NANDIF_NF_ICR		0x011C
#define NANDIF_NF_FIFO		0x1000


#define NANDIF_FWPN		0x0002

#define NANDIF_TASK_TASKCLEAR	0x0001
#define NANDIF_TASK_COMMAND1	0x0002
#define NANDIF_TASK_COLADR0	0x0004
#define NANDIF_TASK_COLADR1	0x0008
#define NANDIF_TASK_PAGADR0	0x0010
#define NANDIF_TASK_PAGADR1	0x0020
#define NANDIF_TASK_PAGADR2	0x0040
#define NANDIF_TASK_COMMAND2	0x0080
#define NANDIF_TASK_WAITRDY1	0x0100
#define NANDIF_TASK_RECVDATA	0x0200
#define NANDIF_TASK_CHKECC	0x0400
#define NANDIF_TASK_SENDDATA	0x0800
#define NANDIF_TASK_SENDECC	0x1000
#define NANDIF_TASK_COMMAND3	0x2000
#define NANDIF_TASK_WAITRDY2	0x4000
#define NANDIF_TASK_RECV2REG	0x8000



#define NANDIF_CMD_READ1	0x00
#define NANDIF_CMD_READ2	0x30
#define NANDIF_CMD_PAGEPRG1	0x80
#define NANDIF_CMD_PAGEPRG2	0x10
#define NANDIF_CMD_BLOCKERASE1	0x60
#define NANDIF_CMD_BLOCKERASE2	0xD0
#define NANDIF_CMD_READSTATUS	0x70
#define NANDIF_CMD_READID	0x90
#define NANDIF_CMD_RESET	0xFF


#endif


