/*
 * (C) Copyright 2003
 * Texas Instruments.
 * Kshitij Gupta <kshitij@ti.com>
 * Configuation settings for the TI OMAP Innovator board.
 *
 * (C) Copyright 2004
 * ARM Ltd.
 * Philippe Robin, <philippe.robin@arm.com>
 * Configuration for Versatile PB.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef __CONFIG_H
#define __CONFIG_H
/*
 * High Level Configuration Options
 * (easy to change)
 */
#include <xarina_config.h>
#define CONFIG_ARM1176	1	/* This is an arm1176 CPU core */
#define CONFIG_XARINA	1	/* in Allion Platform Board	*/
#define CONFIG_XARINA_FPGA	1
#define CONFIG_ARCH_XARINA	1	/* Specifically, a xarina	*/

#define CONFIG_SYS_MEMTEST_START	0x60C00000
#define CONFIG_SYS_MEMTEST_END		0x63FFFFFF

#define CONFIG_SYS_HZ			(1687500 >> 4)
#define CONFIG_SYS_TIMERBASE		0x30009000	/* Dual-Timer(SP804) base address */

#define CONFIG_SP805_RESET_COUNT   	0x0001869F      /* 100ms   0x1869F(100ms load value/MHz)  */

#ifndef CONFIG_XARINA_SPL
#define CONFIG_CMDLINE_TAG		1	/* enable passing of ATAGs */
#define CONFIG_SETUP_MEMORY_TAGS	1
#define CONFIG_INITRD_TAG		1	/* add this line */
#define CONFIG_MISC_INIT_R		1
#endif /* CONFIG_XARINA_SPL */

#define CONFIG_XARINA_NAND_NO_USE

/*
 * Size of malloc() pool
 */
#ifndef CONFIG_XARINA_SPL
#define CONFIG_SYS_MALLOC_LEN		(CONFIG_ENV_SIZE + 768 * 1024)
#else /* CONFIG_XARINA_SPL */
#define CONFIG_SYS_MALLOC_LEN		(CONFIG_ENV_SIZE + 16 * 1024)
#endif /* CONFIG_XARINA_SPL */

/* size in bytes reserved for initial data */
#define CONFIG_SYS_GBL_DATA_SIZE	128

/*
 * Hardware drivers
 */

#define CONFIG_NET_MULTI
#define CONFIG_SMAC
#ifdef CONFIG_XARINA_SPL
#define CONFIG_SYS_RX_ETH_BUFFER       2
#endif
#ifdef CONFIG_XARINA_NOR_BOOT
#define CONFIG_DRIVER_SMSC9118
#define CONFIG_SMSC9118_BASE		0x28000000
#endif
/*
 * NS16550 Configuration
 */
#define CONFIG_PL011_SERIAL
#define CONFIG_PL011_CLOCK	3375000
#define CONFIG_PL01x_PORTS	{(void *)CONFIG_SYS_SERIAL0}
#define CONFIG_CONS_INDEX	0

#define CONFIG_BAUDRATE			38400
#define CONFIG_SYS_BAUDRATE_TABLE	{ 9600, 19200, 38400, 57600, 115200 }
#define CONFIG_SYS_SERIAL0		0x30007000
/*
 * Command line configuration.
 */

#ifdef CONFIG_XARINA_SPL
#ifdef CONFIG_XARINA_NETSPL
#define CONFIG_CMD_NET
#define CONFIG_CMD_PING
#define CONFIG_CMD_LOADB
#define CONFIG_CMD_RUN
#define CONFIG_CMD_DHCP
#else	/* CONFIG_XARINA_NETSPL */ 
#define CONFIG_CMD_NAND
#endif	/* CONFIG_XARINA_NETSPL */
#else	/* CONFIG_XARINA_SPL */

#define CONFIG_RBTREE
#define CONFIG_LZO

#define CONFIG_CMD_IMI
#define CONFIG_CMD_NET
#define CONFIG_CMD_PING
#define CONFIG_CMD_BDI
#define CONFIG_CMD_MEMORY
#define CONFIG_CMD_FLASH
#define CONFIG_CMD_SAVEENV
#define CONFIG_CMD_LOADB
#define CONFIG_CMD_LOADS
#define CONFIG_CMD_RUN
#define CONFIG_CMD_BOOTD
#define CONFIG_CMD_MISC
#define CONFIG_CMD_DHCP
#define CONFIG_CMD_I2C

#ifndef CONFIG_XARINA_NAND_NO_USE
#define CONFIG_FLASH_CFI_DRIVER
#define CONFIG_FLASH_CFI_MTD
#define CONFIG_CMD_NAND
#define CONFIG_MTD_DEVICE
#define CONFIG_MTD_PARTITIONS
#define CONFIG_CMD_UBIFS
#define CONFIG_CMD_MTDPARTS
#define CONFIG_CMD_UBI
#endif

/* #define CONFIG_CMD_SPI */
#endif	/* CONFIG_XARINA_SPL */


/*
 * BOOTP options
 */
#define CONFIG_BOOTP_BOOTPATH
#define CONFIG_BOOTP_GATEWAY
#define CONFIG_BOOTP_HOSTNAME
#define CONFIG_BOOTP_SUBNETMASK

#define CONFIG_BOOTDELAY	3
#define CONFIG_ZERO_BOOTDELAY_CHECK

/*
#define CONFIG_BOOTARGS		"root=/dev/nfs mem=128M ip=dhcp "\
				"netdev=25,0,0xf1010000,0xf1010010,eth0"
*/

/*
 * Static configuration when assigning fixed address
 */
/*
#define CONFIG_BOOTFILE		"/tftpboot/uImage" 
*/

/*
 * Miscellaneous configurable options
 */
#define CONFIG_SYS_LONGHELP	/* undef to save memory */
#define CONFIG_SYS_CBSIZE	256		/* Console I/O Buffer Size */

/* Monitor Command Prompt	 */
#ifdef CONFIG_XARINA_NETSPL
#define CONFIG_SYS_PROMPT	"XARINA NETSPL# "
#else
#define CONFIG_SYS_PROMPT	"XARINA# "
#endif	/* CONFIG_XARINA_NETSPL */

/* Print Buffer Size */
#define CONFIG_SYS_PBSIZE	\
			(CONFIG_SYS_CBSIZE + sizeof(CONFIG_SYS_PROMPT) + 16)
#define CONFIG_SYS_MAXARGS	16		/* max number of command args */
#define CONFIG_SYS_BARGSIZE	CONFIG_SYS_CBSIZE /* Boot Argument Buffer Size */

#ifndef	CONFIG_XARINA_SPL
#define CONFIG_SYS_LOAD_ADDR	0x60C00000	/* default load address */
#else	/* CONFIG_XARINA_SPL */
#define CONFIG_SYS_LOAD_ADDR	0x60B80000	/* default load address */
#endif	/* CONFIG_XARINA_SPL */
#define CONFIG_SYS_AUTOLOAD	"n"	/* xarina adds this line */

/*-----------------------------------------------------------------------
 * Stack sizes
 *
 * The stack sizes are set up in start.S using the settings below
 */
#define CONFIG_STACKSIZE	(128 * 1024)	/* regular stack */
#ifdef CONFIG_USE_IRQ
#define CONFIG_STACKSIZE_IRQ	(4 * 1024)	/* IRQ stack */
#define CONFIG_STACKSIZE_FIQ	(4 * 1024)	/* FIQ stack */
#endif

/*-----------------------------------------------------------------------
 * Physical Memory Map
 */
#define CONFIG_NR_DRAM_BANKS	1	/* we have 1 bank of DRAM */
#define PHYS_SDRAM_1		0x64000000	/* SDRAM Bank #1 */
#define PHYS_SDRAM_1_SIZE	0x02000000	/* 128 MB */
#ifdef CONFIG_XARINA_FPGA
#define PHYS_FLASH_SIZE		0x00080000	/* 512KB */
#endif /* CONFIG_XARINA_FPGA */
/*-----------------------------------------------------------------------
 * FLASH and environment organization
 */
/*
 * Use the CFI flash driver for ease of use
 */
#ifndef CONFIG_XARINA_SPL
#define CONFIG_SYS_FLASH_CFI
#define CONFIG_FLASH_CFI_DRIVER
#define CONFIG_FLASH_CFI_WIDTH	FLASH_CFI_16BIT

//#define CONFIG_ENV_IS_IN_FLASH	1
#ifndef CONFIG_XARINA_NAND_NO_USE
#define CONFIG_ENV_IS_IN_NAND
#else
#define CONFIG_ENV_IS_NOWHERE
#endif
#define CONFIG_SYS_FLASH_USE_BUFFER_WRITE	/* xarina adds this line */

/*
 * Note that CONFIG_SYS_MAX_FLASH_SECT allows for a parameter block
 * i.e.
 *	the bottom "sector" (bottom boot), or top "sector"
 *	(top boot), is a seperate erase region divided into
 *	4 (equal) smaller sectors. This, notionally, allows
 *	quicker erase/rewrire of the most frequently changed
 *	area......
 *	CONFIG_SYS_MAX_FLASH_SECT is padded up to a multiple of 4
 */

#define FLASH_SECTOR_SIZE		0x00020000	/* 128 KB sectors */
#define CONFIG_ENV_SECT_SIZE		FLASH_SECTOR_SIZE
#define CONFIG_SYS_MAX_FLASH_SECT	(512)

#define CONFIG_SYS_FLASH_BASE		0x20000000
#define CONFIG_SYS_MAX_FLASH_BANKS	1

#define CONFIG_SYS_MONITOR_LEN		(4 * CONFIG_ENV_SECT_SIZE)

/* The ARM Boot Monitor is shipped in the lowest sector of flash */

#define FLASH_TOP			(CONFIG_SYS_FLASH_BASE + PHYS_FLASH_SIZE)
#define CONFIG_ENV_SIZE			0x4000
#define CONFIG_ENV_ADDR			(FLASH_TOP - CONFIG_ENV_SECT_SIZE * 2)
//#define CONFIG_ENV_OFFSET		(CONFIG_ENV_ADDR - CONFIG_SYS_FLASH_BASE)
#define CONFIG_ENV_OFFSET		(0x012C0000)
#define CONFIG_ENV_OFFSET_REDUND	(0x01360000)
#define CONFIG_SYS_MONITOR_BASE		(CONFIG_ENV_ADDR - CONFIG_SYS_MONITOR_LEN)
//#define CONFIG_NAND_ENV_DST		(TEXT_BASE - CONFIG_SYS_MALLOC_LEN - CONFIG_ENV_SIZE)
#else	/* CONFIG_XARINA_SPL */

#define CONFIG_ENV_IS_NOWHERE
#define CONFIG_ENV_SIZE 512
#define CONFIG_SYS_NO_FLASH
#endif	/* CONFIG_XARINA_SPL */

/* #define CONFIG_SYS_FLASH_PROTECTION */	/* The devices have real protection */


/*-----------------------------------------------------------------------
 * ARM9
 */
#ifndef CONFIG_XARINA_SPL
/* nor flash area size  */
#define CFG_NOR_MONITOR_AREA_SIZE		(0x00080000)	/* U-Boot nor flash Area Size */

/* nor flash map */
#define CFG_NOR_MONITOR_ADDR	        (CONFIG_SYS_FLASH_BASE + 0x00000000)	/* u-boot area */

/* ARM9 F/W Boot */
#define CFG_ARM9FW_VECTOR_LOAD_ADDR	0xFFFF0000	/* vector program load address */
#define CFG_ARM9FW_FW_LOAD_ADDR		0x60008000	/* fw program load address */
#define CFG_ARM9FW_BOOT_RETRY		0		/* retry */
#define CFG_ARM9FW_BOOT_TIMEOUT		5		/* timeout second(s) */
#endif /* CONFIG_XARINA_SPL */

/*-----------------------------------------------------------------------
 * I2C
 */
#ifndef CONFIG_XARINA_SPL
#define CONFIG_I2C00_I2C				/* I2C00 driver enable */
#define CONFIG_HARD_I2C
#define CONFIG_I2C_MULTI_BUS
#define CONFIG_I2C_CMD_TREE
#define CONFIG_I2C00_CLOCK		(3.375)			/* MHz */
#define CONFIG_I2C00_DEFAULT_NUM	(0)			/* I2C00 #0 Use */
/* I2C speed and slave address */
#define CONFIG_SYS_I2C_SPEED		(100000)		/* 100KHz */
#define CONFIG_SYS_I2C_SLAVE		(0x00)
#else	/* CONFIG_XARINA_SPL */
#ifdef CONFIG_DDR_INIT_I2C_DATA_GET
#define CONFIG_I2C00_I2C				/* I2C00 driver enable */
#define CFG_I2C00_CLOCK		(3.375)			/* MHz */
#endif	/* CONFIG_DDR_INIT_I2C_DATA_GET*/
#endif	/* CONFIG_XARINA_SPL */


/*-----------------------------------------------------------------------
 * NAND
 */
#define CONFIG_SYS_NAND_BASE		(0x38006000)	/* EMC_SM2 Base Address */
#define CONFIG_SYS_MAX_NAND_DEVICE	1		/* treat it for 1 with 1 NAND chips */
#define NAND_MAX_CHIPS		1		/* physical nand chip num */
#define CFG_MAX_NAND_CHIP	1		/* treat it for 1 with 1 NAND chips */
/* #define CONFIG_MTD_NAND_VERIFY_WRITE */		/* verify enable after write */
#define CONFIG_EMC_SM2_ECC_4SYMBOL		/* 4symbol ecc */ /* When I use NAND, setting is required */
#define CONFIG_READ_OOB_HWECC_ENABLE		/* hwecc enable on nand_write_oob */
#define CONFIG_WRITE_OOB_HWECC_ENABLE		/* hwecc enable on nand_read_oob  */
/* #define CONFIG_EMC_SM2_CORRECT_TEST */		/* ecc correct test */

/* for NAND SPL */
#define CONFIG_SYS_NAND_PAGE_SIZE	(0x800)
#define CONFIG_SYS_NAND_PAGE_COUNT	(0x40)
#define CONFIG_SYS_NAND_ECCSIZE		(0x200)
#define CONFIG_SYS_NAND_ECCSTEPS	(CONFIG_SYS_NAND_PAGE_SIZE / CONFIG_SYS_NAND_ECCSIZE)
#define CONFIG_SYS_NAND_BLOCK_SIZE	(CONFIG_SYS_NAND_PAGE_SIZE * CONFIG_SYS_NAND_PAGE_COUNT)
#define CONFIG_SYS_NAND_U_BOOT_DST	(0x60B80000)
#define CONFIG_SYS_NAND_U_BOOT_START	(CONFIG_SYS_NAND_U_BOOT_DST)
#define CONFIG_XARINA_U_BOOT_BIN_START	(0x40)
#define CONFIG_XARINA_U_BOOT_BIN_LEN	(0x56)
#define CONFIG_XARINA_NAND_OOB_SIZE	(0x20)

/*-----------------------------------------------------------------------
 * SPL
 */
#ifdef CONFIG_XARINA_SPL
#define CONFIG_SPL_WORK_AREA_TOP          0x60B80000	/* spl work area top - sysram only */
#define CONFIG_DEFAULT_UBOOT_LOAD_ADDR    0x60B80000
#endif /* CONFIG_XARINA_SPL */

/*-----------------------------------------------------------------------
 * Xarina parameter
 */
#define CONFIG_XARINA_UBI_PART			"ubifs"
#define CONFIG_XARINA_UBI_VOLUME		"ubootfs"
#define CONFIG_XARINA_ENV_UBI_PART		"u-boot_ubi_part"
#define CONFIG_XARINA_ENV_UBI_VOLUME		"u-boot_ubi_volume"
#define CONFIG_XARINA_ENV_ROOTFS_UBI_PART	"rootfs_ubi_part"
#define CONFIG_XARINA_ENV_ROOTFS_UBI_VOLUME	"rootfs_ubi_volume"
#define CONFIG_XARINA_ENV_COREFW_COMM_PARAM	"corefw_comm_param"
#define CONFIG_XARINA_ENV_CAMFW_SETTING_PARAM	"camfw_setting_param"
#define CONFIG_XARINA_ENV_CAMFW_SETTING_PARAM_D	"camfw_setting_param_default"
#define CONFIG_XARINA_ENV_CAMFW_BLEMISH_DATA	"camfw_blemish_data"
#define CONFIG_XARINA_ENV_CAMFW_SHADING_DATA	"camfw_shading_data"
#define CONFIG_XARINA_ENV_COREFW_BIN		"corefw_bin"
#define CONFIG_XARINA_ENV_OSD_COLOR_PALETTE	"osd_color_palette"
#define CONFIG_XARINA_ENV_OSD_DATA		"osd_data"
#define CONFIG_XARINA_ENV_MASK_DATA		"mask_data"
#define CONFIG_XARINA_ENV_KERNEL_IMAGE		"kernel_image"
#define CONFIG_XARINA_ENV_VIDEOOUT_DEV		"vout_dev"
#define CONFIG_XARINA_COREFW_COMM_PARAM_SIZE	(0xFE0)
#define CONFIG_XARINA_COREFW_BOOT_INFO_ADDR	(0x60000000)	/* corefw boot infomation address */
#define CONFIG_XARINA_COREFW_BIN_MAX_SIZE	(0x00178000)
#define CONFIG_XARINA_COREFW_BOOT_RETRY		(0)
#define CONFIG_XARINA_PARAM_DATA_MAX_SIZE	(0x00100000)


/*-----------------------------------------------------------------------
 * Xarina update
 */
#define CONFIG_XARINA_NAND_PART_SPL_START	(0x00000000)
#define CONFIG_XARINA_NAND_PART_SPL_END		(0x007fffff)
#define CONFIG_XARINA_NAND_PART_UBOOT_START	(0x00800000)
#define CONFIG_XARINA_NAND_PART_UBOOT_END	(0x012Bffff)

/*-----------------------------------------------------------------------
 * SPI
 */
#ifdef CONFIG_XARINA_FPGA
#define CONFIG_SPI_CLOCK	13500000
#else
#define CONFIG_SPI_CLOCK	50000000
#endif
/*-----------------------------------------------------------------------
 * etc
 */


#define CONFIG_XARINA_USE_RGMII

#define CONFIG_FOR_DEVELOPMENT


#endif	/* __CONFIG_H */
