/*
 * (C) Copyright 2003
 * Texas Instruments.
 * Kshitij Gupta <kshitij@ti.com>
 * Configuation settings for the TI OMAP Innovator board.
 *
 * (C) Copyright 2004
 * ARM Ltd.
 * Philippe Robin, <philippe.robin@arm.com>
 *
 * (C) Copyright 2007, 2011 Sony Corporation.
 * Configuration for Xarina.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef __CONFIG_H
#define __CONFIG_H
/*
 * High Level Configuration Options
 * (easy to change)
 */
#include <xarina_config.h>
#define CONFIG_ARM1176	1	/* This is an arm1176 CPU core */
#define CONFIG_XARINA	1	/* in Xarina Platform Board	*/
#define CONFIG_XARINA_EVBRD	1
#define CONFIG_ARCH_XARINA	1	/* Specifically, a xarina	*/
#define CONFIG_XARINA_VSS 1

#define CONFIG_SYS_MEMTEST_START	0x60C00000
#define CONFIG_SYS_MEMTEST_END		0x63FFFFFF

#ifdef CONFIG_XARINA_EVBRD_PRE
#define CONFIG_SYS_HZ			(1687500 >> 4)
#else
#define CONFIG_SYS_HZ			(6250000 >> 4)
#endif
#define CONFIG_SYS_TIMERBASE		0x30009000	/* Dual-Timer(SP804) base address */


#define CONFIG_SP805_RESET_COUNT   	0x0001869F      /* 100ms   0x1869F(100ms load value/MHz)  */

#ifndef CONFIG_XARINA_SPL
#define CONFIG_CMDLINE_TAG		1	/* enable passing of ATAGs */
#define CONFIG_SETUP_MEMORY_TAGS	1
#define CONFIG_INITRD_TAG		1	/* add this line */
#define CONFIG_MISC_INIT_R		1
#endif /* CONFIG_XARINA_SPL */

/*
 * Size of malloc() pool
 */
#ifdef CONFIG_XARINA_DDR_TEST
#define CONFIG_SYS_MALLOC_LEN		(2 * 1024)
#else
#define CONFIG_SYS_MALLOC_LEN		(7680 * 1024)
#endif

/* size in bytes reserved for initial data */
#define CONFIG_SYS_GBL_DATA_SIZE	128

/*
 * Hardware drivers
 */

#define CONFIG_NET_MULTI
#define CONFIG_SMAC
#ifdef CONFIG_XARINA_SPL
#define CONFIG_SYS_RX_ETH_BUFFER       2
#endif
/*
 * NS16550 Configuration
 */
#define CONFIG_PL011_SERIAL
#ifdef CONFIG_XARINA_EVBRD_PRE
#define CONFIG_PL011_CLOCK	3375000
#else
#define CONFIG_PL011_CLOCK	12500000
#endif

#define CONFIG_PL01x_PORTS	{(void *)CONFIG_SYS_SERIAL0}
#define CONFIG_CONS_INDEX	0

#define CONFIG_BAUDRATE			115200
#define CONFIG_SYS_BAUDRATE_TABLE	{ 9600, 19200, 38400, 57600, 115200 }
#define CONFIG_SYS_SERIAL0		0x30007000
/*
 * Command line configuration.
 */

#ifdef CONFIG_XARINA_SPL
#ifdef CONFIG_XARINA_NETSPL
#define CONFIG_CMD_NET
#define CONFIG_CMD_PING
#define CONFIG_CMD_LOADB
#define CONFIG_CMD_RUN
#define CONFIG_CMD_DHCP
#endif

#ifdef CONFIG_NAND_SPL
#define CONFIG_CMD_NAND
#endif

#ifdef CONFIG_XARINA_SDSPL
#define CONFIG_GENERIC_MMC
#define CONFIG_CMD_MMC
#define CONFIG_MMC
#define CONFIG_DOS_PARTITION
#define CONFIG_CMD_FAT
#endif

#else	/* CONFIG_XARINA_SPL */

#define CONFIG_MTD_DEVICE
#define CONFIG_MTD_PARTITIONS
#define CONFIG_CMD_UBIFS
#define CONFIG_CMD_MTDPARTS
#define CONFIG_RBTREE
#define CONFIG_LZO
#define CONFIG_CMD_UBI
#define CONFIG_CMD_IMI
#define CONFIG_CMD_NET
#define CONFIG_CMD_PING
#define CONFIG_CMD_BDI
#define CONFIG_CMD_MEMORY
#define CONFIG_CMD_SAVEENV
#define CONFIG_CMD_LOADB
#define CONFIG_CMD_LOADS
#define CONFIG_CMD_RUN
#define CONFIG_CMD_BOOTD
#define CONFIG_CMD_MISC
#define CONFIG_CMD_DHCP
#define CONFIG_CMD_I2C
#define CONFIG_CMD_NAND
#define CONFIG_GENERIC_MMC
#define CONFIG_CMD_MMC
#define CONFIG_MMC
#define CONFIG_DOS_PARTITION
#define CONFIG_CMD_FAT
#define CONFIG_CMD_EEPROM

/* #define CONFIG_CMD_SPI */
#endif	/* CONFIG_XARINA_SPL */


/*
 * BOOTP options
 */
#define CONFIG_BOOTP_BOOTPATH
#define CONFIG_BOOTP_GATEWAY
#define CONFIG_BOOTP_HOSTNAME
#define CONFIG_BOOTP_SUBNETMASK

#define CONFIG_BOOTDELAY	3
#define CONFIG_ZERO_BOOTDELAY_CHECK

/*
 * Miscellaneous configurable options
 */
#define CONFIG_SYS_LONGHELP	/* undef to save memory */
#define CONFIG_SYS_CBSIZE	512		/* Console I/O Buffer Size */

/* Monitor Command Prompt	 */
#ifdef CONFIG_XARINA_NETSPL
#define CONFIG_SYS_PROMPT	"XARINA NETSPL# "
#endif
#ifdef CONFIG_XARINA_SDSPL
#define CONFIG_SYS_PROMPT	"XARINA SDSPL# "
#endif
#ifndef CONFIG_XARINA_SPL
#define CONFIG_SYS_PROMPT	"XARINA# "
#endif


/* Print Buffer Size */
#define CONFIG_SYS_PBSIZE	\
			(CONFIG_SYS_CBSIZE + sizeof(CONFIG_SYS_PROMPT) + 16)
#define CONFIG_SYS_MAXARGS	16		/* max number of command args */
#define CONFIG_SYS_BARGSIZE	CONFIG_SYS_CBSIZE /* Boot Argument Buffer Size */

#ifndef	CONFIG_XARINA_SPL
#define CONFIG_SYS_LOAD_ADDR	0x60C00000	/* default load address */
#else	/* CONFIG_XARINA_SPL */
#define CONFIG_SYS_LOAD_ADDR	0x60B80000	/* default load address */
#endif	/* CONFIG_XARINA_SPL */
#define CONFIG_SYS_AUTOLOAD	"n"

/*-----------------------------------------------------------------------
 * Stack sizes
 *
 * The stack sizes are set up in start.S using the settings below
 */
#define CONFIG_STACKSIZE	(128 * 1024)	/* regular stack */
#ifdef CONFIG_USE_IRQ
#define CONFIG_STACKSIZE_IRQ	(4 * 1024)	/* IRQ stack */
#define CONFIG_STACKSIZE_FIQ	(4 * 1024)	/* FIQ stack */
#endif

/*-----------------------------------------------------------------------
 * Physical Memory Map
 */
#define CONFIG_NR_DRAM_BANKS	1	/* we have 1 bank of DRAM */
#define PHYS_SDRAM_1			0x64000000	/* SDRAM Bank #1 */
#define PHYS_SDRAM_1_SIZE		0x02000000	/* 32 MB */
#define PHYS_SDRAM_1_2G			0x68000000	/* SDRAM Bank #1 */
#define PHYS_SDRAM_1_SIZE_2G		0x08000000	/* 128 MB */

/*-----------------------------------------------------------------------
 * DDR Memory
 */
#define CONFIG_XARINA_ENV_DDR_NUM	"ddr_num"

/*-----------------------------------------------------------------------
 * NOR Flash
 */
#define CONFIG_SYS_NO_FLASH	/* Xarina has no nor flash */

/*-----------------------------------------------------------------------
 * Environment organization
 */
#ifndef CONFIG_XARINA_SPL

#define CONFIG_ENV_IS_IN_NAND
#define CONFIG_ENV_SIZE				0x4000
#define CONFIG_ENV_OFFSET
#define CONFIG_ENV_OFFSET_REDUND
#define CONFIG_ENV_RANGE
#define CONFIG_XARINA_NAND1_ENV_RANGE		(0x80000)
#define CONFIG_XARINA_NAND1_ENV_OFFSET		(0x01300000)
#define CONFIG_XARINA_NAND1_ENV_OFFSET_REDUND	(0x01380000)
#define CONFIG_XARINA_NAND2_ENV_RANGE		(0x100000)
#define CONFIG_XARINA_NAND2_ENV_OFFSET		(0x01A00000)
#define CONFIG_XARINA_NAND2_ENV_OFFSET_REDUND	(0x01B00000)
#else	/* CONFIG_XARINA_SPL */
#define CONFIG_ENV_IS_NOWHERE
#define CONFIG_ENV_SIZE 0x1000
#endif	/* CONFIG_XARINA_SPL */

/*-----------------------------------------------------------------------
 * CoreFW
 */
#ifndef CONFIG_XARINA_SPL

/* CoreFW Boot */
#define CONFIG_COREFW_BOOT_RETRY		0		/* retry */
#define CONFIG_COREFW_BOOT_TIMEOUT		5		/* timeout second(s) */
#endif /* CONFIG_XARINA_SPL */

/*-----------------------------------------------------------------------
 * I2C
 */
#ifndef CONFIG_XARINA_SPL
#define CONFIG_I2C00_I2C				/* I2C00 driver enable */
#define CONFIG_HARD_I2C
#define CONFIG_I2C_MULTI_BUS
#define CONFIG_I2C_CMD_TREE
#define CONFIG_I2C00_DEFAULT_NUM	(1)			/* I2C00 #1 Use */
/* I2C speed and slave address */
#define CONFIG_SYS_I2C_SPEED		(100000)		/* 100KHz */
#define CONFIG_SYS_I2C_SLAVE		(0x00)

/* EEPROM */
#define CONFIG_SYS_I2C_EEPROM_ADDR	0x50
#define CONFIG_SYS_I2C_EEPROM_ADDR_LEN 2
#define CONFIG_SYS_EEPROM_PAGE_WRITE_BITS 4
#define CONFIG_SYS_EEPROM_PAGE_WRITE_DELAY_MS 10

#endif

#ifdef CONFIG_XARINA_EVBRD_PRE
#define CONFIG_I2C00_CLOCK		(3.375)			/* MHz */
#else
#define CONFIG_I2C00_CLOCK		(12.5)			/* MHz */
#endif


/*-----------------------------------------------------------------------
 * NAND
 */
#define CONFIG_SYS_NAND_BASE		(0x38006000)
#define CONFIG_SYS_MAX_NAND_DEVICE	1		/* treat it for 1 with 1 NAND chips */
/*-----------------------------------------------------------------------
 * SPL
 */
#ifdef CONFIG_XARINA_SPL
#ifdef CONFIG_XARINA_DDR_TEST
#define CONFIG_SPL_WORK_AREA_TOP   	      0x5300F000
#else
#define CONFIG_SPL_WORK_AREA_TOP          0x60B80000	/* spl work area top - sysram only */
#endif
#define CONFIG_DEFAULT_UBOOT_LOAD_ADDR    0x60B80000
#endif /* CONFIG_XARINA_SPL */

/*-----------------------------------------------------------------------
 * Xarina parameter
 */
#define CONFIG_XARINA_UBI_PART			"ubifs"
#define CONFIG_XARINA_UBI_VOLUME		"ubootfs"
#define CONFIG_XARINA_ENV_UBI_PART		"u-boot_ubi_part"
#define CONFIG_XARINA_ENV_UBI_VOLUME		"u-boot_ubi_volume"
#define CONFIG_XARINA_ENV_ROOTFS_UBI_PART	"rootfs_ubi_part"
#define CONFIG_XARINA_ENV_ROOTFS_UBI_VOLUME	"rootfs_ubi_volume"
#define CONFIG_XARINA_ENV_COREFW_COMM_PARAM	"corefw_comm_param"
#define CONFIG_XARINA_ENV_COREFW_COMM_PARAM_D	"corefw_comm_param_default"
#define CONFIG_XARINA_ENV_CAMFW_SETTING_PARAM	"camfw_setting_param"
#define CONFIG_XARINA_ENV_CAMFW_SETTING_PARAM_D	"camfw_setting_param_default"
#define CONFIG_XARINA_ENV_CAMFW_DEFECT_DATA	"camfw_defect_data"
#define CONFIG_XARINA_ENV_CAMFW_SHADING_DATA	"camfw_shading_data"
#define CONFIG_XARINA_ENV_COREFW_BIN		"corefw_bin"
#define CONFIG_XARINA_ENV_SENSFW_BIN		"sensfw_bin"
#define CONFIG_XARINA_ENV_OSD_COLOR_PALETTE	"osd_color_palette"
#define CONFIG_XARINA_ENV_OSD_DATA		"osd_data"
#define CONFIG_XARINA_ENV_MASK_DATA		"mask_data"
#define CONFIG_XARINA_ENV_KERNEL_IMAGE		"kernel_image"
#define CONFIG_XARINA_ENV_VIDEOOUT_DEV		"vout_dev"
#define CONFIG_XARINA_ENV_VIDEOIN_DEV		"vin_dev"
#define CONFIG_XARINA_ENV_PINUMX_IOEX_USE	"pinmux_ioex"
#define CONFIG_XARINA_ENV_UPDATE_MMC_FILE_NAME  "update_mmc_filename"
#define CONFIG_XARINA_COREFW_BOOT_INFO_ADDR	(0x60000000)	/* corefw boot infomation address */
#define CONFIG_XARINA_COREFW_BIN_MAX_SIZE	(0x00178000)
#define CONFIG_XARINA_COREFW_BOOT_RETRY		(0)
#define CONFIG_XARINA_PARAM_DATA_MAX_SIZE	(0x00100000)


/*-----------------------------------------------------------------------
 * Xarina update
 */
#define CONFIG_XARINA_NAND1_PART_SPL_START	(0x00000000)
#define CONFIG_XARINA_NAND1_PART_SPL_END	(0x007fffff)
#define CONFIG_XARINA_NAND1_PART_UBOOT_START	(0x00800000)
#define CONFIG_XARINA_NAND1_PART_UBOOT_END	(0x012fffff)
#define CONFIG_XARINA_NAND2_PART_SPL_START	(0x00000000)
#define CONFIG_XARINA_NAND2_PART_SPL_END	(0x00ffffff)
#define CONFIG_XARINA_NAND2_PART_UBOOT_START	(0x01000000)
#define CONFIG_XARINA_NAND2_PART_UBOOT_END	(0x019fffff)

/*-----------------------------------------------------------------------
 * SPI
 */
#ifdef CONFIG_XARINA_EVBRD_PRE
#define CONFIG_SPI_CLOCK	13500000
#else
#define CONFIG_SPI_CLOCK	50000000
#endif

/*-----------------------------------------------------------------------
 * NANDSPL
 */
#ifdef CONFIG_NAND_SPL
#define CONFIG_SYS_NAND_U_BOOT_DST	(0x60B80000)
#define CONFIG_SYS_NAND_U_BOOT_START	(CONFIG_SYS_NAND_U_BOOT_DST)
#define CONFIG_XARINA_U_BOOT_BIN_START	(0x40)
#define CONFIG_XARINA_NAND1_U_BOOT_BIN_LEN	(0x58)
#define CONFIG_XARINA_NAND2_U_BOOT_BIN_LEN	(0x28)
#endif

/*-----------------------------------------------------------------------
 * SDSPL
 */
#ifdef CONFIG_XARINA_SDSPL
#define CONFIG_XARINA_SDSPL_UBOOT_DIR	"/sd_boot/u-boot"
#define CONFIG_XARINA_SDSPL_UBOOT_HEAD	"u-boot"
#define CONFIG_XARINA_SDSPL_UBOOT_EXT	"bin"
#endif /* CONFIG_XARINA_SDSPL */

/*-----------------------------------------------------------------------
 * SD BOOT
 */
#define CONFIG_XARINA_SD_BOOTSCRIPT_DIR		"/sd_boot/script"
#define CONFIG_XARINA_SD_BOOTSCRIPT_HEAD	"u-boot"
#define CONFIG_XARINA_SD_BOOTSCRIPT_EXT		"ush"
#define CONFIG_XARINA_SD_BOOTSCRIPT_LOAD_ADDR	(0x60298000)
#define CONFIG_XARINA_SD_BOOTSCRIPT_MAX_SIZE	(0x00100000)


/*-----------------------------------------------------------------------
 * etc
 */

#define CONFIG_IDENT_STRING		" Xarina"
#define CONFIG_FOR_DEVELOPMENT
#define CONFIG_AUTO_COMPLETE
#define CONFIG_SYS_HUSH_PARSER
#define CONFIG_SYS_PROMPT_HUSH_PS2      "> "

#define CONFIG_XARINA_TEST_BENCH
#define CONFIG_POSTEDWRITE_WORKAROUND
#define CONFIG_XARINA_DDR_ODT_OFF
/* #define CONFIG_XARINA_DDR_I2C_DATA_GET */

/* -------------------------------------
 * Xarina Web Update
 *--------------------------------------
 */
/* #define CONFIG_XARINA_WEB_UPDATE */
#define CONFIG_XARINA_WEB_UPDATE_INDICATOR	"web_update_indicator"
#define CONFIG_XARINA_ENV_STREAM_UBI_PART	"streaming_ubi_part"
#define CONFIG_XARINA_ENV_STREAM_UBI_VOLUME	"streaming_ubi_volume"
#define CONFIG_XARINA_WEB_UPDATE_FOLDER "web_update/"
#define CONFIG_XARINA_WEB_UPDATE_NANDSPL_FILE_NAME	"web_update/update_img_nand_spl.bin"
#define CONFIG_XARINA_WEB_UPDATE_UBOOT_FILE_NAME	"web_update/update_img_uboot.bin"
#define CONFIG_XARINA_WEB_UPDATE_FW_FILE_NAME	"web_update/update_img_fw.img"
#define CONFIG_XARINA_WEB_UPDATE_ROOTFS_FILE_NAME	"web_update/update_img_rootfs.img"

#endif	/* __CONFIG_H */
